﻿;||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||;			
;|																															|;	
;| Title:				UB2D - 004_Sprite																|;
;| Copyright: 	UnionBytes																			|;
;|																															|;
;| Date:				07.11.2018																			|;
;|																															|;
;||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||;


;- Engine
XIncludeFile "Includes\UB2D.pbi" 
If Not InitUnionBytes2DEngine(#UB2D_ENGINE_DEBUG)
	Debug "UB2D initialization failed!"
	End
EndIf

UB2D_OpenScreen(1280, 720, 32, "Union Bytes 2D Engine - Sprites", #PB_Window_ScreenCentered|#PB_Window_SystemMenu, #False)


;- Textures
; Loading the texture for the sprite. UB2D needs textures, because the UB2D use a material
; system, even for sprites. This gives us the possibility to add shaders later on.
UB2D_LoadTexture(0, "Data\Sprites\UB2D.jpg")


;- Materials
; Creating of a material, with the default sprite shader and the texture 0.
UB2D_CreateMaterial(0, UB2D_DefaultShaderID(#UB2D_SHADER_SPR_DEFAULT), 0)


;- Sprites
; Creating of a sprite, with the material 0 and a origin in the middle and resize it.
UB2D_CreateSprite(0, 0, 0.5, 0.5)
UB2D_ZoomSprite(0, 512, 512)


;- Main Loop
Repeat
	
	; Normal pure basic window event handling.
	Repeat
		Select UB2D_WindowEvent()
			Case #PB_Event_CloseWindow
				Break 2
			Case #PB_Event_None
				Break
		EndSelect 
	ForEver
	
	; Update of the control functions.
	UB2D_ExamineKeyboard()
	
	; SetUp of the render target. In this case the final frame buffer.
	UB2D_BindFrameBuffer(#UB2D_FRAMEBUFFER_FINAL, #True, #True)
	
	; Rotate the sprite.
	UB2D_RotateSprite(0, 15.0*UB2D_TimeFactor())

	; Draw the sprite in the middle of the screen.
	UB2D_DisplaySprite(0, UB2D_ScreenWidth()*0.5, UB2D_ScreenHeight()*0.5)
	
	; Flip the buffers and draw it on the window.
	UB2D_FlipBuffers()
	
	; F12 makes a screenshot
	If UB2D_KeyboardReleased(#UB2D_KEY_F12)
		UB2D_ScreenShot("004_Sprites.jpg")
	EndIf
	
ForEver

; Free the engine and all its resources.
UB2D_Free()
End

; IDE Options = PureBasic 5.62 (Windows - x64)
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 719
; EnableBuildCount = 0