﻿CompilerIf #PB_Compiler_Processor <> #PB_Processor_x86
	CompilerError "Only x86 (32-bit) is supported!"
CompilerEndIf

;<Library Constants>

;- Constants: Engine
#UB2D_ENGINE_RELEASE 												= 0
#UB2D_ENGINE_DEBUG 													= 1

#UB2D_ALL																		= -1
#UB2D_ANY																		= -1
#UB2D_DEFAULT																= -1
#UB2D_GLOBAL																= -2
#UB2D_IGNORE																= -$FFFF
#UB2D_NONE																	= 0
#UB2D_SIMILAR																= -1
#UB2D_FAIL																	= 0
#UB2D_OK																		= 1
#UB2D_OFF																		= 0
#UB2D_ON																		= 1
#UB2D_MAXNUM 																= $FFFF
#UB2D_NONUM  																= ~#UB2D_MAXNUM

#UB2D_AREA_START														= 0
#UB2D_AREA_END															= 1

#UB2D_NONE																	= 0
#UB2D_CAMERA																= 1
#UB2D_SHADER																= 2
#UB2D_TEXTURE																= 3
#UB2D_MATERIAL															= 4
#UB2D_GROUP																	= 5
#UB2D_OBJECT																= 6
#UB2D_OBJECTINSTANCE												= 7
#UB2D_MESH																	= 8
#UB2D_MESHINSTANCE													= 9
#UB2D_ARMATURE															= 10
#UB2D_BONE																	= 11
#UB2D_LIGHT																	= 12
#UB2D_GUI																		= 13
#UB2D_FONT																	= 14
#UB2D_SPRITE																= 15

#UB2D_HALF																	=	1.0 / 2.0
#UB2D_THIRD  																= 1.0 / 3.0
#UB2D_FOURTH 																= 1.0 / 4.0
#UB2D_FIFTH										 							= 1.0 / 5.0
#UB2D_SIXTH	 																= 1.0 / 6.0

EnumerationBinary 1
	#UB2D_CPU_SSE
	#UB2D_CPU_SSE2
	#UB2D_CPU_SSE3
	#UB2D_CPU_SSSE3
EndEnumeration


;- Constants: Engine - Attatchment

#UB2D_ATTACH_DEFAULT                         = -1
#UB2D_ATTACH_NONE                            = %000
#UB2D_ATTACH_POSITION                        = %001
#UB2D_ATTACH_ROTATION                        = %010
#UB2D_ATTACH_SCALING                         = %100
#UB2D_ATTACH_ALL                             = #UB2D_ATTACH_POSITION|#UB2D_ATTACH_ROTATION|#UB2D_ATTACH_SCALING
#UB2D_ATTACH_NOSCALING                       = #UB2D_ATTACH_POSITION|#UB2D_ATTACH_ROTATION


;- Constants: Units

#UB2D_BOOL																	= 0
#UB2D_LONG																	= 1
#UB2D_SAMPLER																= 2
#UB2D_INTEGER																= 3
#UB2D_FLOAT																	= 4
#UB2D_VECTOR2f															= 5
#UB2D_VECTOR3f															= 6
#UB2D_VECTOR4f															= 7
#UB2D_MATRIX3f															= 8
#UB2D_MATRIX4f															= 9

#UB2D_R																			= 0
#UB2D_G																			= 1
#UB2D_B																			= 2
#UB2D_A																			= 3

#UB2D_X																			= 0
#UB2D_Y																			= 1
#UB2D_Z																			= 2
#UB2D_W																			= 3

#UB2D_U																			= 0
#UB2D_S																			= 0
#UB2D_V																			= 1
#UB2D_T																			= 1

#UB2D_ABSOLUTE															= %000
#UB2D_RELATIVE															= %001

#UB2D_PARENT 																= %000
#UB2D_LOCAL 																= %010
#UB2D_WORLD 																= %100


;- Constants: XML

#UB2D_XML_FILE															= 0
#UB2D_XML_STRING														= 1


;- Constants: Math

#UB2D_MATH_STACKSIZE 												= 128

#UB2D_DEGREE                 								= 0
#UB2D_RADIAN                 								= 1

#UB2D_TORAD																	=  #PI/180
#UB2D_TODEG																	=  180/#PI
#UB2D_FLOATMAX                              =  3.4028234663852886e38
#UB2D_FLOATMIN                              = -3.4028234663852886e38


;- Constants: FrameBuffer

#UB2D_FRAMEBUFFER_TEXTURE_DEPTH             				= 0
#UB2D_FRAMEBUFFER_TEXTURE_GBUFFER           				= 1
#UB2D_FRAMEBUFFER_TEXTURE_FORWARDRENDERING   				= 2
#UB2D_FRAMEBUFFER_TEXTURE_POSTPROCESSING_FULL  			= 3
#UB2D_FRAMEBUFFER_TEXTURE_POSTPROCESSING_HALF  			= 4
#UB2D_FRAMEBUFFER_TEXTURE_POSTPROCESSING_QUARTER   	= 5
#UB2D_FRAMEBUFFER_TEXTURE_COMBINED           				= 6
#UB2D_FRAMEBUFFER_TEXTURE_FINAL          						= 7

#UB2D_FRAMEBUFFER_GBUFFER                   				= 0
#UB2D_FRAMEBUFFER_FORWARDRENDERING          				= 1
#UB2D_FRAMEBUFFER_POSTPROCESSING_FULL            		= 2
#UB2D_FRAMEBUFFER_POSTPROCESSING_HALF            		= 3
#UB2D_FRAMEBUFFER_POSTPROCESSING_QUARTER           	= 4
#UB2D_FRAMEBUFFER_COMBINED           								= 5
#UB2D_FRAMEBUFFER_FINAL                     				= 6

#UB2D_GBUFFER																				= 6
#UB2D_GBUFFER_POSITION															= 0
#UB2D_GBUFFER_NORMAL																= 1
#UB2D_GBUFFER_DIFFUSE																= 2
#UB2D_GBUFFER_SPECULAR	  													= 3
#UB2D_GBUFFER_MISC			  													= 4
#UB2D_GBUFFER_DEPTH      														= 5


;- Constants: Camera

#UB2D_PROJECTIONMODE_3D_ORTHOGRAPHIC				= 0
#UB2D_PROJECTIONMODE_3D_PERSPECTIVE					= 1
#UB2D_PROJECTIONMODE_2D											= 2


;- Constants: Light

#UB2D_LIGHT_INSTANCES							  				= 512

#UB2D_LIGHT_DIRECT													= 0
#UB2D_LIGHT_POINT														= 1
#UB2D_LIGHT_SPOT														= 2

#UB2D_LIGHT_OFF															= %000	; 0
#UB2D_LIGHT_ON															= %001	; 1

#UB2D_LIGHT_NONE_SHADOW											= %000	; 1 
#UB2D_LIGHT_STATIC_SHADOW										= %010	; 3 
#UB2D_LIGHT_DYNAMIC_SHADOW									= %100	; 5 


;- Constants: Textures

#UB2D_TEXTURE_TYPE_STANDARD									= $0DE1
#UB2D_TEXTURE_TYPE_ARRAY										= $8C1A

#UB2D_TEXTURE_FILTER_NONE										= $2600
#UB2D_TEXTURE_FILTER_LINEAR									= $2601


;- Constants: Mesh

#UB2D_ALIGNMENTPOINT_CENTER									= 0
#UB2D_ALIGNMENTPOINT_CORNER									= 1


;- Constants: Shader

#UB2D_SHADER_UNIFORMBUFFER_MATRICES 				= 0
#UB2D_SHADER_UNIFORMBUFFER_MODEL						= 1
#UB2D_SHADER_UNIFORMBUFFER_MATERIAL					= 2
#UB2D_SHADER_UNIFORMBUFFER_LIGHT						= 3
#UB2D_SHADER_UNIFORMBUFFER_MISC							= 4
#UB2D_SHADER_UNIFORMBUFFER_KERNEL						= 5

#UB2D_KERNELSIZE														= 32

#UB2D_SHADER_SCR														= 0
#UB2D_SHADER_GUI														= 1
#UB2D_SHADER_2D															= 2
#UB2D_SHADER_SPR														= 3
#UB2D_SHADER_OBJ														= 4
#UB2D_SHADER_3D															= 5
#UB2D_SHADER_PAR														= 6

#UB2D_SHADER_USER                      		  = 0
#UB2D_SHADER_DEFAULT                        = 1

Enumeration #UB2D_SHADER_DEFAULT
	#UB2D_SHADER_SCR_DEFAULT
	#UB2D_SHADER_SCR_DIRECTLIGHT
	#UB2D_SHADER_SCR_POINTLIGHT
	#UB2D_SHADER_SCR_VOLUMETRICPOINTLIGHT
	#UB2D_SHADER_SCR_SPOTLIGHT
	#UB2D_SHADER_SCR_VOLUMETRICSPOTLIGHT
	#UB2D_SHADER_SCR_SSAO	
	#UB2D_SHADER_SCR_BLUR
	
	#UB2D_SHADER_SCR_SCENECOMPOSER
	
	#UB2D_SHADER_SCR_GLOWBLOOMLENS
	#UB2D_SHADER_SCR_LENSFLARE
	
	#UB2D_SHADER_SCR_FINAL
	#UB2D_SHADER_SCR_PARTICLEDIRECTLIGHT
	#UB2D_SHADER_SCR_PARTICLEPOINTLIGHT
	
	#UB2D_SHADER_GUI_DEFAULT
	#UB2D_SHADER_GUI_BLUR
		
	#UB2D_SHADER_2D_DRAWING

	#UB2D_SHADER_SPR_DEFAULT
	#UB2D_SHADER_SPR_DEFAULT_TA
	#UB2D_SHADER_SPR_BLUR
	
	#UB2D_SHADER_OBJ_PBR
	#UB2D_SHADER_OBJ_PBR_TA
	#UB2D_SHADER_OBJ_PBR_TA_BLEND
	
	#UB2D_SHADER_3D_PBR
	#UB2D_SHADER_3D_PBR_SKELETAL
	
	#UB2D_SHADER_PAR_DEFAULT	
	#UB2D_SHADER_PAR_SMOKE	
EndEnumeration


;- Constants: BlendMode

#UB2D_BLENDMODE_ZERO              					= 0
#UB2D_BLENDMODE_ONE                     		= 1
#UB2D_BLENDMODE_SRC_COLOR                		= $0300
#UB2D_BLENDMODE_ONE_MINUS_SRC_COLOR      		= $0301
#UB2D_BLENDMODE_SRC_ALPHA               		= $0302
#UB2D_BLENDMODE_ONE_MINUS_SRC_ALPHA      		= $0303
#UB2D_BLENDMODE_DST_ALPHA                		= $0304
#UB2D_BLENDMODE_ONE_MINUS_DST_ALPHA      		= $0305
#UB2D_BLENDMODE_DST_COLOR                		= $0306
#UB2D_BLENDMODE_ONE_MINUS_DST_COLOR      		= $0307
#UB2D_BLENDMODE_SRC_ALPHA_SATURATE      		= $0308


;- Constants: Font

#UB2D_FONT_MAGICNUMBER 											= $7C30342E317C8354
#UB2D_FONT_TRANSLATIONZ 										= 400.0

#UB2D_FONT_CHUNK_END 												= 0
#UB2D_FONT_CHUNK_IMAGE											= 1
#UB2D_FONT_CHUNK_CHARACTERS									= 2
#UB2D_FONT_CHUNK_KERNINGPAIRS								= 3
#UB2D_FONT_CHUNK_FONT												= 4

#UB2D_FONT_ALIGNMENT_LEFT 									= 0.0
#UB2D_FONT_ALIGNMENT_CENTER 								= 0.5
#UB2D_FONT_ALIGNMENT_RIGHT 									= 1.0
#UB2D_FONT_ALIGNMENT_TOP 										= 0.0
#UB2D_FONT_ALIGNMENT_MIDDLE 								= 0.5
#UB2D_FONT_ALIGNMENT_BOTTOM 								= 1.0


;- Constants: Sound

#UB2D_SOUND_DEFAULT                         = %0000000
#UB2D_SOUND_PLAY                            = %0000001
#UB2D_SOUND_LOOP                            = %0000010
#UB2D_SOUND_BACKGROUND                      = %0000100
#UB2D_SOUND_CHANNEL                         = %0001000
#UB2D_SOUND_AUTORELEASE                     = %0010000
#UB2D_SOUND_DOPPLEREFFECT                   = %0100000
#UB2D_SOUND_STREAM                          = %1000000

#UB2D_SOUND_FULLSPHERE                      = -1.0
#UB2D_SOUND_INFINITY                        = -1.0


;- Constants: Controls - Mouse

#UB2D_MOUSEBUTTON_LEFT											= 1
#UB2D_MOUSEBUTTON_RIGHT											= 2
#UB2D_MOUSEBUTTON_MIDDLE										= 4


;- Constants: Controls - Keyboard

#UB2D_KEY_BACK															= 8
#UB2D_KEY_TAB																= 9
#UB2D_KEY_CLEAR															= 12
#UB2D_KEY_RETURN														= 13
#UB2D_KEY_SHIFT															= 16
#UB2D_KEY_CONTROL														= 17
#UB2D_KEY_MENU															= 18
#UB2D_KEY_PAUSE															= 19
#UB2D_KEY_CAPITAL														= 20
#UB2D_KEY_FINAL															= 21
#UB2D_KEY_ESC																= 27
#UB2D_KEY_CONVERT														= 28
#UB2D_KEY_NONCONVERT												= 29
#UB2D_KEY_MODECHANGE												= 31
#UB2D_KEY_SPACE															= 32
#UB2D_KEY_PRIOR															= 33
#UB2D_KEY_NEXT															= 34
#UB2D_KEY_END																= 35
#UB2D_KEY_HOME															= 36
#UB2D_KEY_LEFT															= 37
#UB2D_KEY_UP																= 38
#UB2D_KEY_RIGHT															= 39
#UB2D_KEY_DOWN															= 40
#UB2D_KEY_SELECT														= 41
#UB2D_KEY_PRINT															= 42
#UB2D_KEY_EXECUTE														= 43
#UB2D_KEY_SNAPSHOT													= 44
#UB2D_KEY_INSERT														= 45
#UB2D_KEY_DELETE														= 46
#UB2D_KEY_HELP															= 47
#UB2D_KEY_0																	= 48
#UB2D_KEY_1																	= 49
#UB2D_KEY_2																	= 50
#UB2D_KEY_3																	= 51
#UB2D_KEY_4																	= 52
#UB2D_KEY_5																	= 53
#UB2D_KEY_6																	= 54
#UB2D_KEY_7																	= 55
#UB2D_KEY_8																	= 56
#UB2D_KEY_9																	= 57
#UB2D_KEY_A																	= 65
#UB2D_KEY_B																	= 66
#UB2D_KEY_C																	= 67
#UB2D_KEY_D																	= 68
#UB2D_KEY_E																	= 69
#UB2D_KEY_F																	= 70
#UB2D_KEY_G																	= 71
#UB2D_KEY_H																	= 72
#UB2D_KEY_I																	= 73
#UB2D_KEY_J																	= 74
#UB2D_KEY_K																	= 75
#UB2D_KEY_L																	= 76
#UB2D_KEY_M																	= 77
#UB2D_KEY_N																	= 78
#UB2D_KEY_O																	= 79
#UB2D_KEY_P																	= 80
#UB2D_KEY_Q																	= 81
#UB2D_KEY_R																	= 82
#UB2D_KEY_S																	= 83
#UB2D_KEY_T																	= 84
#UB2D_KEY_U																	= 85
#UB2D_KEY_V																	= 86
#UB2D_KEY_W																	= 87
#UB2D_KEY_X																	= 88
#UB2D_KEY_Y																	= 89
#UB2D_KEY_Z																	= 90
#UB2D_KEY_LWIN															= 91
#UB2D_KEY_RWIN															= 92
#UB2D_KEY_APPS															= 93
#UB2D_KEY_NUMPAD0														= 96
#UB2D_KEY_NUMPAD1														= 97
#UB2D_KEY_NUMPAD2														= 98
#UB2D_KEY_NUMPAD3														= 99
#UB2D_KEY_NUMPAD4														= 100
#UB2D_KEY_NUMPAD5														= 101
#UB2D_KEY_NUMPAD6														= 102
#UB2D_KEY_NUMPAD7														= 103
#UB2D_KEY_NUMPAD8														= 104
#UB2D_KEY_NUMPAD9														= 105
#UB2D_KEY_MULTIPLY													= 106
#UB2D_KEY_ADD																= 107
#UB2D_KEY_SEPARATOR													= 108
#UB2D_KEY_SUBTRACT													= 109
#UB2D_KEY_DECIMAL														= 110
#UB2D_KEY_DIVIDE														= 111
#UB2D_KEY_F1																= 112
#UB2D_KEY_F2																= 113
#UB2D_KEY_F3																= 114
#UB2D_KEY_F4																= 115
#UB2D_KEY_F5																= 116
#UB2D_KEY_F6																= 117
#UB2D_KEY_F7																= 118
#UB2D_KEY_F8																= 119
#UB2D_KEY_F9																= 120
#UB2D_KEY_F10																= 121
#UB2D_KEY_F11																= 122
#UB2D_KEY_F12																= 123
#UB2D_KEY_NUMLOCK														= 144
#UB2D_KEY_SCROLL														= 145
#UB2D_KEY_LSHIFT														= 160
#UB2D_KEY_RSHIFT														= 161
#UB2D_KEY_LCONTROL													= 162
#UB2D_KEY_RCONTROL													= 163
#UB2D_KEY_LMENU															= 164
#UB2D_KEY_RMENU															= 165
#UB2D_KEY_OEM_1															= 186
#UB2D_KEY_OEM_PLUS													= 187
#UB2D_KEY_OEM_COMMA													= 188
#UB2D_KEY_OEM_MINUS													= 189
#UB2D_KEY_OEM_PERIOD												= 190
#UB2D_KEY_OEM_2															= 191
#UB2D_KEY_OEM_3															= 192
#UB2D_KEY_OEM_4															= 219
#UB2D_KEY_OEM_5															= 220
#UB2D_KEY_OEM_6															= 221
#UB2D_KEY_OEM_7															= 222
#UB2D_KEY_OEM_8															= 223
#UB2D_KEY_OEM_CLEAR													= 254
#UB2D_KEY_ZOOM															= 251


;- Constants: Controls - Gamepad

#UB2D_GAMEPAD_AXIS_X             						= 0
#UB2D_GAMEPAD_AXIS_Y             						= 1
#UB2D_GAMEPAD_AXIS_Z             						= 2
#UB2D_GAMEPAD_AXIS_R             						= 3
#UB2D_GAMEPAD_AXIS_U             						= 4
#UB2D_GAMEPAD_AXIS_V             						= 5
#UB2D_GAMEPAD_AXIS_ALL           						=-1

#UB2D_GAMEPAD_BUTTON_A          						= 0
#UB2D_GAMEPAD_BUTTON_B          						= 1
#UB2D_GAMEPAD_BUTTON_X           						= 2
#UB2D_GAMEPAD_BUTTON_Y           						= 3
#UB2D_GAMEPAD_BUTTON_LEFTBUMPER  						= 4
#UB2D_GAMEPAD_BUTTON_RIGHTBUMPER 						= 5
#UB2D_GAMEPAD_BUTTON_BACK        						= 6
#UB2D_GAMEPAD_BUTTON_START       						= 7
#UB2D_GAMEPAD_BUTTON_LEFTSTICK   						= 8
#UB2D_GAMEPAD_BUTTON_RIGHTSTICK  						= 9

#UB2D_GAMEPAD_DOWN               						= %00001
#UB2D_GAMEPAD_PUSHED             						= %00010
#UB2D_GAMEPAD_UP                 						= %00100
#UB2D_GAMEPAD_CLICK              						= %00100
#UB2D_GAMEPAD_DOUBLECLICK       						= %01000


;- Constants: Drawing

#UB2D_DRAWING_VBO_VERTEXMAXIMUM							= 8192

#UB2D_PROJECTIONMATRIX_FULL									= 0
#UB2D_PROJECTIONMATRIX_HALF									= 1
#UB2D_PROJECTIONMATRIX_QUARTER							= 2


;- Constants: GUI

#UB2D_GADGET_TEMPLATE_TYPE_FIXED						= 0
#UB2D_GADGET_TEMPLATE_TYPE_STRIPE						= 1
#UB2D_GADGET_TEMPLATE_TYPE_FRAME						= 2

#UB2D_GADGET_TYPE_TEXT											= 0
#UB2D_GADGET_TYPE_BUTTON										= 1
#UB2D_GADGET_TYPE_CHECKBOX									= 2
#UB2D_GADGET_TYPE_CONTAINER									= 3
#UB2D_GADGET_TYPE_STRING										= 4
#UB2D_GADGET_TYPE_PROGRESSBAR								= 5
#UB2D_GADGET_TYPE_SLIDER										= 6
#UB2D_GADGET_TYPE_SPIN											= 7
#UB2D_GADGET_TYPE_SPRITE										= 8
#UB2D_GADGET_TYPE_LISTVIEW									= 9

#UB2D_GADGET_TEMPLATE_BUTTON_NORMAL					= 0
#UB2D_GADGET_TEMPLATE_BUTTON_HOVER					= 1
#UB2D_GADGET_TEMPLATE_BUTTON_PUSHED					= 2
#UB2D_GADGET_TEMPLATE_CHECKBOX_FALSE				= 3
#UB2D_GADGET_TEMPLATE_CHECKBOX_TRUE					= 4
#UB2D_GADGET_TEMPLATE_FRAME									= 5
#UB2D_GADGET_TEMPLATE_BORDER								= 6
#UB2D_GADGET_TEMPLATE_SLIDER								= 7
#UB2D_GADGET_TEMPLATE_SLIDER_FILLED					= 8
#UB2D_GADGET_TEMPLATE_SLIDER_BUTTON					= 9
#UB2D_GADGET_TEMPLATE_SPIN_UP								= 10
#UB2D_GADGET_TEMPLATE_SPIN_DOWN							= 11
#UB2D_GADGET_TEMPLATE_SPRITE								= 12

#UB2D_EVENT_NONE														= 0
#UB2D_EVENT_CLOSEWINDOW											= 1
#UB2D_EVENT_GADGET													= 2

EnumerationBinary
	#UB2D_FLAG_SCREEN
	#UB2D_FLAG_FRAME
	#UB2D_FLAG_READONLY
	#UB2D_FLAG_TOGGLE
	#UB2D_FLAG_HIDDEN
	#UB2D_FLAG_DISABLED
EndEnumeration


;- Constants: Armature

#UB2D_ARMATURE_INTERPOLATION_EXPONENTIAL		= -3
#UB2D_ARMATURE_INTERPOLATION_SMOOTH 				= -2
#UB2D_ARMATURE_INTERPOLATION_LINEAR 				= -1
#UB2D_ARMATURE_INTERPOLATION_NONE   				= 0

#UB2D_ARMATURE_ANIMATION_NORMAL 						= 0
#UB2D_ARMATURE_ANIMATION_LOOP 							= 1
#UB2D_ARMATURE_ANIMATION_INSERTION 					= 2

#UB2D_ARMATURE_ANIMATE_NONE     						= 0
#UB2D_ARMATURE_ANIMATE_LENGTH   						= 1
#UB2D_ARMATURE_ANIMATE_OFFSET   						= 2
#UB2D_ARMATURE_ANIMATE_ROTATION 						= 4
#UB2D_ARMATURE_ANIMATE_SCALING 							= 8

#UB2D_ARMATURE_NOTIME 											= -1

#UB2D_ARMATURE_ARM                          = 0
#UB2D_ARMATURE_DAE                          = 1


;- Constants: Debugger

#UB2D_DEBUGGER_SHAREDMEMORYNAME 						= "UB2D DebuggerApplication "
#UB2D_DEBUGGER_SHAREDMEMORYSIZE 						= 100 * 1024*1024

#UB2D_DEBUGGER_NONE													= 0
#UB2D_DEBUGGER_CLEAR												= 1
#UB2D_DEBUGGER_ERROR												= 2
#UB2D_DEBUGGER_WARNING											= 3
#UB2D_DEBUGGER_NOTE													= 4
#UB2D_DEBUGGER_REPORT												= 5
#UB2D_DEBUGGER_OUTPUT												= 6
#UB2D_DEBUGGER_LIBRARY											= 7
#UB2D_DEBUGGER_LIBRARY_NONE									= 8
#UB2D_DEBUGGER_LIBRARY_FONT									= 9
#UB2D_DEBUGGER_LIBRARY_LIGHT								= 10
#UB2D_DEBUGGER_LIBRARY_MATERIAL							= 11
#UB2D_DEBUGGER_LIBRARY_OBJECT								= 12
#UB2D_DEBUGGER_LIBRARY_SHADER								= 13
#UB2D_DEBUGGER_LIBRARY_TEXTURE							= 14
#UB2D_DEBUGGER_LIBRARY_TEXTURE_IMAGE				= 15
#UB2D_DEBUGGER_LIBRARY_POSITION							= 16
#UB2D_DEBUGGER_LIBRARY_ARMATURE							= 17


;</Library Constants>

;<Library Structures>

;- Structures: Vectors

Structure UB2D_VECTOR2l
	StructureUnion : X.l : U.l : S.l : EndStructureUnion
	StructureUnion : Y.l : V.l : T.l : EndStructureUnion
EndStructure

Structure UB2D_VECTOR2i
	StructureUnion : X.i : U.i : S.i : EndStructureUnion
	StructureUnion : Y.i : V.i : T.i : EndStructureUnion
EndStructure

Structure UB2D_VECTOR2f
	StructureUnion : X.f : U.f : S.f : EndStructureUnion
	StructureUnion : Y.f : V.f : T.f : EndStructureUnion
EndStructure

Structure UB2D_VECTOR3l
	StructureUnion : X.l : R.l : U.l : S.l : EndStructureUnion
	StructureUnion : Y.l : G.l : V.l : T.l : EndStructureUnion
	StructureUnion : Z.l : B.l : EndStructureUnion
EndStructure

Structure UB2D_VECTOR3i
	StructureUnion : X.i : R.i : U.i : S.i : EndStructureUnion
	StructureUnion : Y.i : G.i : V.i : T.i : EndStructureUnion
	StructureUnion : Z.i : B.i : EndStructureUnion
EndStructure

Structure UB2D_VECTOR3f
	StructureUnion : X.f : R.f : U.f : S.f : EndStructureUnion
	StructureUnion : Y.f : G.f : V.f : T.f : EndStructureUnion
	StructureUnion : Z.f : B.f : EndStructureUnion
EndStructure

Structure UB2D_COLOR3f Extends UB2D_VECTOR3f : EndStructure

Structure UB2D_VECTOR4l Extends UB2D_VECTOR3l
	StructureUnion : W.l : A.l : EndStructureUnion
EndStructure

Structure UB2D_VECTOR4i Extends UB2D_VECTOR3i
	StructureUnion : W.i : A.i : EndStructureUnion
EndStructure

Structure UB2D_VECTOR4f Extends UB2D_VECTOR3f
	StructureUnion : W.f : A.f : EndStructureUnion
EndStructure

Structure UB2D_QUATERNION Extends UB2D_VECTOR4f : EndStructure

Structure UB2D_COLOR4f Extends UB2D_VECTOR4f : EndStructure

Structure UB2D_EULER
	Pitch.f
	Yaw.f
	Roll.f
	Void.f
EndStructure


;- Structures: Matrix

Structure UB2D_MATRIX3f
	I11.f : I21.f : I31.f
	I12.f : I22.f : I32.f
	I13.f : I23.f : I33.f
EndStructure

Structure UB2D_MATRIX4X3f
	I11.f : I21.f : I31.f : I41.f
	I12.f : I22.f : I32.f : I42.f
	I13.f : I23.f : I33.f : I43.f
EndStructure

Structure UB2D_MATRIX4f
	I11.f : I21.f : I31.f : I41.f
	I12.f : I22.f : I32.f : I42.f
	I13.f : I23.f : I33.f : I43.f
	I14.f : I24.f : I34.f : I44.f
EndStructure


;- Structures: Size
	
Structure UB2D_SIZE2l
	StructureUnion : W.l : X.l : lWidth.l  : EndStructureUnion
	StructureUnion : H.l : Y.l : lHeight.l : EndStructureUnion
EndStructure

Structure UB2D_SIZE2i
	StructureUnion : W.i : X.i : iWidth.i  : EndStructureUnion
	StructureUnion : H.i : Y.i : iHeight.i : EndStructureUnion
EndStructure

Structure UB2D_SIZE2f
	StructureUnion : W.f : X.f : fWidth.f  : EndStructureUnion
	StructureUnion : H.f : Y.f : fHeight.f : EndStructureUnion
EndStructure

Structure UB2D_SIZE3l Extends UB2D_SIZE2l
	StructureUnion : D.l : Z.l : lDepth.l : EndStructureUnion	
EndStructure

Structure UB2D_SIZE3i Extends UB2D_SIZE2i
	StructureUnion : D.i : Z.i : iDepth.i : EndStructureUnion	
EndStructure

Structure UB2D_SIZE3f Extends UB2D_SIZE2f
	StructureUnion : D.f : Z.f : fDepth.f : EndStructureUnion	
EndStructure


;- Structures: Area

Structure UB2D_AREA2l : V.UB2D_VECTOR2l[2] : EndStructure

Structure UB2D_AREA2i : V.UB2D_VECTOR2i[2] : EndStructure

Structure UB2D_AREA2f : V.UB2D_VECTOR2f[2] : EndStructure

Structure UB2D_AREA3l : V.UB2D_VECTOR3l[2] : EndStructure

Structure UB2D_AREA3i : V.UB2D_VECTOR3i[2] : EndStructure

Structure UB2D_AREA3f : V.UB2D_VECTOR3f[2] : EndStructure


;- Structures: Attribute

Structure UB2D_ATTRIBUTEl : Min.l : Val.l : Max.l : EndStructure

Structure UB2D_ATTRIBUTEi : Min.i : Val.i : Max.i : EndStructure

Structure UB2D_ATTRIBUTEf : Min.f : Val.f : Max.f : EndStructure


;- Structures: Range

Structure UB2D_RANGEl : Min.l : Max.l : EndStructure

Structure UB2D_RANGEi : Min.i : Max.i : EndStructure

Structure UB2D_RANGEf : Min.f : Max.f : EndStructure


;- Structures: CharacterArray

Structure UB2D_CHARACTERARRAY
	C.c[0]
EndStructure

Structure UB2D_ASCIIARRAY
	C.a[0]
EndStructure


;- Structures: XML

Structure UB2D_XML_ATTRIBUTE
	sName.s
	iInteger.i
	fFloat.f
	StructureUnion
		sValue.s
		sString.s
	EndStructureUnion
EndStructure

Structure UB2D_XML_NODE
	sName.s
	sText.s
	iType.i
	iOffset.i
	Map 	mAttributes.UB2D_XML_ATTRIBUTE(8)
	List 	*plAttributes.UB2D_XML_ATTRIBUTE()
	Map 	mNodes.UB2D_XML_NODE(16)
	List	*plNodes.UB2D_XML_NODE()
	
EndStructure

Structure UB2D_XML
	MainNode.UB2D_XML_NODE
	Map		*pmPathNode.UB2D_XML_NODE()
EndStructure


;- Structures: JSON

Structure UB2D_JSON
	iType.i
	iInteger.i
	fFloat.f
	sString.s
	Map  	mMembers.UB2D_JSON()
	List 	lElements.UB2D_JSON()
	Array *paElements.UB2D_JSON(0)
EndStructure


;- Structures: Window

Structure UB2D_WINDOW
	iID.i
	hWnd.i
	hDC.i
	hRC.i
	sTitle.s
EndStructure


;- Structures: Screen

Structure	UB2D_SCREEN Extends UB2D_VECTOR2i
	bFullScreen.i
	bASync.i
	iContainer.i
	v2iSize.UB2D_SIZE2i
	v2iHalfSize.UB2D_SIZE2i
	PFD.PIXELFORMATDESCRIPTOR
	fGamma.f
EndStructure


;- Structures: Control

Structure UB2D_CONTROL_KEYBOARD
	bDown.i[256]
	bPushed.i[256]
	bReleased.i[256]
	cInput.i
EndStructure

Structure UB2D_CONTROL_MOUSE
	X.i
	Y.i
	DeltaX.i
	DeltaY.i
	bButtonDown.i[5]
	bButtonPushed.i[5]
	bButtonReleased.i[5]
	iWheel.i
	bHidden.i
	bLocked.i
	bClipped.i
EndStructure

Structure UB2D_CONTROL_MANAGER
	Keyboard.UB2D_CONTROL_KEYBOARD
	Mouse.UB2D_CONTROL_MOUSE
EndStructure


;- Structures: Gamepad
Structure UB2D_GAMEPAD
	Capabilities.JOYCAPS
	Name.s
	Axis.f[8]
	Deadzone.f[8]
	PushedButtons.l
	ButtonDownTime.i[16]
	ButtonPushedTime.i[16]
	ButtonEvent.i[16]
	PointOfView.f
EndStructure

Structure UB2D_GAMEPAD_MANAGER
	Devices.i
	GamepadInfo.JOYINFOEX
	fGetKeyboardDelay.f
	fGetKeyboardSpeed.f
	Array Gamepad.UB2D_GAMEPAD(15)
EndStructure


;- Structures: FrameBuffer 

Structure UB2D_FRAMEBUFFER
	glFBO.i
	glRBO.i
	sName.s{64}
	iDrawingBufferCount.i
	Array glDrawingBuffer.i(0)
	Array aDrawingBufferNames.s{64}(0)
EndStructure

Structure UB2D_FRAMEBUFFER_TEXTURE
	glTO.i
	sName.s{64}
  v2iSize.UB2D_SIZE2i
  bTextureArray.i
  iTextureArraySize.i
  Array aTextureArrayName.s{64}(0)
EndStructure

Structure UB2D_FRAMEBUFFER_VERTEX
	v4fPosition.UB2D_VECTOR4f
  v2fTexCoord.UB2D_VECTOR2f	
EndStructure

Structure UB2D_FRAMEBUFFER_SCREENPLANE
  glVAO.i
  glVBO.i
  v2iSize.UB2D_SIZE2i
  v2iHalfSize.UB2D_SIZE2i
  Vertices.UB2D_FRAMEBUFFER_VERTEX[4]
EndStructure

Structure UB2D_FRAMEBUFFER_MANAGER
  ScreenPlane.UB2D_FRAMEBUFFER_SCREENPLANE
  iFrameBufferCount.i
  iCurrentFrameBuffer.i
  Array aFrameBuffer.UB2D_FRAMEBUFFER(0)
  iTextureCount.i
  Array aTexture.UB2D_FRAMEBUFFER_TEXTURE(0)
EndStructure


;- Structures: Textures

Structure UB2D_TEXTURE
	iID.i
	sName.s
	iType.i
	glTO.i
	glMipmaps.i
	lWidth.i ; War vorher l
	lHeight.i ; War vorher l
	iSize.i
EndStructure

Structure UB2D_TEXTURE_RENDERING
	bStatus.i
	glFBO.i
	glRBO.i
	glTBO.i
	
	glVAO.i
  glVBO.i
	Vertices.UB2D_FRAMEBUFFER_VERTEX[4]
	
	
	v2iOriginalScreenSize.UB2D_SIZE2i
	qOriginalCameraRotation.UB2D_QUATERNION
	v4fOriginalCameraPosition.UB2D_VECTOR4f
EndStructure

Structure UB2D_TEXTURE_MANAGER
	iTextureFilter.i
	
	TextureRendering.UB2D_TEXTURE_RENDERING
	
	List	 lTexture.UB2D_TEXTURE()
	Array *paTexture.UB2D_TEXTURE(0)
	Map		*pmTexture.UB2D_TEXTURE()
EndStructure


;- Structures: Shader
Structure UB2D_SHADER_BUFFERSTRUCTURE_MATRICES
	m4fProjection.UB2D_MATRIX4f
	m4fWorldView.UB2D_MATRIX4f
	m4fNormal.UB2D_MATRIX4X3f
EndStructure

Structure UB2D_SHADER_BUFFERSTRUCTURE_MATERIAL
	v4fColor.UB2D_COLOR4f
	fRoughness.f
	fMetallic.f
	fSpecular.f
	fEmission.f
EndStructure

Structure UB2D_SHADER_BUFFERSTRUCTURE_LIGHT
	v3fPosition.UB2D_VECTOR3f
	fRange.f
	v3fColor.UB2D_COLOR3f
	fIntensity.f
	v3fDirection.UB2D_VECTOR3f
	fConeAngle.f
	;bStatic.i
EndStructure

Structure UB2D_SHADER_BUFFERSTRUCTURE_MISC
	v2fResolution.UB2D_VECTOR2f
	fNear.f
	fFar.f
EndStructure

Structure UB2D_SHADER_BUFFERSTRUCTURE_KERNEL
	v3fVector.UB2D_VECTOR3f[32]
EndStructure

Structure UB2D_SHADER_BUFFEROBJECT
	ID.i
	sName.s
	glUBO.i
	iSize.i
	iOffset.i
	iPointerOffset.i
	iPointerSize.i
 *pPointer	
EndStructure

Structure UB2D_SHADER_BUFFER_MATRICES Extends UB2D_SHADER_BUFFEROBJECT
	Buffer.UB2D_SHADER_BUFFERSTRUCTURE_MATRICES
EndStructure

Structure UB2D_SHADER_BUFFER_MATERIAL Extends UB2D_SHADER_BUFFEROBJECT
	Buffer.UB2D_SHADER_BUFFERSTRUCTURE_MATERIAL
EndStructure

Structure UB2D_SHADER_BUFFER_LIGHT Extends UB2D_SHADER_BUFFEROBJECT
	Buffer.UB2D_SHADER_BUFFERSTRUCTURE_LIGHT
EndStructure

Structure UB2D_SHADER_BUFFER_MISC Extends UB2D_SHADER_BUFFEROBJECT
	Buffer.UB2D_SHADER_BUFFERSTRUCTURE_MISC
EndStructure

Structure UB2D_SHADER_BUFFER_KERNEL Extends UB2D_SHADER_BUFFEROBJECT
	Buffer.UB2D_SHADER_BUFFERSTRUCTURE_KERNEL
EndStructure

Structure UB2D_SHADER_BUFFER
	Matrices.UB2D_SHADER_BUFFER_MATRICES
	Material.UB2D_SHADER_BUFFER_MATERIAL
	Light.UB2D_SHADER_BUFFER_LIGHT
	Misc.UB2D_SHADER_BUFFER_MISC
	Kernel.UB2D_SHADER_BUFFER_KERNEL
EndStructure

Structure UB2D_SHADER_UNIFORM_POINTER
	StructureUnion
		iSampler.i
		iInteger.i
		fFloat.f
		v4fVector.UB2D_VECTOR4f
		m3fMatrix.UB2D_MATRIX3f
		m4fMatrix.UB2D_MATRIX4f
	EndStructureUnion
EndStructure

Structure UB2D_SHADER_UNIFORM
	iType.i
	sName.s{32}
  glLocation.i	
  iIndex.i
  
  iSize.i
	iPointerOffset.i
	*pPointer.UB2D_SHADER_UNIFORM_POINTER
	
	StructureUnion
		iSampler.i
		iInteger.i
		fFloat.f
		v4fVector.UB2D_VECTOR4f
		m3fMatrix.UB2D_MATRIX3f
		m4fMatrix.UB2D_MATRIX4f
	EndStructureUnion
EndStructure

Structure UB2D_SHADER
	iID.i
	iDefaultID.i
	iType.i
	sName.s{64}
	iRenderTreeBranch.i
	glObject.i
	
	Array *paUniform.UB2D_SHADER_UNIFORM(0)
	List 	lUniform.UB2D_SHADER_UNIFORM()
	List	*plSamplerUniform.UB2D_SHADER_UNIFORM()
EndStructure

Structure UB2D_SHADER_MANAGER
	
	iMaxBufferCount.i	
	Buffer.UB2D_SHADER_BUFFER
	
 *pCurrentShader.UB2D_SHADER
	
	NoiseTexture.UB2D_Texture
 *pBRDFTexture.UB2D_Texture
	
	Array    aBuffer.UB2D_SHADER_BUFFEROBJECT(0)
	
	List 		 lShader.UB2D_SHADER()
	Array 	*paShader.UB2D_SHADER(0)
	Map 		*pmShader.UB2D_SHADER(0)
	Array   *paDefaultShader.UB2D_SHADER(63)
EndStructure


;- Structures: Material

Structure UB2D_MATERIAL
	iID.i
	sName.s
 *pShader.UB2D_SHADER
 *pTexture.UB2D_TEXTURE[4]	
 
	v4fColor.UB2D_COLOR4f
	fRoughness.f
	fMetallic.f
	fSpecular.f
	fEmission.f
	fRefraction.f
	bDepthMask.i
	iBlendingMode.i[2]
	fValue.f[8]
EndStructure

Structure UB2D_MATERIAL_MANAGER
 *pCurrentMaterial.UB2D_MATERIAL
 
	List 	 lMaterial.UB2D_MATERIAL()
	Array *paMaterial.UB2D_MATERIAL(0)
	Map		*pmMaterial.UB2D_MATERIAL()
EndStructure


;- Structures: Header

Structure UB2D_HEADER
	iID.i
	sName.s
	iType.i
	iAttachmentMode.i 
	fRotation.f
	v4fPosition.UB2D_VECTOR4f
	v4fScale.UB2D_VECTOR4f
	m4fMatrix.UB2D_MATRIX4f
	m4fWorldMatrix.UB2D_MATRIX4f
	*pParent.UB2D_HEADER
EndStructure


;- Structures: Mesh

Structure UB2D_MESH_VECTORINDEX
	V.i  : T.i  : N.i : G.i
EndStructure

Structure UB2D_MESH_VERTEX_GROUP
	iID.i
	sName.s
EndStructure

Structure UB2D_MESH_VERTEX
	v4fPosition.UB2D_VECTOR4f 							
	v3fNormal.UB2D_VECTOR3f
	v3fTangent.UB2D_VECTOR3f
  v2fTexCoord.UB2D_VECTOR2f
  iGroup.i	
EndStructure

Structure UB2D_MESH_SKELETAL_VERTEX Extends UB2D_MESH_VERTEX
  v3iBoneID.UB2D_VECTOR3i
  v3fBoneWeight.UB2D_VECTOR3f
EndStructure

Structure UB2D_MESH_BOUNDINGBOX
	v4fPosition.UB2D_VECTOR4f
	v4fSize.UB2D_VECTOR4f
EndStructure

Structure UB2D_MESH
	iID.i
	sName.s
	
	glVAO.i
	glVBO.i
	glIBO.i
	iVertexCount.i
	iIndicesCount.i
	
	*pMaterial.UB2D_MATERIAL
	
	Array  aIndices.i(0)
	
	Array  aVertex.UB2D_MESH_VERTEX(0)
	
	bSkeletal.i
	Array  aSkeletalVertex.UB2D_MESH_SKELETAL_VERTEX(0)
	*pArmature.UB2D_ARMATURE
	
	BoundingBox.UB2D_MESH_BOUNDINGBOX
	
	List 	 lVertexGroup.UB2D_MESH_VERTEX_GROUP()
	Array *paVertexGroup.UB2D_MESH_VERTEX_GROUP(0)
	Map		*pmVertexGroup.UB2D_MESH_VERTEX_GROUP()
EndStructure

Structure UB2D_MESH_INSTANCE Extends UB2D_HEADER
	*pMesh.UB2D_MESH
	bDisplay.i
	bStatic.i
	*pArmatureInstance.UB2D_ARMATURE_INSTANCE
	qRotation.UB2D_QUATERNION	
EndStructure

Structure UB2D_MESH_MANAGER
	List	 lMesh.UB2D_MESH()
	Array *paMesh.UB2D_MESH(0)
	Map		*pmMesh.UB2D_MESH()
	
	List 		lMeshInstances.UB2D_MESH_INSTANCE()
	Array 	*paMeshInstances.UB2D_MESH_INSTANCE(0)
	Map 		*pmMeshInstances.UB2D_MESH_INSTANCE()
EndStructure


;- Structures: Objects

Structure UB2D_OBJECT_VERTEX
	v4fPosition.UB2D_VECTOR4f
	v2fTexCoord.UB2D_VECTOR2f[2]
EndStructure

Structure UB2D_OBJECT
	iID.i
	sName.s
 *pMaterial.UB2D_MATERIAL
	v2fSize.UB2D_SIZE2f
	v2fOrigin.UB2D_VECTOR2f
	Vertex.UB2D_OBJECT_VERTEX[4]
	glVAO.i
	glVBO.i
	fBoundingSphereRadius.f
	
	;For direct display:
	fRotation.f
	v4fScale.UB2D_VECTOR4f
	m4fMatrix.UB2D_MATRIX4f
EndStructure

Structure UB2D_OBJECT_INSTANCE Extends UB2D_HEADER
 *pObject.UB2D_OBJECT
	bDisplay.i
	bStatic.i
	fBoundingSphereRadius.f
EndStructure

Structure UB2D_OBJECT_MANAGER
	List 		lObjects.UB2D_OBJECT()
	Array 	*paObjects.UB2D_OBJECT(0)
	Map 		*pmObjects.UB2D_OBJECT()
	
	List 		lObjectInstances.UB2D_OBJECT_INSTANCE()
	Array 	*paObjectInstances.UB2D_OBJECT_INSTANCE(0)
	Map 		*pmObjectInstances.UB2D_OBJECT_INSTANCE()
EndStructure


;- Structures: Group

Structure UB2D_GROUP Extends UB2D_HEADER
	List *plMember.UB2D_HEADER()
EndStructure


;- Structures: Camera	

Structure UB2D_CAMERA Extends UB2D_HEADER
	iWidth.i
	iHeight.i
	fNear.f
	fFar.f 
	v2fRatio.UB2D_SIZE2f
	qRotation.UB2D_QUATERNION	
	m4fInvMatrix.UB2D_MATRIX4f
	m4fProjectionMatrix.UB2D_MATRIX4f[3]
	m4fInvProjectionMatrix.UB2D_MATRIX4f
EndStructure

Structure UB2D_CAMERA_MANAGER
 *pCurrentCamera.UB2D_CAMERA
	
	List	 lCamera.UB2D_CAMERA()
	Array *paCamera.UB2D_CAMERA(0)
	Map 	*pmCamera.UB2D_CAMERA(0)
EndStructure


;- Structures: Drawing

Structure UB2D_DRAWING_VERTEX
	v4fPosition.UB2D_COLOR4f
	v4fColor.UB2D_COLOR4f
EndStructure

Structure UB2D_DRAWING_MANAGER
	lColor.l
	v4fColor.UB2D_COLOR4f
	glLineWidth.f
	glVAO.i
	glVBO.i
	iIndices.i
	iVertexMaximum.i
	
	bTransformation.i
	v4fPosition.UB2D_VECTOR4f
	v4fScale.UB2D_VECTOR4f
	qRotation.UB2D_QUATERNION	
	m4fMatrix.UB2D_MATRIX4f
		
	Array aVertices.UB2D_DRAWING_VERTEX(0)
EndStructure


;- Structures: Sprites

Structure UB2D_SPRITE_VERTEX
	v4fPosition.UB2D_VECTOR4f
	v2fTexCoord.UB2D_VECTOR2f[2]
EndStructure

Structure UB2D_SPRITE
	iID.i
	sName.s
 *pMaterial.UB2D_MATERIAL
	fWidth.f
	fHeight.f
	fDepth.f
	fRotation.f
	v2fOrigin.UB2D_VECTOR2f
	Vertex.UB2D_SPRITE_VERTEX[4]
	glVAO.i
	glVBO.i
	v4fScale.UB2D_VECTOR4f
	m4fWorldMatrix.UB2D_MATRIX4f
EndStructure

Structure UB2D_SPRITE_MANAGER
	List	 lSprite.UB2D_SPRITE()
	Array *paSprite.UB2D_SPRITE(0)	
	Map 	*pmSprite.UB2D_SPRITE()
EndStructure


;- Structures: Light

Structure UB2D_LIGHT_DIRECTLIGHT
	fIntensity.f
	v4fColor.UB2D_COLOR4f
	v4fDirection.UB2D_VECTOR4f
EndStructure

Structure UB2D_LIGHT Extends UB2D_HEADER
	iLightType.i
	bEnable.i
	bStatic.i
	fRange.f
	fIntensity.f
	fConeAngle.f
	v4fColor.UB2D_COLOR4f
	v4fDirection.UB2D_VECTOR4f
	qRotation.UB2D_QUATERNION
EndStructure

Structure UB2D_LIGHT_MESH_VERTEX
	v4fPosition.UB2D_VECTOR4f
	v2fTexCoord.UB2D_VECTOR2f
EndStructure

Structure UB2D_LIGHT_MESH
	glVAO.i
	glVBO.i
	glIBO.i
	iVertexCount.i
	iIndicesCount.i
	Array aIndices.i(0)
	Array aVertices.UB2D_LIGHT_MESH_VERTEX(0)
EndStructure

Structure UB2D_LIGHT_INSTANCEBUFFER
	m4fMatrix.UB2D_MATRIX4f
	v3fPosition.UB2D_VECTOR3f
	fRange.f
	v3fColor.UB2D_COLOR3f
	fIntensity.f
	v3fDirection.UB2D_VECTOR3f
	fConeAngle.f
EndStructure

Structure UB2D_LIGHT_VOLUMETRICLIGHT
	bEnable.i
	iSamples.i
	fDensity.f
	fMinimalExposure.f
	fWeight.f
	fDecay.f
	v4fVolumetricLightSettings.UB2D_VECTOR4f ;x) fDensity, y) fMinimalExposure, z) fWeight, w) fDecay
EndStructure

Structure UB2D_LIGHT_MANAGER
	v4fAmbientColor.UB2D_COLOR4f
	DirectLight.UB2D_LIGHT_DIRECTLIGHT
	VolumetricLight.UB2D_LIGHT_VOLUMETRICLIGHT
	
	LightMesh.UB2D_LIGHT_MESH
	glLightInstancesVBO.i
	fSSAOMaxDistance.f
	
	List	 lLight.UB2D_LIGHT()
	Array *paLight.UB2D_LIGHT(0)
	Map 	*pmLight.UB2D_LIGHT()
	
	iLightInstances.i
	iPointLightInstances.i
	iSpotLightInstances.i
	Array aPointLightInstanceBuffer.UB2D_LIGHT_INSTANCEBUFFER(0)
	Array aSpotLightInstanceBuffer.UB2D_LIGHT_INSTANCEBUFFER(0)
	Array *paLightInstances.UB2D_LIGHT(0)
EndStructure


;- Structures: Armature

Structure UB2D_ARMATURE_ANIMATION_FRAME_BONE
	*pBone.UB2D_ARMATURE_BONE
	iFlags.i
	v4fOffset.UB2D_VECTOR4f
	qRotation.UB2D_QUATERNION
	v4fScale.UB2D_VECTOR4f
	iOffsetInterpolation.i
	iRotationInterpolation.i
	iScaleInterpolation.i
EndStructure

Structure UB2D_ARMATURE_ANIMATION_FRAME
	List lBone.UB2D_ARMATURE_ANIMATION_FRAME_BONE()
	fTimePosition.f
EndStructure

Structure UB2D_ARMATURE_ANIMATION
	List lFrame.UB2D_ARMATURE_ANIMATION_FRAME()
	fTimeLength.f
	sName.s
EndStructure

Structure UB2D_ARMATURE_BONE
	*pParentBone.UB2D_ARMATURE_BONE
	sLabel.s
	
	fLength.f
	qRotation.UB2D_QUATERNION
	v4fOffset.UB2D_VECTOR4f
	v4fScale.UB2D_VECTOR4f
	
	m4fLocalResetMatrix.UB2D_MATRIX4f
	m4fResetMatrix.UB2D_MATRIX4f
	
; 	fPreviousLength.f
; 	qPreviousRotation.UB2D_QUATERNION
; 	v4fPreviousOffset.UB2D_VECTOR4f
; 	v4fPreviousScale.UB2D_VECTOR4f
; 	fAnimatedLength.f
; 	qAnimatedRotation.UB2D_QUATERNION
; 	v4fAnimatedOffset.UB2D_VECTOR4f
; 	v4fAnimatedScale.UB2D_VECTOR4f
; 	*pPreviousFrame.UB2D_ARMATURE_ANIMATION_FRAME
; 	*pPreviousFrameBone.UB2D_ARMATURE_ANIMATION_FRAME_BONE
; 	*pCurrentFrame.UB2D_ARMATURE_ANIMATION_FRAME
; 	*pCurrentFrameBone.UB2D_ARMATURE_ANIMATION_FRAME_BONE
; 	m4fLocalMatrix.UB2D_MATRIX4f
; 	m4fMatrix.UB2D_MATRIX4f
; 	
; 	*pSprite.UB2D_SPRITE
; 	m4fSpriteMatrix.UB2D_MATRIX4f
; 	
; 	*pMesh.UB2D_MESH
; 	m4fMeshMatrix.UB2D_MATRIX4f
; 	
; 	*pLight.UB2D_LIGHT
; 	m4fLightMatrix.UB2D_MATRIX4f
EndStructure

Structure UB2D_ARMATURE_INSTANCE_BONE Extends UB2D_HEADER
	*pBone.UB2D_ARMATURE_BONE
	*pParentBone.UB2D_ARMATURE_INSTANCE_BONE
	fPreviousLength.f
	qPreviousRotation.UB2D_QUATERNION
	v4fPreviousOffset.UB2D_VECTOR4f
	v4fPreviousScale.UB2D_VECTOR4f
	fAnimatedLength.f
	qAnimatedRotation.UB2D_QUATERNION
	v4fAnimatedOffset.UB2D_VECTOR4f
	v4fAnimatedScale.UB2D_VECTOR4f
	*pPreviousFrame.UB2D_ARMATURE_ANIMATION_FRAME
	*pPreviousFrameBone.UB2D_ARMATURE_ANIMATION_FRAME_BONE
	*pCurrentFrame.UB2D_ARMATURE_ANIMATION_FRAME
	*pCurrentFrameBone.UB2D_ARMATURE_ANIMATION_FRAME_BONE
	m4fLocalMatrix.UB2D_MATRIX4f
	m4fMeshMatrix.UB2D_MATRIX4f
EndStructure

Structure UB2D_ARMATURE_INSTANCE
	*pArmature.UB2D_ARMATURE
	*pCurrentAnimation.UB2D_ARMATURE_ANIMATION
	iFlags.i
	*pPushedAnimation.UB2D_ARMATURE_ANIMATION
	iPushedFlags.i
	fPushedPreviousTime.f
	fStartTime.f
	fPauseTime.f
	fCurrentTime.f
	fPreviousTime.f
	fAnimationSpeed.f
	List lBone.UB2D_ARMATURE_INSTANCE_BONE()
EndStructure

Structure UB2D_ARMATURE Extends UB2D_HEADER
	iMode.i
	*pMainBone.UB2D_ARMATURE_BONE
	List lBone.UB2D_ARMATURE_BONE()
	List lAnimation.UB2D_ARMATURE_ANIMATION()
	*SelectedBone.UB2D_ARMATURE_BONE
	*pInstance.UB2D_ARMATURE_INSTANCE
EndStructure

Structure UB2D_ARMATURE_MANAGER
	List	 lArmature.UB2D_ARMATURE()
	Array	 *paArmature.UB2D_ARMATURE(0)	
	Map	   *pmArmature.UB2D_ARMATURE()
EndStructure


;- Structures: Scene Manager

Prototype.i UB2D_RenderCallback()

Structure UB2D_SCENE_RENDERTREE_MATERIAL
	*pMaterial.UB2D_MATERIAL
	pRenderCallback.UB2D_RenderCallback
	List *plObjectInstances.UB2D_OBJECT_INSTANCE()
	List *plMeshInstances.UB2D_MESH_INSTANCE()
EndStructure

Structure UB2D_SCENE_RENDERTREE_SHADER
	*pShader.UB2D_SHADER
	pRenderCallback.UB2D_RenderCallback
	List lMaterial.UB2D_SCENE_RENDERTREE_MATERIAL()
EndStructure

Structure UB2D_SCENE_RENDERTREE_BRANCH
	List lShader.UB2D_SCENE_RENDERTREE_SHADER()
EndStructure

Structure UB2D_SCENE_RENDERTREE
	Array aBranch.UB2D_SCENE_RENDERTREE_BRANCH(1)
EndStructure

Structure UB2D_SCENE_GLOWBLOOM
	bEnable.i
	fGlowIntensity.f
	fBloomIntensity.f
	fBlurIntensity.f
	fBrightness.f
EndStructure

Structure UB2D_SCENE_LENSFLARE
	bEnable.i
	fBias.f
	fScale.f
	iSamples.i
	fDispersal.f
	fHaloWidth.f
	fBlurIntensity.f
	fBrightness.f
EndStructure

Structure UB2D_SCENE_MANAGER
	fGamma.f
	fContrast.f
	fSaturation.f
	bBlur.i
	v4fClearColor.UB2D_COLOR4f
 *pEnvironmentMap.UB2D_TEXTURE
	GlowBloom.UB2D_SCENE_GLOWBLOOM
	LensFlare.UB2D_SCENE_LENSFLARE
	v3fWind.UB2D_VECTOR3f
	RenderTree.UB2D_SCENE_RENDERTREE
EndStructure


;- Structures: Font

#UB2D_FONT_KERNINGSLOTS    = 701
#UB2D_FONT_CHARACTERBUFFER = 256

Structure UB2D_FONT_CHUNK_CHARACTERS_CHARACTER
	iIndex.u         																				 ; Zeichenindex
	iOutlayX.w       																				 ; Ausgabe: X-Versatz (in Pixel)
	iOutlayY.w      																				 ; Ausgabe: Y-Versatz (in Pixel)
	iOutlayWidth.w   																				 ; Ausgabe: Breite (in Pixel)
	iOutlayHeight.w  																				 ; Ausgabe: H�he (in Pixel)
	iSourceX.w       																				 ; Quelle: X-Position (in Pixel)
	iSourceY.w       																				 ; Quelle: Y-Position (i,n Pixel)
	iSourceWidth.w   																				 ; Quelle: Breite (in Pixel)
	iSourceHeight.w  																				 ; Quelle: H�he (in Pixel)
EndStructure

Structure UB2D_FONT_CHUNK_CHARACTERS
	iType.l                                            			 ; Chunktyp
	iCount.l                                           			 ; Anzahl der Zeichen
	aCharacter.UB2D_FONT_CHUNK_CHARACTERS_CHARACTER[0] 			 ; Zeichendefinition
EndStructure

Structure UB2D_FONT_CHUNK_KERNINGPAIRS_KERNINGPAIR
	iLeftCharacter.u   																			 ; linkes Zeichen
	iRightCharacter.u  																			 ; rechtes Zeichen
	iAmount.w          																			 ; Verschiebung
EndStructure

Structure UB2D_FONT_CHUNK_KERNINGPAIRS
	iType.l                                                  ; Chunktyp
	iCount.l                                                 ; Anzahl der Unterscheidungspaare
	aKerningPair.UB2D_FONT_CHUNK_KERNINGPAIRS_KERNINGPAIR[0] ; Unterscheidungspaar
EndStructure

Structure UB2D_FONTVERTEX
	v4fPosition.UB2D_VECTOR4f
	v2fTexCoord.UB2D_VECTOR2f
EndStructure

Structure UB2D_FONTVERTICES
	aI.UB2D_FONTVERTEX[4]
EndStructure

Structure UB2D_FONTCHARACTERAREA
	X.i : Y.i
	iWidth.i : iHeight.i
EndStructure

Structure UB2D_FONTCHARACTER
	iIndex.i
	Outlay.UB2D_FONTCHARACTERAREA
	Source.UB2D_FONTCHARACTERAREA
EndStructure

Structure UB2D_FONTCHUNK
	iLength.l  
	iChecksum.l
	StructureUnion
		iType.l
		iChunkData.l
	EndStructureUnion
	iImageData.l
EndStructure

Structure UB2D_FONTKERNINGPAIR
	StructureUnion
		iCharacterPair.q             
		iCharacter.w[2]              
	EndStructureUnion
	iAmount.i                       
	*pNextPair.UB2D_FONTKERNINGPAIR 
EndStructure

Structure UB2D_FONTCHARACTERSET
	*pMaterial.UB2D_MATERIAL
	m4fMatrix.UB2D_MATRIX4f
	iCopys.i
	sComment.s
	fMaxCharacterHeight.f
	List		lCharacter.UB2D_FONTCHARACTER()     
	List		lKerningPair.UB2D_FONTKERNINGPAIR()
	Array		*paCharacter.UB2D_FONTCHARACTER(0)
	Array		*paKerningPair.UB2D_FONTKERNINGPAIR(701)
EndStructure

Structure UB2D_FONTSTYLE
	fSize.f
	iColor.i
	fBendRadius.f
	v2fAlignment.UB2D_VECTOR2f
	fItalic.f
	fLetterSpace.f
	fWordSpace.f
	v4fTranslation.UB2D_VECTOR4f
	v4fRotation.UB2D_VECTOR4f
	m3fRotation.UB2D_MATRIX3f
	fWordWrap.f
	bEnabledRegion.i
	Region.UB2D_FONTCHARACTERAREA
	bKerning.i
EndStructure

Structure UB2D_FONT
	iID.i
	sName.s
 *pCharacterSet.UB2D_FONTCHARACTERSET
	Style.UB2D_FONTSTYLE 
EndStructure

Structure UB2D_FONT_MANAGER
	glIBO.i
	glVAO.i
	glVBO.i
	Array		aVertex.UB2D_FONTVERTEX(#UB2D_FONT_CHARACTERBUFFER*4-1)
	Array		aFaceIndex.i(#UB2D_FONT_CHARACTERBUFFER*6-1)
	
	*pShader.UB2D_SHADER
	DefaultFontStyle.UB2D_FONTSTYLE
	
	List		lFontCharacterSet.UB2D_FONTCHARACTERSET()
	
	List		lFont.UB2D_FONT()
	Array		*paFont.UB2D_FONT(0)
	Map			*pmFont.UB2D_FONT()
EndStructure


;- Structures: GUI

Structure UB2D_GUI_GADGET_TEMPLATE
	iID.i
	iType.i
	v2fSize.UB2D_SIZE2f
	v2fTileSize.UB2D_SIZE2f
	*pMaterial.UB2D_MATERIAL	
	glVAO.i
	glVBO.i
	iVertex.i
	Vertex.UB2D_SPRITE_VERTEX[36]
EndStructure

Structure UB2D_GUI_GADGET_ITEM
	sText.s
	iData.i
EndStructure

Structure UB2D_GUI_GADGET
	iType.i
	iID.i
	sText.s
	sToggleText.s
	iStatus.i
	bHidden.i
	bDisabled.i
	v2fPosition.UB2D_VECTOR2f
	v2fSize.UB2D_SIZE2f
	*pGadgetList.UB2D_GUI_GADGETLIST
	*pSprite.UB2D_SPRITE
	fMin.f
	fMax.f
	fStep.f
	fValue.f
	StructureUnion
		fShift.f
		iShift.i
	EndStructureUnion
	iFlag.i
	List   lItems.UB2D_GUI_GADGET_ITEM()
EndStructure

Structure UB2D_GUI_GADGETLIST
	List *plGadgets.UB2D_GUI_GADGET()
EndStructure

Structure UB2D_GUI_WINDOWGADGET
	iID.i
	sTitle.s
	bDisplay.i
	v2fPosition.UB2D_VECTOR2f
	v2fSize.UB2D_SIZE2f
	v2fTileSize.UB2D_SIZE2f
	*pMaterial.UB2D_MATERIAL

	Vertex.UB2D_SPRITE_VERTEX[36]
	glVAO.i
	glVBO.i
	
	*pGadgetList.UB2D_GUI_GADGETLIST
EndStructure

Structure UB2D_GUI_MANAGER
	iStatus.i
	
	iEvent.i
	*pEventGadget.UB2D_GUI_GADGET
	*pGadgetList.UB2D_GUI_GADGETLIST
	*pMovingWindow.UB2D_GUI_WINDOWGADGET
	*pHoveredGadget.UB2D_GUI_GADGET
	*pSelectedGadget.UB2D_GUI_GADGET
	fSelectedGadgetX.f
	*pEditableGadget.UB2D_GUI_GADGET
	sEditedText.s
	*pActiveGadget.UB2D_GUI_GADGET
	iCursor.i
	
	bWindowBlur.i
	
	ScreenGadgetList.UB2D_GUI_GADGETLIST
	
	v4fOffset.UB2D_VECTOR2f
	
	List	lWindows.UB2D_GUI_WINDOWGADGET()
	Array *paWindows.UB2D_GUI_WINDOWGADGET(0)
		
	List lGadgets.UB2D_GUI_GADGET()
	Array *paGadgets.UB2D_GUI_GADGET(0)
	
	List lGadgetList.UB2D_GUI_GADGETLIST()
	List *plCurrentGadgetList.UB2D_GUI_GADGETLIST()

	Array aGadgetTemplates.UB2D_GUI_GADGET_TEMPLATE(16)
	
	Array *paFonts.UB2D_FONT(8)
	Array *paTextures.UB2D_TEXTURE(8)
	Array *paMaterials.UB2D_MATERIAL(8)
EndStructure


;- Structures: Debugger

Structure UB2D_DEBUGGER_MANAGER
	iInitialized.i
	*QueueWrite
	*QueueRead
EndStructure


;- Structures: Queue

Structure UB2D_QUEUE_MEMORY
	StructureUnion
		lSize.l
		lLength.l
	EndStructureUnion
	qSignal.q
	lCursorWrite.l
	lCursorRead.l
EndStructure

Structure UB2D_QUEUE_BUFFER
	StructureUnion
		wWord.w
		lLong.l
		fFloat.f
		lLength.l
		qQuad.q
	EndStructureUnion
EndStructure

Structure UB2D_QUEUE
	sName.s
	*pFileMapping
	*pSharedMemory.UB2D_QUEUE_MEMORY
	*pSharedMemoryPosition.UB2D_QUEUE_MEMORY
	*pBuffer.UB2D_QUEUE_BUFFER
	*pBufferPosition.UB2D_QUEUE_BUFFER
	qSignal.q
EndStructure

Structure UB2D_QUEUE_MANAGER
	Map   mQueue.UB2D_QUEUE()
EndStructure


;- Structures: Engine Control

Structure UB2D_ENGINECONTROL_PAGE
	iID.i
	sName.s
	*pButtonGadget.UB2D_GUI_GADGET
	*pContainerGadget.UB2D_GUI_GADGET
	Array *paGadgets.UB2D_GUI_GADGET(0)
EndStructure

Structure UB2D_ENGINECONTROL
	bStatus.i
	*pWindowGadget.UB2D_GUI_WINDOWGADGET
	*pCloseButtonGadget.UB2D_GUI_GADGET
	iPages.i
	Array aPages.UB2D_ENGINECONTROL_PAGE(0)
EndStructure


;- Structures: Default Resources

Structure UB2D_DEFAULTRESOURCES
	*pUnionBytesTexture.UB2D_TEXTURE
	*pUnionBytesSprite.UB2D_SPRITE
	*pEnvironmentMap.UB2D_TEXTURE
	*pLensFlareRadiallyColorTexture.UB2D_TEXTURE
	*pLensDustTexture.UB2D_TEXTURE
	*pLensFlareHexagonTexture.UB2D_TEXTURE
	*pLensFlareHexagonSprite.UB2D_SPRITE
	*pDefaultTexture.UB2D_TEXTURE[4]
	*pDefaultMeshMaterial.UB2D_MATERIAL
	*pDefaultObjectMaterial.UB2D_MATERIAL
	*pDefaultSpriteMaterial.UB2D_MATERIAL
	*pHeaderFont.UB2D_FONT
	*pTextFont.UB2D_FONT
	*pWindowTexture.UB2D_TEXTURE
	*pGadgetsTexture.UB2D_TEXTURE
EndStructure


;- Structures: UB2D

Structure UB2D
	Window.UB2D_WINDOW
	Screen.UB2D_SCREEN

	FrameBufferManager.UB2D_FRAMEBUFFER_MANAGER	
	CameraManager.UB2D_CAMERA_MANAGER
	ControlManager.UB2D_CONTROL_MANAGER
	ExamineControlManager.UB2D_CONTROL_MANAGER		
	GamepadManager.UB2D_GAMEPAD_MANAGER
	SceneManager.UB2D_SCENE_MANAGER
	ShaderManager.UB2D_SHADER_MANAGER
	TextureManager.UB2D_TEXTURE_MANAGER
	MaterialManager.UB2D_MATERIAL_MANAGER
	DrawingManager.UB2D_DRAWING_MANAGER
	MeshManager.UB2D_MESH_MANAGER
	ObjectManager.UB2D_OBJECT_MANAGER
	ArmatureManager.UB2D_ARMATURE_MANAGER
	SpriteManager.UB2D_SPRITE_MANAGER
	LightManager.UB2D_LIGHT_MANAGER
	FontManager.UB2D_FONT_MANAGER
	GUI.UB2D_GUI_MANAGER
	QueueManager.UB2D_QUEUE_MANAGER
	DebuggerManager.UB2D_DEBUGGER_MANAGER

	DefaultResources.UB2D_DEFAULTRESOURCES
	
	EngineControl.UB2D_ENGINECONTROL

	QueryPerformanceFrequency.q
	fTimeFactor.f
	qTime.q
	fTime.f
	fFPS.f
	bDisplayFPS.i
	bClose.i
EndStructure


;</Library Structures>

;<Library Prototypes>

Prototype   UB2D_Prototype_ASync( bEnable.i = #True )
Prototype.i UB2D_Prototype_AddArmatureAnimation( iArmature.i, fTimeLength.f, sName.s = "" )
Prototype.i UB2D_Prototype_AddArmatureBone( iArmature.i, *ParentBone.UB2D_ARMATURE_BONE = #Null, fLength.f = 0.0, sLabel.s = "" )
Prototype.i UB2D_Prototype_AddArmatureFrame( iArmature.i, *Animation.UB2D_ARMATURE_ANIMATION, fTimePosition.f )
Prototype.i UB2D_Prototype_AddGadgetItem( iGadget.i, iIndex.i, sText.s, iData.i=0 )
Prototype.i UB2D_Prototype_AddMeshCubeData( iMesh.i, X.f, Y.f, Z.f, fWidth.f = 1.0, fHeight.f = 1.0, fDepth.f = 1.0, U.f = 1.0, V.f = 1.0, RX.f = 0.0,  RY.f = 0.0,  RZ.f = 0.0, iVertexGroup.i = 0 )
Prototype.i UB2D_Prototype_AddMeshData( iMesh.i, iSourceMesh.i, X.f, Y.f, Z.f, RX.f = 0.0,  RY.f = 0.0,  RZ.f = 0.0, SX.f = 1.0, SY.f = 1.0, SZ.f = 1.0, iVertexGroup.i = #UB2D_ALL )
Prototype.i UB2D_Prototype_AddMeshFaceData( iMesh.i, X.f, Y.f, Z.f, fWidth.f = 1.0, fHeight.f = 1.0, U.f = 1.0, V.f = 1.0, RX.f = 0.0,  RY.f = 0.0,  RZ.f = 0.0, iVertexGroup.i = 0, iMode.i = #UB2D_ALIGNMENTPOINT_CENTER )
Prototype.i UB2D_Prototype_AddMeshInstance( iMeshInstance.i, iMesh.i, X.f, Y.f, Z.f = 0.0, *ParentMeshInstance.UB2D_MESH_INSTANCE = #Null, sName.s = "" )
Prototype.i UB2D_Prototype_AddMeshVertexGroup( iMesh.i, sName.s )
Prototype.i UB2D_Prototype_AddObjectInstance( iObjectInstance.i, iObject.i, X.f, Y.f, Z.f = 0.0, sName.s = "" )
Prototype.i UB2D_Prototype_AddRenderTreeMaterial( *Material.UB2D_MATERIAL )
Prototype.i UB2D_Prototype_AddRenderTreeMeshInstance( *MeshInstance.UB2D_MESH_INSTANCE )
Prototype.i UB2D_Prototype_AddRenderTreeObjectInstance( *ObjectInstance.UB2D_OBJECT_INSTANCE )
Prototype.i UB2D_Prototype_AddRenderTreeShader( *Shader.UB2D_SHADER, iBranch.i )
Prototype.i UB2D_Prototype_AddSimpleMeshFaceData( iMesh.i, X.f, Y.f, Z.f, fWidth.f = 1.0, fHeight.f = 1.0, U.f = 0.0, V.f = 0.0, fUWidth.f = 1.0, fVHeight.f = 1.0, iVertexGroup.i = 0, iMode.i = #UB2D_ALIGNMENTPOINT_CENTER )
Prototype.i UB2D_Prototype_AddTextureToTextureArray( iTexture.i, sFile.s, iIndex.i = 0 )
Prototype.i UB2D_Prototype_AmbientLightColor()
Prototype.f UB2D_Prototype_ArcSin( Value.f )
Prototype   UB2D_Prototype_ArmatureAnimation( iArmature.i, sName.s )
Prototype.i UB2D_Prototype_ArmatureBone( iArmature.i, sName.s, *MeshInstance.UB2D_MESH_INSTANCE = #Null )
Prototype.i UB2D_Prototype_ArmatureBoneID( iArmature.i, iBoneIndex.i )
Prototype.i UB2D_Prototype_ArmatureID( iArmature.i )
Prototype.i UB2D_Prototype_Attach( *Target.UB2D_HEADER, *Attachment.UB2D_HEADER, iMode.i = #UB2D_ATTACH_DEFAULT )
Prototype   UB2D_Prototype_BindCameraProjectionMatrix(iCamera.i, iProjectionMatrix.i = #UB2D_PROJECTIONMATRIX_FULL )
Prototype   UB2D_Prototype_BindCurrentCameraProjectionMatrix( iProjectionMatrix.i = #UB2D_PROJECTIONMATRIX_FULL )
Prototype   UB2D_Prototype_BindFrameBuffer( iFrameBuffer.i = #UB2D_FRAMEBUFFER_FINAL, bClear.b = #True, bSetUp = #True )
Prototype   UB2D_Prototype_BindMaterial( iMaterial.i, bTextureArray.b = #False )
Prototype.i UB2D_Prototype_BindShader( iShader.i )
Prototype   UB2D_Prototype_ButtonGadget( iGadget.i, X.i, Y.i, iWidth.i, iHeight.i, sText.s, iFlag.i = 0, sToggleText.s = #Null$ )
Prototype.i UB2D_Prototype_CalculateMeshTangents( iMesh.i )
Prototype.i UB2D_Prototype_Camera( sName.s )
Prototype.f UB2D_Prototype_CameraFar( iCamera.i )
Prototype.i UB2D_Prototype_CameraID( iCamera.i )
Prototype.i UB2D_Prototype_CameraInvMatrix( iCamera.i )
Prototype.i UB2D_Prototype_CameraMatrix( iCamera.i )
Prototype.f UB2D_Prototype_CameraNear( iCamera.i )
Prototype.f UB2D_Prototype_CameraPositionX( iCamera.i )
Prototype.f UB2D_Prototype_CameraPositionY( iCamera.i )
Prototype.f UB2D_Prototype_CameraRotation( iCamera.i )
Prototype.i UB2D_Prototype_CatchFont( iFont.i, *Memory.UB2D_FONTCHUNK, sName.s = "" )
Prototype.i UB2D_Prototype_CatchJSON( *JSON.UB2D_JSON, *Buffer, iLength.i )
Prototype.i UB2D_Prototype_CatchShader( iShader.i, iType.i, *VertexShaderStart.INTEGER, *VertexShaderEnd.INTEGER, *FragmentShaderStart.INTEGER, *FragmentShaderEnd.INTEGER, sName.s )
Prototype.i UB2D_Prototype_CatchTexture( iTexture.i, *Memory.INTEGER, iFilter.i = #UB2D_IGNORE, iMipmaps.i = 0, sName.s = "" )
Prototype   UB2D_Prototype_CheckBoxGadget( iGadget.i, X.i, Y.i, sText.s = "" )
Prototype   UB2D_Prototype_ClearGadgetItems( iGadget.i )
Prototype   UB2D_Prototype_ClearMouse()
Prototype   UB2D_Prototype_ClipMouse()
Prototype   UB2D_Prototype_ClipObject( iObject.i, X.i, Y.i, iWidth.i, iHeight.i )
Prototype   UB2D_Prototype_ClipSprite( iSprite.i, X.i, Y.i, iWidth.i, iHeight.i, iTexCoord.i = 0 )
Prototype   UB2D_Prototype_CloseEngineControl()
Prototype.i UB2D_Prototype_CloseGadgetList()
Prototype.l UB2D_Prototype_Color( *Color.UB2D_COLOR4f )
Prototype   UB2D_Prototype_ContainerGadget( iGadget.i, X.i, Y.i, iWidth.i, iHeight.i, iFlag.i = 0, sTitle.s="" )
Prototype.i UB2D_Prototype_ConvertTextureToImage( iImage.i, iTexture.i, bInvertY.i = #False )
Prototype.i UB2D_Prototype_CopyFont( iSourceFont.i, iFont.i )
Prototype.i UB2D_Prototype_CopyMaterial( iSourceMaterial.i, iDestinationMaterial.i )
Prototype   UB2D_Prototype_CountGadgetItems( iGadget.i )
Prototype.i UB2D_Prototype_CreateArmature( iArmature.i, sName.s = "" )
Prototype.i UB2D_Prototype_CreateCamera( iCamera.i, X.f = 0.0, Y.f = 0.0, iWidth.i = #UB2D_IGNORE, iHeight.i = #UB2D_IGNORE, sName.s = "" )
Prototype.i UB2D_Prototype_CreateClippedObject( iObject.i, iMaterial.i, X.i, Y.i, iWidth.i, iHeight.i, fOriginX.f = 0.0, fOriginY.f = 0.0, sName.s = "" )
Prototype.i UB2D_Prototype_CreateClippedSprite( iSprite.i, iMaterial.i, X.i, Y.i, iWidth.i, iHeight.i, fOriginX.f = 0.0, fOriginY.f = 0.0, sName.s = "" )
Prototype.i UB2D_Prototype_CreateCubeMesh( iMesh.i, iMaterial.i, fSize.f = 1.0, fUV.f = 1.0, iVertexGroup.i = 0, sName.s = "" )
Prototype.i UB2D_Prototype_CreateEmptySprite( iSprite.i, iWidth.f, iHeight.f, fOriginX.f = 0.0, fOriginY.f = 0.0, sName.s = "" )
Prototype.i UB2D_Prototype_CreateEmptyTexture( iTexture.i , lWidth.l, lHeight.l, iFilter.i = #UB2D_IGNORE, sName.s = "" )
Prototype   UB2D_Prototype_CreateInvertSphereMesh( iMesh.i, iMaterial.i, fRadius.f, iSegments.i = 36, iRings.i = 18, sName.s = "" )
Prototype.i UB2D_Prototype_CreateLight( iLight.i, X.f, Y.f, Z.f, fRange.f = 128.0, iColor.i = $FFFFFFFF, iType.i = #UB2D_LIGHT_POINT, sName.s = "" )
Prototype.i UB2D_Prototype_CreateMaterial( iMaterial.i, iShader.i, iTexture.i, sName.s = "" )
Prototype.i UB2D_Prototype_CreateMesh( iMesh.i, iMaterial.i, sName.s = "" )
Prototype.i UB2D_Prototype_CreateObject( iObject.i, iMaterial.i, fOriginX.f = 0.0, fOriginY.f = 0.0, sName.s = "" )
Prototype.i UB2D_Prototype_CreatePlaneMesh( iMesh.i, iMaterial.i, fWidth.f = 1.0, fHeight.f = 1.0, U.f = 1.0, V.f = 1.0, iMode.i = #UB2D_ALIGNMENTPOINT_CENTER, sName.s = "" )
Prototype   UB2D_Prototype_CreateSphereMesh( iMesh.i, iMaterial.i, fRadius.f, iSegments.i = 36, iRings.i = 18, sName.s = "" )
Prototype.i UB2D_Prototype_CreateSprite( iSprite.i, iMaterial.i, fOriginX.f = 0.0, fOriginY.f = 0.0, sName.s = "" )
Prototype.i UB2D_Prototype_CreateSquarePlaneMesh( iMesh.i, iMaterial.i, fSize.f = 1.0, fUV.f = 1.0, sName.s = "" )
Prototype.i UB2D_Prototype_CreateTexture( iTexture.i, iImage.i, iFilter.i = #UB2D_IGNORE, sName.s = "" )
Prototype.i UB2D_Prototype_CreateTextureArray( iTexture.i , lWidth.l, lHeight.l, iSize.i = 1, iFilter.i = #UB2D_IGNORE, iMipmaps.i = 0, sName.s = "" )
Prototype.i UB2D_Prototype_CreateTextureArrayFromTO( iTexture.i , glTextureObject.i, lWidth.l, lHeight.l, iSize.i, sName.s = "" )
Prototype.i UB2D_Prototype_CreateTextureFromTO( iTexture.i , glTextureObject.i, lWidth.l, lHeight.l, sName.s = "" )
Prototype.i UB2D_Prototype_CreateTriangleMesh( iMesh.i, iMaterial.i, fSize.f = 1.0, fUV.f = 1.0, sName.s = "" )
Prototype.i UB2D_Prototype_CreateWindow( iWindow.i, X.i, Y.i, iWidth.i, iHeight.i, sTitle.s, bDisplay.i = #True )
Prototype.i UB2D_Prototype_CurrentArmatureAnimation( iArmature.i )
Prototype.i UB2D_Prototype_CurrentCamera()
Prototype.f UB2D_Prototype_CurrentCameraFar()
Prototype.i UB2D_Prototype_CurrentCameraInvMatrix()
Prototype.i UB2D_Prototype_CurrentCameraMatrix()
Prototype.f UB2D_Prototype_CurrentCameraNear()
Prototype.f UB2D_Prototype_CurrentCameraPositionX()
Prototype.f UB2D_Prototype_CurrentCameraPositionY()
Prototype.f UB2D_Prototype_CurrentCameraRotation()
Prototype   UB2D_Prototype_Debug( sText.s )
Prototype   UB2D_Prototype_DebugSystemInformation()
Prototype.i UB2D_Prototype_DefaultShaderID( iDefaultShader.i )
Prototype   UB2D_Prototype_DeleteAllMeshInstanceFromMesh( iMesh.i )
Prototype   UB2D_Prototype_DeleteMeshInstance( iMeshInstance.i )
Prototype   UB2D_Prototype_DeleteObjectInstance( iObjectInstance.i )
Prototype.i UB2D_Prototype_DeleteRenderTreeMaterial( *Material.UB2D_MATERIAL )
Prototype.i UB2D_Prototype_DeleteRenderTreeMeshInstance( *MeshInstance.UB2D_MESH_INSTANCE )
Prototype.i UB2D_Prototype_DeleteRenderTreeObjectInstance( *ObjectInstance.UB2D_OBJECT_INSTANCE )
Prototype.i UB2D_Prototype_DeleteRenderTreeShader( *Shader.UB2D_SHADER )
Prototype.i UB2D_Prototype_DirectLightColor()
Prototype.f UB2D_Prototype_DirectLightIntensity()
Prototype.i UB2D_Prototype_DisableGadget( iGadget.i, iState.i = #True )
Prototype.i UB2D_Prototype_DisplayArmature( iArmature.i, X.f, Y.f )
Prototype   UB2D_Prototype_DisplayDrawingBuffer()
Prototype   UB2D_Prototype_DisplayGUI()
Prototype   UB2D_Prototype_DisplayObject( iObject.i, X.f, Y.f, Z.f = 0.0 )
Prototype   UB2D_Prototype_DisplaySprite( iSprite.i, X.f, Y.f, fDepth.f = #UB2D_IGNORE )
Prototype   UB2D_Prototype_DisplaySpriteWithoutBindings( iSprite.i, X.f, Y.f, fDepth.f = #UB2D_IGNORE )
Prototype   UB2D_Prototype_DisplayText( iFont.i, X.f, Y.f, sText.s, iColor.i = #UB2D_IGNORE, fSize.f = #UB2D_IGNORE, fItalic.f = #UB2D_IGNORE )
Prototype   UB2D_Prototype_Draw2DBox( X1.f, Y1.f, X2.f, Y2.f, Z.f = 0.0, lColor.l = $FFFFFFFF )
Prototype   UB2D_Prototype_Draw2DCircle( X.f, Y.f, fRadius.f, Z.f = 0.0, lColor.l = $FFFFFFFF )
Prototype   UB2D_Prototype_Draw2DCross( X.f, Y.f, fSize.f, Z.f = 0.0, lColor.l = $FFFFFFFF )
Prototype   UB2D_Prototype_Draw2DLine( X1.f, Y1.f, X2.f, Y2.f, Z.f = 0.0, lColor.l = $FFFFFFFF )
Prototype   UB2D_Prototype_Draw2DTrianle( X1.f, Y1.f, X2.f, Y2.f, X3.f, Y3.f, Z.f = 0.0, lColor.l = $FFFFFFFF )
Prototype   UB2D_Prototype_Draw2DVectorBox( *v2fVertex1.UB2D_VECTOR2f, *v2fVertex2.UB2D_VECTOR2f, Z.f = 0.0, lColor.l = $FFFFFFFF )
Prototype   UB2D_Prototype_Draw2DVectorCircle( *v2fVertex.UB2D_VECTOR2f, fRadius.f, Z.f = 0.0, lColor.l = $FFFFFFFF )
Prototype   UB2D_Prototype_Draw2DVectorCross( *v2fVertex.UB2D_VECTOR2f, fSize.f, Z.f = 0.0, lColor.l = $FFFFFFFF )
Prototype   UB2D_Prototype_Draw2DVectorLine( *v2fVertex1.UB2D_VECTOR2f, *v2fVertex2.UB2D_VECTOR2f, Z.f = 0.0, lColor.l = $FFFFFFFF )
Prototype   UB2D_Prototype_Draw2DVectorTrianle( *v2fVertex1.UB2D_VECTOR2f, *v2fVertex2.UB2D_VECTOR2f, *v2fVertex3.UB2D_VECTOR2f, Z.f = 0.0, lColor.l = $FFFFFFFF )
Prototype   UB2D_Prototype_Draw3DAxes( X.f, Y.f, Z.f, fSize.f )
Prototype   UB2D_Prototype_Draw3DBox( X1.f, Y1.f, Z1.f, X2.f, Y2.f, Z2.f, lColor.l = $FFFFFFFF )
Prototype   UB2D_Prototype_Draw3DCross( X.f, Y.f, Z.f, fSize.f, lColor.l = $FFFFFFFF )
Prototype   UB2D_Prototype_Draw3DLine( X1.f, Y1.f, Z1.f, X2.f, Y2.f, Z2.f, lColor.l = $FFFFFFFF )
Prototype   UB2D_Prototype_Draw3DSphere( X.f, Y.f, Z.f, fRadius.f, lColor.l = $FFFFFFFF )
Prototype   UB2D_Prototype_Draw3DTrianle( X1.f, Y1.f, Z1.f, X2.f, Y2.f, Z2.f, X3.f, Y3.f, Z3.f, lColor.l = $FFFFFFFF )
Prototype   UB2D_Prototype_Draw3DVectorBox( *v3fVertex1.UB2D_VECTOR3f, *v3fVertex2.UB2D_VECTOR3f, lColor.l = $FFFFFFFF )
Prototype   UB2D_Prototype_Draw3DVectorCross( *v3fVertex.UB2D_VECTOR3f, fSize.f, lColor.l = $FFFFFFFF )
Prototype   UB2D_Prototype_Draw3DVectorLine( *v3fVertex1.UB2D_VECTOR3f, *v3fVertex2.UB2D_VECTOR3f, lColor.l = $FFFFFFFF )
Prototype   UB2D_Prototype_Draw3DVectorSphere( *v3fVertex.UB2D_VECTOR3f, fRadius.f, lColor.l = $FFFFFFFF )
Prototype   UB2D_Prototype_Draw3DVectorTrianle( *v3fVertex1.UB2D_VECTOR3f, *v3fVertex2.UB2D_VECTOR3f, *v3fVertex3.UB2D_VECTOR3f, lColor.l = $FFFFFFFF )
Prototype.f UB2D_Prototype_DrawingLineWidth()
Prototype.i UB2D_Prototype_DuplicateLight( iLight.i, iSourceLight.i,  sName.s = "" )
Prototype.i UB2D_Prototype_DuplicateMaterial( iDuplicatedMaterial.i, iMaterial.i, sName.s = "" )
Prototype.i UB2D_Prototype_EnableGadget( iGadget.i, iState.i = #True )
Prototype.i UB2D_Prototype_EngineControlStatus()
Prototype   UB2D_Prototype_Error( sText.s , iLibrary.i = #UB2D_NONE , sProcedure.s = "" )
Prototype   UB2D_Prototype_Event()
Prototype   UB2D_Prototype_EventGadget()
Prototype.i UB2D_Prototype_ExamineArmature( iArmature.i, *Instance.UB2D_ARMATURE_INSTANCE = #Null )
Prototype.i UB2D_Prototype_ExamineGamepads()
Prototype   UB2D_Prototype_ExamineKeyboard()
Prototype   UB2D_Prototype_ExamineMouse()
Prototype.f UB2D_Prototype_FPS()
Prototype   UB2D_Prototype_FinishMesh( iMesh.i )
Prototype   UB2D_Prototype_FlipBuffers()
Prototype.i UB2D_Prototype_FontAlignment( iFont.i, fAlignmentH.f, fAlignmentV.f = #UB2D_DEFAULT )
Prototype.i UB2D_Prototype_FontBendRadius( iFont.i, fBendRadius.f = #UB2D_NONE )
Prototype.i UB2D_Prototype_FontColor( iFont.i, iColor.i )
Prototype.i UB2D_Prototype_FontID( iFont.i )
Prototype.i UB2D_Prototype_FontItalic( iFont.i, fAngle.f = 0.0 )
Prototype.i UB2D_Prototype_FontKerning( iFont.i, bState.i )
Prototype.i UB2D_Prototype_FontOrigin( iFont.i, X.f = 0.0, Y.f = 0.0, Z.f = #UB2D_FONT_TRANSLATIONZ )
Prototype.i UB2D_Prototype_FontRegion( iFont.i, bState.i, X.i = 0, Y.i = 0, iWidth.i = $FFFF, iHeight.i = $FFFF )
Prototype.i UB2D_Prototype_FontRotation( iFont.i, Z.f = 0.0, Y.f = 0.0, X.f = 0.0 )
Prototype.i UB2D_Prototype_FontSize( iFont.i, fSize.f = 1.0, iMode.i = #UB2D_RELATIVE )
Prototype.i UB2D_Prototype_FontSpace( iFont.i, fLetterSpace.f = #UB2D_IGNORE, fWordSpace.f = #UB2D_IGNORE )
Prototype.i UB2D_Prototype_FontWordWrap( iFont.i, fWidth.f = 0.0 )
Prototype   UB2D_Prototype_Free()
Prototype   UB2D_Prototype_FreeArmature( iArmature.i )
Prototype.i UB2D_Prototype_FreeCamera( iCamera.i )
Prototype.i UB2D_Prototype_FreeFont( iFont.i )
Prototype   UB2D_Prototype_FreeGUI()
Prototype   UB2D_Prototype_FreeLight( iLight.i )
Prototype   UB2D_Prototype_FreeMaterial( iMaterial.i )
Prototype   UB2D_Prototype_FreeMesh( iMesh.i )
Prototype   UB2D_Prototype_FreeMeshes()
Prototype   UB2D_Prototype_FreeObject( iObject.i )
Prototype   UB2D_Prototype_FreeObjects()
Prototype   UB2D_Prototype_FreeSprite( iSprite.i )
Prototype   UB2D_Prototype_FreeTexture( iTexture.i )
Prototype.i UB2D_Prototype_GadgetID( iGadget.i )
Prototype.f UB2D_Prototype_GamepadAxis(iGamepad.i, iAxis.i, fPrecision.f = 0.0)
Prototype.f UB2D_Prototype_GamepadAxisDeadzone(iGamepad.i, iAxis.i, fValue.f)
Prototype.i UB2D_Prototype_GamepadButtonEvent(iGamepad.i, iButton.i)
Prototype.i UB2D_Prototype_GamepadButtonPushed(iGamepad.i, iButton.i)
Prototype.i UB2D_Prototype_GamepadButtonReleased(iGamepad.i, iButton.i)
Prototype.i UB2D_Prototype_GamepadName(iGamepad.i)
Prototype.f UB2D_Prototype_GamepadPointOfView(iGamepad.i, iMode.i = #UB2D_DEGREE )
Prototype.i UB2D_Prototype_GetActiveGadget()
Prototype.f UB2D_Prototype_GetArmatureAnimationTime( iArmature.i, *MeshInstance.UB2D_MESH_INSTANCE = #Null )
Prototype.f UB2D_Prototype_GetArmaturePositionX( iArmature.i )
Prototype.f UB2D_Prototype_GetArmaturePositionY( iArmature.i )
Prototype.f UB2D_Prototype_GetArmatureRotation( iArmature.i )
Prototype.i UB2D_Prototype_GetGadgetItemData( iGadget.i, iItem.i )
Prototype.i UB2D_Prototype_GetGadgetState( iGadget.i )
Prototype.i UB2D_Prototype_GetGadgetText( iGadget.i )
Prototype.f UB2D_Prototype_GetGadgetValue( iGadget.i )
Prototype.f UB2D_Prototype_GetMeshInstanceRotationX( iMeshInstance.i )
Prototype.f UB2D_Prototype_GetMeshInstanceRotationY( iMeshInstance.i )
Prototype.f UB2D_Prototype_GetMeshInstanceRotationZ( iMeshInstance.i )
Prototype.i UB2D_Prototype_GetTextureName( iTexture.i )
Prototype   UB2D_Prototype_GetWindowState( iWindow.i )
Prototype   UB2D_Prototype_HideGadget( iGadget.i, iState.i = #True )
Prototype   UB2D_Prototype_HideMouse()
Prototype   UB2D_Prototype_HideWindow( iWindow.i )
Prototype.i UB2D_Prototype_ImportJSON( *JSON.UB2D_JSON, sFileName.s )
Prototype.i UB2D_Prototype_ImportXML( *XML.UB2D_XML, sSource.s, iType.i = #UB2D_XML_FILE )
Prototype.i UB2D_Prototype_IsFont( iFont.i )
Prototype.i UB2D_Prototype_IsLight( iLight.i )
Prototype.i UB2D_Prototype_IsMaterial( iMaterial.i )
Prototype.i UB2D_Prototype_IsMesh( iMesh.i )
Prototype.i UB2D_Prototype_IsMeshInstance( iMeshInstance.i )
Prototype.i UB2D_Prototype_IsMouseInArea( X.i, Y.i, iWidth.i, iHeight.i )
Prototype.i UB2D_Prototype_IsMouseInRange( X.i, Y.i, fRange.f )
Prototype.i UB2D_Prototype_IsObject( iObject.i )
Prototype.i UB2D_Prototype_IsObjectInstance( iObjectInstance.i )
Prototype.i UB2D_Prototype_IsShader( iShader.i )
Prototype.i UB2D_Prototype_IsSprite( iSprite.i )
Prototype.i UB2D_Prototype_IsTexture( iTexture.i )
Prototype   UB2D_Prototype_IsWindowHidden( iWindow.i )
Prototype.i UB2D_Prototype_KeyboardDown( Key.i )
Prototype.i UB2D_Prototype_KeyboardInput()
Prototype.i UB2D_Prototype_KeyboardPushed( Key.i )
Prototype.i UB2D_Prototype_KeyboardReleased( Key.i )
Prototype.i UB2D_Prototype_LightColor( iLight.i )
Prototype.f UB2D_Prototype_LightConeAngle( iLight.i)
Prototype.i UB2D_Prototype_LightID( iLight.i )
Prototype.f UB2D_Prototype_LightIntensity( iLight.i )
Prototype.f UB2D_Prototype_LightPositionX( iLight.i, iMode.i = #UB2D_WORLD )
Prototype.f UB2D_Prototype_LightPositionY( iLight.i, iMode.i = #UB2D_WORLD  )
Prototype.f UB2D_Prototype_LightPositionZ( iLight.i, iMode.i = #UB2D_WORLD )
Prototype.f UB2D_Prototype_LightRange( iLight.i )
Prototype.i UB2D_Prototype_LightState( iLight.i )
Prototype.i UB2D_Prototype_LightType( iLight.i )
Prototype   UB2D_Prototype_ListViewGadget( iGadget.i, X.i, Y.i, iWidth.i, iHeight.i, iFlag.i = 0 )
Prototype.i UB2D_Prototype_LoadArmature( iArmature.i, sFileName.s )
Prototype.i UB2D_Prototype_LoadArmatureAnimation( iArmature.i, sFileName.s, iInterpolation.i = #UB2D_ARMATURE_INTERPOLATION_LINEAR  )
Prototype.i UB2D_Prototype_LoadDAEMesh( iMesh.i, sFile.s, iMaterial.i, fScale.f = 1.0, sName.s = "" )
Prototype.i UB2D_Prototype_LoadDAESkeletalMesh( iMesh.i, sFile.s, iArmature.i, iMaterial.i, fScale.f = 1.0, sName.s = "" )
Prototype.i UB2D_Prototype_LoadEnvironmentTexture( iTexture.i, sFile.s, sName.s = "" )
Prototype.i UB2D_Prototype_LoadFont( iFont.i, sFileName.s )
Prototype.i UB2D_Prototype_LoadOBJMesh( iMesh.i, sFile.s, iMaterial.i, fScale.f = 1.0, sName.s = "" )
Prototype.i UB2D_Prototype_LoadOBJMeshSingleObject( iMesh.i, sFile.s, sObject.s, iMaterial.i, fOffsetX.f = 0.0, fOffsetY.f = 0.0, fOffsetZ.f = 0.0, fScale.f = 1.0, sName.s = "" )
Prototype.i UB2D_Prototype_LoadShader( iShader.i, iType.i, sVertexShader.s, sFragmentShader.s, sName.s )
Prototype.i UB2D_Prototype_LoadTexture( iTexture.i, sFile.s, iFilter.i = #UB2D_IGNORE, iMipmaps.i = 0, sName.s = "" )
Prototype   UB2D_Prototype_LockMouse()
Prototype.i UB2D_Prototype_Material( sName.s )
Prototype.i UB2D_Prototype_MaterialColor( iMaterial.i )
Prototype.f UB2D_Prototype_MaterialEmission( iMaterial.i )
Prototype.i UB2D_Prototype_MaterialID( iMaterial.i )
Prototype.f UB2D_Prototype_MaterialMetallic( iMaterial.i )
Prototype.i UB2D_Prototype_MaterialName( iMaterial.i )
Prototype.f UB2D_Prototype_MaterialRoughness( iMaterial.i )
Prototype.i UB2D_Prototype_MaterialShader( iMaterial.i )
Prototype.f UB2D_Prototype_MaterialSpecular( iMaterial.i )
Prototype.i UB2D_Prototype_MaterialTexture( iMaterial.i, iIndex.i )
Prototype.f UB2D_Prototype_MaterialValue( iMaterial.i, iIndex.i )
Prototype.i UB2D_Prototype_Mesh( sName.s )
Prototype.i UB2D_Prototype_MeshFaceCount( iMesh.i )
Prototype.i UB2D_Prototype_MeshID( iMesh.i )
Prototype.i UB2D_Prototype_MeshIndicesCount( iMesh.i )
Prototype   UB2D_Prototype_MeshInstanceBehaviour( iMeshInstance.i )
Prototype   UB2D_Prototype_MeshInstanceDisplay( iMeshInstance.i )
Prototype.i UB2D_Prototype_MeshInstanceID( iMeshInstance.i )
Prototype   UB2D_Prototype_MeshInstanceLookAt( iMeshInstance.i, X.f, Y.f, Z.f )
Prototype.i UB2D_Prototype_MeshInstanceMatrix( iMeshInstance.i )
Prototype.i UB2D_Prototype_MeshInstanceName( iMeshInstance.i )
Prototype.f UB2D_Prototype_MeshInstancePositionX( iMeshInstance.i, iMode.i = #UB2D_WORLD )
Prototype.f UB2D_Prototype_MeshInstancePositionY( iMeshInstance.i, iMode.i = #UB2D_WORLD )
Prototype.f UB2D_Prototype_MeshInstancePositionZ( iMeshInstance.i, iMode.i = #UB2D_WORLD )
Prototype.f UB2D_Prototype_MeshInstanceScaleX( iMeshInstance.i )
Prototype.f UB2D_Prototype_MeshInstanceScaleY( iMeshInstance.i )
Prototype.f UB2D_Prototype_MeshInstanceScaleZ( iMeshInstance.i )
Prototype.i UB2D_Prototype_MeshName( iMesh.i )
Prototype.i UB2D_Prototype_MeshNormal( iMesh.i, iIndex.i )
Prototype.i UB2D_Prototype_MeshTexCoord( iMesh.i, iIndex.i )
Prototype.i UB2D_Prototype_MeshVector( iMesh.i, iIndex.i )
Prototype.i UB2D_Prototype_MeshVertexCount( iMesh.i )
Prototype.i UB2D_Prototype_MeshVertexGroup( iMesh.i, iIndex.i )
Prototype.i UB2D_Prototype_MeshVertexGroupID( iMesh.i, sName.s )
Prototype.i UB2D_Prototype_MouseButtonDown( Button.i )
Prototype.i UB2D_Prototype_MouseButtonPushed( Button.i )
Prototype.i UB2D_Prototype_MouseButtonReleased( Button.i )
Prototype.i UB2D_Prototype_MouseDeltaX()
Prototype.i UB2D_Prototype_MouseDeltaY()
Prototype   UB2D_Prototype_MousePosition( X.i, Y.i )
Prototype.i UB2D_Prototype_MouseWheel()
Prototype.i UB2D_Prototype_MouseX()
Prototype.i UB2D_Prototype_MouseY()
Prototype   UB2D_Prototype_MoveArmature( iArmature.i, X.f, Y.f, Z.f )
Prototype   UB2D_Prototype_MoveCamera( iCamera.i, X.f, Y.f )
Prototype   UB2D_Prototype_MoveCurrentCamera( X.f, Y.f )
Prototype   UB2D_Prototype_MoveDrawingTransformation( X.f, Y.f, Z.f )
Prototype   UB2D_Prototype_MoveLight( iLight.i, X.f, Y.f, Z.f = 0.0 )
Prototype   UB2D_Prototype_MoveMeshInstance( iMeshInstance.i, X.f, Y.f, Z.f = 0.0 )
Prototype   UB2D_Prototype_MoveObjectInstance(	iObjectInstance.i, X.f, Y.f, Z.f = 0.0 )
Prototype   UB2D_Prototype_Note( sText.s , iLibrary.i = #UB2D_NONE , sProcedure.s = "" )
Prototype.i UB2D_Prototype_ObjectHeight( iObject.i )
Prototype.i UB2D_Prototype_ObjectID( iObject.i )
Prototype   UB2D_Prototype_ObjectInstanceBehaviour( iObjectInstance.i )
Prototype.i UB2D_Prototype_ObjectInstanceHeight( iObjectInstance.i )
Prototype.i UB2D_Prototype_ObjectInstanceID( iObjectInstance.i )
Prototype.i UB2D_Prototype_ObjectInstanceName( iObjectInstance.i )
Prototype.f UB2D_Prototype_ObjectInstancePositionX( iObjectInstance.i, iMode.i = #UB2D_WORLD  )
Prototype.f UB2D_Prototype_ObjectInstancePositionY( iObjectInstance.i, iMode.i = #UB2D_WORLD )
Prototype.f UB2D_Prototype_ObjectInstancePositionZ( iObjectInstance.i, iMode.i = #UB2D_WORLD )
Prototype.f UB2D_Prototype_ObjectInstanceRotation( iObjectInstance.i )
Prototype.i UB2D_Prototype_ObjectInstanceWidth( iObjectInstance.i )
Prototype.i UB2D_Prototype_ObjectMaterial( iObject.i)
Prototype.f UB2D_Prototype_ObjectOriginX( iObject.i )
Prototype.f UB2D_Prototype_ObjectOriginY( iObject.i )
Prototype.f UB2D_Prototype_ObjectRotation( iObject.i )
Prototype.i UB2D_Prototype_ObjectWidth( iObject.i )
Prototype   UB2D_Prototype_OpenEngineControl( X.i = #UB2D_IGNORE, Y.i = #UB2D_IGNORE )
Prototype.i UB2D_Prototype_OpenGadgetList( iGadget.i )
Prototype.i UB2D_Prototype_OpenScreen(iWidth.i, iHeight.i, iDepth.i, sTitle.s, iFlags.i, bFullScreen.i = #False )
Prototype.i UB2D_Prototype_OpenWindowedScreen( iWindow.i, X.i, Y.i, iWidth.i, iHeight.i, iDepth.i )
Prototype.i UB2D_Prototype_PauseArmatureAnimation( iArmature.i, *MeshInstance.UB2D_MESH_INSTANCE = #Null )
Prototype.i UB2D_Prototype_PlayArmatureAnimation( iArmature.i, *Animation.UB2D_ARMATURE_ANIMATION, iFlags.i = #UB2D_ARMATURE_ANIMATION_NORMAL, *MeshInstance.UB2D_MESH_INSTANCE = #Null )
Prototype   UB2D_Prototype_ProgressbarGadget( iGadget.i, X.i, Y.i, iWidth.i, fMax.f = 1.0, fMin.f = 0.0 )
Prototype.i UB2D_Prototype_ReadTextureFromMemory( iTexture.i, *Memory.INTEGER, lTextureWidth.l, lTextureHeight.l, iFilter.i = #UB2D_IGNORE, sName.s = "" )
Prototype.i UB2D_Prototype_RemoveArmatureFrame( iArmature.i, *Animation.UB2D_ARMATURE_ANIMATION, *Frame.UB2D_ARMATURE_ANIMATION_FRAME )
Prototype.i UB2D_Prototype_RemoveArmatureFrameBoneOffset( iArmature.i, *Animation.UB2D_ARMATURE_ANIMATION, *Frame.UB2D_ARMATURE_ANIMATION_FRAME, *Bone.UB2D_ARMATURE_BONE )
Prototype.i UB2D_Prototype_RemoveArmatureFrameBoneRotation( iArmature.i, *Animation.UB2D_ARMATURE_ANIMATION, *Frame.UB2D_ARMATURE_ANIMATION_FRAME, *Bone.UB2D_ARMATURE_BONE )
Prototype.i UB2D_Prototype_RemoveArmatureFrameBoneScaling( iArmature.i, *Animation.UB2D_ARMATURE_ANIMATION, *Frame.UB2D_ARMATURE_ANIMATION_FRAME, *Bone.UB2D_ARMATURE_BONE )
Prototype   UB2D_Prototype_RemoveGadgetItem( iGadget.i, iIndex.i )
Prototype.i UB2D_Prototype_RemoveMaterialRenderCallback( *Material.UB2D_MATERIAL )
Prototype.i UB2D_Prototype_RemoveShaderRenderCallback( *Shader.UB2D_SHADER )
Prototype.i UB2D_Prototype_RenderScene()
Prototype   UB2D_Prototype_Report( sText.s , iLibrary.i = #UB2D_NONE , sProcedure.s = "" )
Prototype   UB2D_Prototype_ResetDrawingTransformationMatrix()
Prototype   UB2D_Prototype_ResizeObject( iObject.i, iWidth.i = #UB2D_IGNORE, iHeight.i = #UB2D_IGNORE )
Prototype   UB2D_Prototype_ResizeObjectInstance( iObjectInstance.i, iWidth.i = #UB2D_IGNORE, iHeight.i = #UB2D_IGNORE )
Prototype   UB2D_Prototype_ResizeScreen( iWidth.i, iHeight.i, bResizeContainer.i = #True )
Prototype.i UB2D_Prototype_ResumeArmatureAnimation( iArmature.i, *MeshInstance.UB2D_MESH_INSTANCE = #Null )
Prototype   UB2D_Prototype_RotateArmature( iArmature.i, fRotation.f )
Prototype   UB2D_Prototype_RotateCamera( iCamera.i, fRotation.f )
Prototype   UB2D_Prototype_RotateCurrentCamera( fRotation.f )
Prototype   UB2D_Prototype_RotateDirectLight( fRotation.f )
Prototype   UB2D_Prototype_RotateDrawingTransformation( X.f, Y.f, Z.f )
Prototype   UB2D_Prototype_RotateLight( iLight.i, fRotation.f )
Prototype.i UB2D_Prototype_RotateMesh( iMesh.i, X.f, Y.f, Z.f )
Prototype   UB2D_Prototype_RotateMeshInstance( iMeshInstance.i, X.f, Y.f, Z.f )
Prototype   UB2D_Prototype_RotateObject( iObject.i, fRotation.f )
Prototype   UB2D_Prototype_RotateObjectInstance( iObjectInstance.i, fRotation.f )
Prototype   UB2D_Prototype_RotateSprite( iSprite.i, fRotation.f )
Prototype.i UB2D_Prototype_SaveArmature( iArmature.i, sFileName.s )
Prototype   UB2D_Prototype_SaveTexture( iTexture.i, sFile.s, iFormat.i = #PB_ImagePlugin_PNG )
Prototype   UB2D_Prototype_ScaleArmature( iArmature.i, fScale.f )
Prototype   UB2D_Prototype_ScaleDrawingTransformation( X.f, Y.f, Z.f )
Prototype.i UB2D_Prototype_ScaleMesh( iMesh.i, X.f, Y.f, Z.f )
Prototype   UB2D_Prototype_ScaleMeshInstance( iMeshInstance.i, X.f, Y.f, Z.f )
Prototype   UB2D_Prototype_ScaleObject( iObject.i, X.f = #UB2D_IGNORE, Y.f = #UB2D_IGNORE, Z.f = #UB2D_IGNORE )
Prototype   UB2D_Prototype_ScaleObjectInstance( iObjectInstance.i, X.f = #UB2D_IGNORE, Y.f = #UB2D_IGNORE, Z.f = #UB2D_IGNORE )
Prototype   UB2D_Prototype_ScaleSprite( iSprite.i, fWidth.f = 1.0, fHeight.f = 1.0 )
Prototype.i UB2D_Prototype_SceneBlur()
Prototype.f UB2D_Prototype_SceneContrast()
Prototype.f UB2D_Prototype_SceneGamma()
Prototype.f UB2D_Prototype_SceneSaturation()
Prototype   UB2D_Prototype_ScreenClearColor( lColor.l )
Prototype.i UB2D_Prototype_ScreenContainerGadgetID()
Prototype.f UB2D_Prototype_ScreenGamma()
Prototype.i UB2D_Prototype_ScreenHeight()
Prototype.i UB2D_Prototype_ScreenShot( sName.s, iImageFormat.i = #PB_ImagePlugin_JPEG )
Prototype.i UB2D_Prototype_ScreenWidth()
Prototype.i UB2D_Prototype_ScreenWindowID()
Prototype   UB2D_Prototype_SetActiveGadget( iGadget.i = -1 )
Prototype   UB2D_Prototype_SetActiveWindow( iWindow.i )
Prototype   UB2D_Prototype_SetAmbientLightColor( iColor.i )
Prototype.f UB2D_Prototype_SetArmatureAnimationSpeed( iArmature.i, fSpeed.f )
Prototype.f UB2D_Prototype_SetArmatureAnimationTime( iArmature.i, fTime.f, *MeshInstance.UB2D_MESH_INSTANCE = #Null )
Prototype.i UB2D_Prototype_SetArmatureBoneOffset( iArmature.i, *Bone.UB2D_ARMATURE_BONE, fOffsetX.f = 0.0, fOffsetY.f = 0.0, fOffsetZ.f = 0.0 )
Prototype.i UB2D_Prototype_SetArmatureBoneRotation( iArmature.i, *Bone.UB2D_ARMATURE_BONE, X.f = 0.0, Y.f = 0.0, Z.f = 0.0, W.f = 1.0 )
Prototype.i UB2D_Prototype_SetArmatureBoneScaling( iArmature.i, *Bone.UB2D_ARMATURE_BONE, X.f = 1.0, Y.f = 1.0, Z.f = 1.0 )
Prototype.i UB2D_Prototype_SetArmatureFrameBoneOffset( iArmature.i, *Animation.UB2D_ARMATURE_ANIMATION, *Frame.UB2D_ARMATURE_ANIMATION_FRAME, *Bone.UB2D_ARMATURE_BONE, X.f, Y.f, Z.f, iInterpolation.i=#UB2D_ARMATURE_INTERPOLATION_LINEAR )
Prototype.i UB2D_Prototype_SetArmatureFrameBoneRotation( iArmature.i, *Animation.UB2D_ARMATURE_ANIMATION, *Frame.UB2D_ARMATURE_ANIMATION_FRAME, *Bone.UB2D_ARMATURE_BONE, X.f, Y.f, Z.f, W.f, iInterpolation.i=#UB2D_ARMATURE_INTERPOLATION_LINEAR )
Prototype.i UB2D_Prototype_SetArmatureFrameBoneScaling( iArmature.i, *Animation.UB2D_ARMATURE_ANIMATION, *Frame.UB2D_ARMATURE_ANIMATION_FRAME, *Bone.UB2D_ARMATURE_BONE, X.f, Y.f, Z.f, iInterpolation.i=#UB2D_ARMATURE_INTERPOLATION_LINEAR )
Prototype.i UB2D_Prototype_SetArmatureFrameTimePosition( iArmature.i, *Animation.UB2D_ARMATURE_ANIMATION, *Frame.UB2D_ARMATURE_ANIMATION_FRAME, fTimePosition.f )
Prototype   UB2D_Prototype_SetArmaturePosition( iArmature.i, X.f, Y.f, Z.f )
Prototype   UB2D_Prototype_SetArmatureRotation( iArmature.i, fRotation.f )
Prototype   UB2D_Prototype_SetArmatureScale( iArmature.i, fScale.f )
Prototype   UB2D_Prototype_SetCameraMatrix( iCamera.i, *m4fMatrix.UB2D_MATRIX4f )
Prototype   UB2D_Prototype_SetCameraPosition( iCamera.i, X.f, Y.f )
Prototype   UB2D_Prototype_SetCameraRotation( iCamera.i, fRotation.f )
Prototype.i UB2D_Prototype_SetColor( *v4fColor.UB2D_COLOR4f, lColor.l )
Prototype.i UB2D_Prototype_SetCurrentCamera( iCamera.i )
Prototype   UB2D_Prototype_SetCurrentCameraMatrix( *m4fMatrix.UB2D_MATRIX4f )
Prototype   UB2D_Prototype_SetCurrentCameraPosition( X.f, Y.f )
Prototype   UB2D_Prototype_SetCurrentCameraRotation( fRotation.f )
Prototype   UB2D_Prototype_SetCurrentCameraToDefault()
Prototype   UB2D_Prototype_SetDirectLightColor( iColor.i )
Prototype   UB2D_Prototype_SetDirectLightDirection( fRotation.f, fAngle.f )
Prototype   UB2D_Prototype_SetDirectLightDirectionVector( X.f, Y.f, Z.f )
Prototype   UB2D_Prototype_SetDirectLightIntensity( fIntensity.f )
Prototype   UB2D_Prototype_SetDrawingLineWidth( fLineWidth.f = 1.5 )
Prototype   UB2D_Prototype_SetDrawingTransformationMatrix( *m4fMatrix.UB2D_MATRIX4f )
Prototype   UB2D_Prototype_SetDrawingTransformationPosition( X.f, Y.f, Z.f )
Prototype   UB2D_Prototype_SetDrawingTransformationRotation( X.f, Y.f, Z.f )
Prototype   UB2D_Prototype_SetDrawingTransformationScale( X.f, Y.f, Z.f )
Prototype   UB2D_Prototype_SetEnvironmentMap( iTexture.i = #UB2D_DEFAULT )
Prototype   UB2D_Prototype_SetGadgetItemText( iGadget.i, iItem.i, sText.s )
Prototype   UB2D_Prototype_SetGadgetState( iGadget.i, iState.i )
Prototype   UB2D_Prototype_SetGadgetText( iGadget.i, sText.s )
Prototype   UB2D_Prototype_SetGadgetValue( iGadget.i, fValue.f )
Prototype   UB2D_Prototype_SetLightColor( iLight.i, iColor.i )
Prototype   UB2D_Prototype_SetLightConeAngle( iLight.i, fConeAngle.f )
Prototype   UB2D_Prototype_SetLightDirection( iLight.i, X.f, Y.f, Z.f )
Prototype   UB2D_Prototype_SetLightIntensity( iLight.i, fIntensity.f )
Prototype   UB2D_Prototype_SetLightPosition( iLight.i, X.f, Y.f, Z.f = #UB2D_IGNORE )
Prototype   UB2D_Prototype_SetLightPositionZ( iLight.i, Z.f )
Prototype   UB2D_Prototype_SetLightRange( iLight.i, fRange.f )
Prototype   UB2D_Prototype_SetLightRotation( iLight.i, fRotation.f, fAngle.f = 0.0)
Prototype   UB2D_Prototype_SetLightState( iLight.i, bState.i )
Prototype   UB2D_Prototype_SetLightType( iLight.i, iType.i )
Prototype   UB2D_Prototype_SetMaterialBlendingMode( iMaterial.i, lOutputMode.l = #UB2D_BLENDMODE_SRC_ALPHA, lTargetMode.l = #UB2D_BLENDMODE_ONE_MINUS_SRC_ALPHA )
Prototype   UB2D_Prototype_SetMaterialColor( iMaterial.i, iColor.i = $FFFFFFFF )
Prototype   UB2D_Prototype_SetMaterialDepthMask( iMaterial.i, bEnable.i = #True )
Prototype   UB2D_Prototype_SetMaterialEmission( iMaterial.i, fEmission.f = 0.0 )
Prototype   UB2D_Prototype_SetMaterialMetallic( iMaterial.i, fMetallic.f = 1.0 )
Prototype.i UB2D_Prototype_SetMaterialRenderCallback( *Material.UB2D_MATERIAL, *RenderCallback )
Prototype   UB2D_Prototype_SetMaterialRoughness( iMaterial.i, fRoughness.f = 1.0 )
Prototype   UB2D_Prototype_SetMaterialShader( iMaterial.i, iShader.i )
Prototype   UB2D_Prototype_SetMaterialSpecular( iMaterial.i, fSpecular.f = 1.0 )
Prototype   UB2D_Prototype_SetMaterialTexture( iMaterial.i, iIndex.i, iTexture.i = 0 )
Prototype   UB2D_Prototype_SetMaterialValue( iMaterial.i, iIndex.i, fValue.f = 0.0 )
Prototype   UB2D_Prototype_SetMaterialValues( iMaterial.i, fValue0.f = #UB2D_IGNORE, fValue1.f = #UB2D_IGNORE, fValue2.f = #UB2D_IGNORE ,fValue3.f = #UB2D_IGNORE )
Prototype   UB2D_Prototype_SetMeshFace( iMesh.i, iIndex.i, Vertex1.i, Vertex2.i, Vertex3.i )
Prototype.i UB2D_Prototype_SetMeshFaceCount( iMesh.i, iFaceCount.i )
Prototype.i UB2D_Prototype_SetMeshIndicesCount( iMesh.i, iIndicesCount.i )
Prototype   UB2D_Prototype_SetMeshInstanceBehaviour( iMeshInstance.i, bStatic.i )
Prototype   UB2D_Prototype_SetMeshInstanceDisplay( iMeshInstance.i, bDisplay.i = #True )
Prototype   UB2D_Prototype_SetMeshInstanceMatrix( iMeshInstance.i, *m4fMatrix.UB2D_MATRIX4f )
Prototype   UB2D_Prototype_SetMeshInstancePosition( iMeshInstance.i, X.f, Y.f, Z.f = #UB2D_IGNORE )
Prototype   UB2D_Prototype_SetMeshInstanceRotation( iMeshInstance.i, X.f, Y.f, Z.f )
Prototype   UB2D_Prototype_SetMeshInstanceScale( iMeshInstance.i, X.f, Y.f, Z.f )
Prototype   UB2D_Prototype_SetMeshNormal( iMesh.i, iIndex.i, X.f, Y.f, Z.f )
Prototype   UB2D_Prototype_SetMeshTexCoord( iMesh.i, iIndex.i, U.f, V.f )
Prototype   UB2D_Prototype_SetMeshVertex( iMesh.i, iIndex.i, X.f, Y.f, Z.f, W.f = 1.0 )
Prototype.i UB2D_Prototype_SetMeshVertexCount( iMesh.i, iVertexCount.i )
Prototype   UB2D_Prototype_SetMeshVertexGroup( iMesh.i, iIndex.i, iGroup.i = 0 )
Prototype   UB2D_Prototype_SetObjectInstanceBehaviour( iObjectInstance.i, bStatic.i )
Prototype   UB2D_Prototype_SetObjectInstancePosition(	iObjectInstance.i, X.f, Y.f, Z.f = #UB2D_IGNORE )
Prototype   UB2D_Prototype_SetObjectInstanceRotation( iObjectInstance.i, fRotation.f )
Prototype   UB2D_Prototype_SetObjectRotation( iObject.i, fRotation.f )
Prototype   UB2D_Prototype_SetSceneBlur( bEnable.i )
Prototype   UB2D_Prototype_SetSceneContrast( fContrast.f =  1.0 )
Prototype   UB2D_Prototype_SetSceneGamma( fGamma.f =  0.5 )
Prototype   UB2D_Prototype_SetSceneSaturation( fSaturation.f =  1.0 )
Prototype   UB2D_Prototype_SetScreenGamma( fGamma.f = 1.0 )
Prototype.i UB2D_Prototype_SetShaderRenderCallback( *Shader.UB2D_SHADER, *RenderCallback )
Prototype.i UB2D_Prototype_SetShaderUniform( iShader.i, iIndex.i, iType.i, sName.s, *Pointer.INTEGER = #Null, iPointerOffset.i = #Null, iSize.i = 1 )
Prototype.i UB2D_Prototype_SetShaderUniformFloat( iShader.i, iIndex.i, fFloat.f )
Prototype.i UB2D_Prototype_SetShaderUniformInteger( iShader.i, iIndex.i, iInteger.i )
Prototype.i UB2D_Prototype_SetShaderUniformMatrix3f( iShader.i, iIndex.i, *m3fMatrix.UB2D_MATRIX3f )
Prototype.i UB2D_Prototype_SetShaderUniformMatrix4f( iShader.i, iIndex.i, *m4fMatrix.UB2D_MATRIX4f )
Prototype.i UB2D_Prototype_SetShaderUniformPointer( iShader.i, iIndex.i, *Pointer.INTEGER, iPointerOffset.i = #Null, iSize.i = 1 )
Prototype.i UB2D_Prototype_SetShaderUniformSampler( iShader.i, iIndex.i, iSampler.i )
Prototype.i UB2D_Prototype_SetShaderUniformVector( iShader.i, iIndex.i, X.f = #UB2D_IGNORE, Y.f = #UB2D_IGNORE, Z.f = #UB2D_IGNORE, W.f = #UB2D_IGNORE )
Prototype.i UB2D_Prototype_SetShaderUniformVector2f( iShader.i, iIndex.i, *v2fVector.UB2D_VECTOR2f )
Prototype.i UB2D_Prototype_SetShaderUniformVector3f( iShader.i, iIndex.i, *v3fVector.UB2D_VECTOR3f )
Prototype.i UB2D_Prototype_SetShaderUniformVector4f( iShader.i, iIndex.i, *v4fVector.UB2D_VECTOR4f )
Prototype   UB2D_Prototype_SetSpriteDepth( iSprite.i, fDepth.f = 0.0 )
Prototype.i UB2D_Prototype_SetSpriteMaterial( iSprite.i, iMaterial.i )
Prototype   UB2D_Prototype_SetSpriteRotation( iSprite.i, fRotation.f )
Prototype   UB2D_Prototype_SetTextureFilter( iFilter.i = #UB2D_TEXTURE_FILTER_NONE )
Prototype   UB2D_Prototype_SetVolumetricLightDecay( fDecay.f )
Prototype   UB2D_Prototype_SetVolumetricLightDensity( fDensity.f )
Prototype   UB2D_Prototype_SetVolumetricLightMinimalExposure( fMinimalExposure.f )
Prototype   UB2D_Prototype_SetVolumetricLightSamples( iSamples.i )
Prototype   UB2D_Prototype_SetVolumetricLightState( bState.i )
Prototype   UB2D_Prototype_SetVolumetricLightWeight( fWeight.f )
Prototype   UB2D_Prototype_SetWindowBlur( bWindowBlur.i )
Prototype   UB2D_Prototype_SetWindowPosition( iWindow.i, X.i, Y.i )
Prototype   UB2D_Prototype_SetWindowTitle( sTitle.s )
Prototype.i UB2D_Prototype_Shader( sName.s )
Prototype.i UB2D_Prototype_ShaderID( iShader.i )
Prototype.i UB2D_Prototype_ShaderUniformIndex( iShader.i, sName.s )
Prototype   UB2D_Prototype_ShowGadget( iGadget.i, iState.i = #True )
Prototype   UB2D_Prototype_ShowMouse()
Prototype   UB2D_Prototype_ShowWindow( iWindow.i )
Prototype   UB2D_Prototype_SliderGadget( iGadget.i, X.i, Y.i, iWidth.i, fMax.f = 1.0, fMin.f = 0.0, fStep.f = 1.0 )
Prototype   UB2D_Prototype_SpinGadget( iGadget.i, X.i, Y.i, iWidth.i, fMax.f = 1.0, fMin.f = 0.0, fStep.f=1.0 )
Prototype.f UB2D_Prototype_SpriteDepth( iSprite.i )
Prototype   UB2D_Prototype_SpriteGadget( iGadget.i, X.i, Y.i, iWidth.i, iHeight.i, iSprite.i, iFlag.i = 0 )
Prototype.f UB2D_Prototype_SpriteHeight( iSprite.i )
Prototype.i UB2D_Prototype_SpriteID( iSprite.i )
Prototype.i UB2D_Prototype_SpriteMaterial( iSprite.i )
Prototype.f UB2D_Prototype_SpriteOriginX( iSprite.i )
Prototype.f UB2D_Prototype_SpriteOriginY( iSprite.i )
Prototype.f UB2D_Prototype_SpriteRotation( iSprite.i )
Prototype.f UB2D_Prototype_SpriteWidth( iSprite.i )
Prototype.i UB2D_Prototype_StopArmatureAnimation( iArmature.i, *MeshInstance.UB2D_MESH_INSTANCE = #Null )
Prototype   UB2D_Prototype_StringGadget( iGadget.i, X.i, Y.i, iWidth.i, iHeight.i, sText.s = "", iFlag.i = 0 )
Prototype   UB2D_Prototype_TextGadget( iGadget.i, X.i, Y.i, sText.s, iWidth.i = 0, iFlag.i = 0 )
Prototype.f UB2D_Prototype_TextHeight( iFont.i, sText.s, fSize.f = #UB2D_IGNORE )
Prototype.f UB2D_Prototype_TextWidth( iFont.i, sText.s, fSize.f = #UB2D_IGNORE )
Prototype.i UB2D_Prototype_Texture( sName.s )
Prototype.i UB2D_Prototype_TextureFilter()
Prototype.l UB2D_Prototype_TextureHeight( iTexture.i )
Prototype.i UB2D_Prototype_TextureID( iTexture.i )
Prototype.l UB2D_Prototype_TextureWidth( iTexture.i )
Prototype.f UB2D_Prototype_Time()
Prototype.f UB2D_Prototype_TimeFactor()
Prototype   UB2D_Prototype_TransformSprite( iSprite.i, X1.f, Y1.f, X2.f, Y2.f, X3.f, Y3.f, X4.f, Y4.f )
Prototype   UB2D_Prototype_UnclipMouse()
Prototype   UB2D_Prototype_UnlockMouse()
Prototype   UB2D_Prototype_UpdateDrawingBufferMatrix()
Prototype   UB2D_Prototype_UpdateMesh( iMesh.i )
Prototype   UB2D_Prototype_UpdateMeshInstanceMatrix( *MeshInstance.UB2D_MESH_INSTANCE )
Prototype.i UB2D_Prototype_UpdateObjectInstanceMatrix( *ObjectInstance.UB2D_OBJECT_INSTANCE )
Prototype   UB2D_Prototype_UpdateShaderBuffer( iBuffer.i )
Prototype   UB2D_Prototype_ViewDebugger()
Prototype.f UB2D_Prototype_VolumetricLightDecay()
Prototype.f UB2D_Prototype_VolumetricLightDensity()
Prototype.f UB2D_Prototype_VolumetricLightMinimalExposure()
Prototype.i UB2D_Prototype_VolumetricLightSamples()
Prototype.i UB2D_Prototype_VolumetricLightState()
Prototype.f UB2D_Prototype_VolumetricLightWeight()
Prototype   UB2D_Prototype_Warning( sText.s , iLibrary.i = #UB2D_NONE , sProcedure.s = "" )
Prototype.i UB2D_Prototype_WindowBlur()
Prototype.i UB2D_Prototype_WindowEvent()
Prototype.i UB2D_Prototype_WindowHeight( iWindow.i )
Prototype.i UB2D_Prototype_WindowID( iWindow.i )
Prototype.i UB2D_Prototype_WindowTitle()
Prototype.i UB2D_Prototype_WindowWidth( iWindow.i )
Prototype.i UB2D_Prototype_WorldMatrix( *m4fWorld.UB2D_MATRIX4f, *Header.UB2D_HEADER )
Prototype.i UB2D_Prototype_WriteTextureToMemory( iTexture.i )
Prototype   UB2D_Prototype_ZoomSprite( iSprite.i, iWidth.i = #UB2D_IGNORE, iHeight.i = #UB2D_IGNORE )
Prototype.f UB2D_Prototype_fClamp( Value.f, Min.f, Max.f )
Prototype.f UB2D_Prototype_fFloor( fValue.f, fWidth.f = 1.0 )
Prototype.f UB2D_Prototype_fMax( fValue1.f, fValue2.f, fValue3.f = -1e100)
Prototype.f UB2D_Prototype_fMin( fValue1.f, fValue2.f, fValue3.f = 1e100)
Prototype.f UB2D_Prototype_fRandom( fMaximum.f = 1.0, fMinimum.f = 0.0)
Prototype.f UB2D_Prototype_fRangeRandom( *Range.UB2D_RANGEf )
Prototype.f UB2D_Prototype_fSignPow(fBase.f, fExponent.f)
Prototype.i UB2D_Prototype_iClamp( Value.i, Min.i, Max.i )
Prototype.i UB2D_Prototype_iMax( fValue1.i, fValue2.i, fValue3.i = -$80000000)
Prototype.i UB2D_Prototype_iMin( fValue1.i, fValue2.i, fValue3.i = $7FFFFFFF)
Prototype.i UB2D_Prototype_m4fBias( *m4fTarget.UB2D_MATRIX4f )
Prototype.i UB2D_Prototype_m4fFromDirection( *m4fResult.UB2D_MATRIX4f, X.f, Y.f, Z.f, *v4fYawAxis.UB2D_VECTOR4f = #Null )
Prototype.i UB2D_Prototype_m4fFromPosition( *m4fResult.UB2D_MATRIX4f, X.f, Y.f, Z.f )
Prototype.i UB2D_Prototype_m4fFromPositionQuaternionScaling( *m4fResult.UB2D_MATRIX4f, *v4fPosition.UB2D_VECTOR4f, *qRotation.UB2D_QUATERNION, *v4fScaling.UB2D_VECTOR4f )
Prototype.i UB2D_Prototype_m4fFromRandomSolidAngle( *m4fTarget.UB2D_MATRIX4f, fAngle.f )
Prototype.i UB2D_Prototype_m4fFromRotation( *m4fResult.UB2D_MATRIX4f, Pitch.f, Yaw.f, Roll.f, iMode.i=#UB2D_DEGREE )
Prototype.i UB2D_Prototype_m4fFromScaling( *m4fResult.UB2D_MATRIX4f, Width.f, Height.f, Depth.f )
Prototype.i UB2D_Prototype_m4fFromTransformation( *m4fResult.UB2D_MATRIX4f, X.f, Y.f, Z.f, Pitch.f, Yaw.f, Roll.f, Width.f, Height.f, Depth.f, iMode.i=#UB2D_DEGREE )
Prototype.i UB2D_Prototype_m4fFromTransformationAlternative( *m4fResult.UB2D_MATRIX4f, X.f, Y.f, Z.f, Pitch.f, Yaw.f, Roll.f, Width.f, Height.f, Depth.f, iMode.i = #UB2D_DEGREE )
Prototype.i UB2D_Prototype_m4fFromVector4f( *m4fTarget.UB2D_MATRIX4f, *v4fSource.UB2D_VECTOR4f )
Prototype.i UB2D_Prototype_m4fFrustum( *m4fTarget.UB2D_MATRIX4f, iMode.i, fLeft.f, fRight.f, fTop.f, fBottom.f, fNear.f, fFar.f )
Prototype.i UB2D_Prototype_m4fFrustumOLD( *m4fTarget.UB2D_MATRIX4f, Mode.i, Left.f, Right.f, Bottom.f, Top.f, Near.f, Far.f )
Prototype.i UB2D_Prototype_m4fIdentity( *m4fOut.UB2D_MATRIX4f, fValue.f = 1.0 )
Prototype.i UB2D_Prototype_m4fInverse( *m4fInOut.UB2D_MATRIX4f )
Prototype.i UB2D_Prototype_m4fInversion( *m4fOut.UB2D_MATRIX4f, *m4fIn.UB2D_MATRIX4f )
Prototype.i UB2D_Prototype_m4fLookAt( *m4fTarget.UB2D_MATRIX4f, *Eye.UB2D_VECTOR3f, *Target.UB2D_VECTOR3f, *Up.UB2D_VECTOR3f = #Null )
Prototype.i UB2D_Prototype_m4fMultiplication( *m4fResult.UB2D_MATRIX4f, *m4fLeft.UB2D_MATRIX4f, *m4fRight.UB2D_MATRIX4f )
Prototype.i UB2D_Prototype_m4fMultiply( *m4fResultAndLeft.UB2D_MATRIX4f, *m4fRight.UB2D_MATRIX4f )
Prototype.i UB2D_Prototype_m4fPerspective( *m4fTarget.UB2D_MATRIX4f, FOV.f, Aspect.f, Near.f, Far.f )
Prototype.i UB2D_Prototype_m4fToMatrix3f( *m4fSource.UB2D_MATRIX4f, *m3fTarget.UB2D_MATRIX3f )
Prototype.i UB2D_Prototype_m4fToMatrix4x3f( *m4fSource.UB2D_MATRIX4f, *m3fTarget.UB2D_MATRIX4X3f )
Prototype.i UB2D_Prototype_m4fToQuaternion( *m4fSource.UB2D_MATRIX4f, *qResult.UB2D_QUATERNION )
Prototype.i UB2D_Prototype_m4fToScaling( *m4fSource.UB2D_MATRIX4f, *v4fResult.UB2D_VECTOR4f )
Prototype.i UB2D_Prototype_m4fToTransposedMatrix3f( *m4fSource.UB2D_MATRIX4f, *m3fTarget.UB2D_MATRIX3f )
Prototype.i UB2D_Prototype_m4fToVector4f( *m4fSource.UB2D_MATRIX4f, *v4fTarget.UB2D_VECTOR4f )
Prototype.i UB2D_Prototype_m4fTranspose( *m4fInOut.UB2D_MATRIX4f )
Prototype.i UB2D_Prototype_m4fTransposition( *m4fOut.UB2D_MATRIX4f, *m4fIn.UB2D_MATRIX4f )
Prototype.i UB2D_Prototype_m4fUnsign( *m4fTarget.UB2D_MATRIX4f, *m4fSource.UB2D_MATRIX4f )
Prototype.i UB2D_Prototype_qDivision( *qTarget.UB2D_QUATERNION, *qSource1.UB2D_QUATERNION, *qSource2.UB2D_QUATERNION )
Prototype.i UB2D_Prototype_qFromDirection( *qResult.UB2D_QUATERNION, X.f, Y.f, Z.f, *v4fYawAxis.UB2D_VECTOR4f = #Null )
Prototype.i UB2D_Prototype_qFromEuler( *qResult.UB2D_QUATERNION, Pitch.f, Yaw.f, Roll.f, Mode.i = #UB2D_DEGREE )
Prototype.i UB2D_Prototype_qIdentity( *qResult.UB2D_QUATERNION )
Prototype.i UB2D_Prototype_qInverse( *qResultAndOperand.UB2D_QUATERNION )
Prototype.i UB2D_Prototype_qInversion( *qResult.UB2D_QUATERNION, *qOperand.UB2D_QUATERNION )
Prototype.i UB2D_Prototype_qMultiplication( *qResult.UB2D_QUATERNION, *qLeftOperand.UB2D_QUATERNION, *qRightOperand.UB2D_QUATERNION )
Prototype.i UB2D_Prototype_qMultiply( *qResultAndLeftOperand.UB2D_QUATERNION, *qRightOperand.UB2D_QUATERNION )
Prototype.i UB2D_Prototype_qNormalization( *qResult.UB2D_QUATERNION, *qOperand.UB2D_QUATERNION )
Prototype.i UB2D_Prototype_qNormalize( *qResultAndOperand.UB2D_QUATERNION )
Prototype.i UB2D_Prototype_qSet( *qResult.UB2D_QUATERNION, X.f, Y.f, Z.f, W.f )
Prototype.i UB2D_Prototype_qStr( *qSource.UB2D_QUATERNION, sSeparator.s=", ", iDecimalDigits.i = 3 )
Prototype.i UB2D_Prototype_qToEuler( *qSource.UB2D_QUATERNION, *eResult.UB2D_EULER, Mode.i = #UB2D_DEGREE )
Prototype.i UB2D_Prototype_qToMatrix4f( *qSource.UB2D_QUATERNION, *m4fResult.UB2D_MATRIX4f )
Prototype.i UB2D_Prototype_v2fAdd( *v2fTarget.UB2D_VECTOR2f, *v2fSource.UB2D_VECTOR2f )
Prototype.i UB2D_Prototype_v2fAddition( *v2fTarget.UB2D_VECTOR2f, *v2fSource1.UB2D_VECTOR2f, *v2fSource2.UB2D_VECTOR2f )
Prototype.f UB2D_Prototype_v2fCrossing( *v2fSource1.UB2D_VECTOR2f, *v2fSource2.UB2D_VECTOR2f )
Prototype.f UB2D_Prototype_v2fDistance( *v2fSource1.UB2D_VECTOR2f, *v2fSource2.UB2D_VECTOR2f )
Prototype.f UB2D_Prototype_v2fDot( *v2fSource1.UB2D_VECTOR2f, *v2fSource2.UB2D_VECTOR2f )
Prototype.f UB2D_Prototype_v2fLength( *v2fSource.UB2D_VECTOR2f )
Prototype.i UB2D_Prototype_v2fNormalize( *v2fTarget.UB2D_VECTOR2f )
Prototype.i UB2D_Prototype_v2fScale( *v2fTarget.UB2D_VECTOR2f, fValue.f )
Prototype.i UB2D_Prototype_v2fSet( *v2fTarget.UB2D_VECTOR2f, X.f, Y.f )
Prototype.i UB2D_Prototype_v2fSubtract( *v2fTarget.UB2D_VECTOR2f, *v2fSource.UB2D_VECTOR2f )
Prototype.i UB2D_Prototype_v2fSubtraction( *v2fTarget.UB2D_VECTOR2f, *v2fSource1.UB2D_VECTOR2f, *v2fSource2.UB2D_VECTOR2f )
Prototype.i UB2D_Prototype_v2iAdd( *v2iTarget.UB2D_VECTOR2i, *v2iSource.UB2D_VECTOR2i )
Prototype.i UB2D_Prototype_v2iAddition( *v2iTarget.UB2D_VECTOR2i, *v2iSource1.UB2D_VECTOR2i, *v2iSource2.UB2D_VECTOR2i )
Prototype.i UB2D_Prototype_v2iCrossing( *v2iSource1.UB2D_VECTOR2i, *v2iSource2.UB2D_VECTOR2i )
Prototype.i UB2D_Prototype_v2iDistance( *v2iSource1.UB2D_VECTOR2i, *v2iSource2.UB2D_VECTOR2i )
Prototype.i UB2D_Prototype_v2iDot( *v2iSource1.UB2D_VECTOR2i, *v2iSource2.UB2D_VECTOR2i )
Prototype.i UB2D_Prototype_v2iLength( *v2iSource.UB2D_VECTOR2i )
Prototype.i UB2D_Prototype_v2iNormalize( *v2iTarget.UB2D_VECTOR2i )
Prototype.i UB2D_Prototype_v2iScale( *v2iTarget.UB2D_VECTOR2i, iValue.i )
Prototype.i UB2D_Prototype_v2iSet( *v2lTarget.UB2D_VECTOR2i, X.i, Y.i )
Prototype.i UB2D_Prototype_v2iSubtract( *v2iTarget.UB2D_VECTOR2i, *v2iSource.UB2D_VECTOR2i )
Prototype.i UB2D_Prototype_v2iSubtraction( *v2iTarget.UB2D_VECTOR2i, *v2iSource1.UB2D_VECTOR2i, *v2iSource2.UB2D_VECTOR2i )
Prototype.i UB2D_Prototype_v3fAdd( *v3fTarget.UB2D_VECTOR3f, *v3fSource.UB2D_VECTOR3f )
Prototype.i UB2D_Prototype_v3fAddition( *v3fTarget.UB2D_VECTOR3f, *v3fSource1.UB2D_VECTOR3f, *v3fSource2.UB2D_VECTOR3f )
Prototype.i UB2D_Prototype_v3fCrossing( *v3fTarget.UB2D_VECTOR3f, *v3fSource1.UB2D_VECTOR3f, *v3fSource2.UB2D_VECTOR3f )
Prototype.f UB2D_Prototype_v3fDistance( *v3fSource1.UB2D_VECTOR3f, *v3fSource2.UB2D_VECTOR3f )
Prototype.f UB2D_Prototype_v3fDot( *v3fSource1.UB2D_VECTOR3f, *v3fSource2.UB2D_VECTOR3f )
Prototype.f UB2D_Prototype_v3fLength( *v3fSource.UB2D_VECTOR3f )
Prototype.i UB2D_Prototype_v3fMultiplyByMatrix4f( *v3fTarget.UB2D_VECTOR3f, *m4fSource.UB2D_MATRIX4f )
Prototype.i UB2D_Prototype_v3fNormalFormVertices( *v3fTarget.UB2D_VECTOR3f, *v3fVertex1.UB2D_VECTOR3f, *v3fVertex2.UB2D_VECTOR3f, *v3fVertex3.UB2D_VECTOR3f )
Prototype.i UB2D_Prototype_v3fNormalize( *v3fTarget.UB2D_VECTOR3f )
Prototype.i UB2D_Prototype_v3fScale( *v3fTarget.UB2D_VECTOR3f, fValue.f )
Prototype.i UB2D_Prototype_v3fSet( *v3fTarget.UB2D_VECTOR3f, X.f, Y.f, Z.f )
Prototype.f UB2D_Prototype_v3fSqrDistance( *v3fSource1.UB2D_VECTOR3f, *v3fSource2.UB2D_VECTOR3f )
Prototype.i UB2D_Prototype_v3fStr( *v3fTarget.UB2D_VECTOR4f, sSeparator.s=", " )
Prototype.i UB2D_Prototype_v3fSubtract( *v3fTarget.UB2D_VECTOR3f, *v3fSource.UB2D_VECTOR3f )
Prototype.i UB2D_Prototype_v3fSubtraction( *v3fTarget.UB2D_VECTOR3f, *v3fSource1.UB2D_VECTOR3f, *v3fSource2.UB2D_VECTOR3f )
Prototype.f UB2D_Prototype_v3fTangentFormVertices( *v3fTarget.UB2D_VECTOR3f, *v3fVertex1.UB2D_VECTOR3f, *v3fVertex2.UB2D_VECTOR3f, *v3fVertex3.UB2D_VECTOR3f, *v2fTex1.UB2D_VECTOR2f, *v2fTex2.UB2D_VECTOR2f, *v2fTex3.UB2D_VECTOR2f )
Prototype.i UB2D_Prototype_v4fAbs( *v4fInOut.UB2D_VECTOR4f )
Prototype.i UB2D_Prototype_v4fAdd( *v4fInOut.UB2D_VECTOR4f, *v4fIn.UB2D_VECTOR4f )
Prototype.i UB2D_Prototype_v4fAddition( *v4fOut.UB2D_VECTOR4f, *v4fInLeft.UB2D_VECTOR4f, *v4fInRight.UB2D_VECTOR4f )
Prototype.f UB2D_Prototype_v4fAngle( *v4fInLeft.UB2D_VECTOR4f, *v4fInRight.UB2D_VECTOR4f, iMode.i=#UB2D_DEGREE )
Prototype.i UB2D_Prototype_v4fChange( *v4fInOut.UB2D_VECTOR4f, *v4fIn.UB2D_VECTOR4f, fFactor.f )
Prototype.i UB2D_Prototype_v4fCopy( *v4fOut.UB2D_VECTOR4f, *v4fIn.UB2D_VECTOR4f )
Prototype.i UB2D_Prototype_v4fCross( *v4fInLeftOut.UB2D_VECTOR4f, *v4fInRight.UB2D_VECTOR4f )
Prototype.i UB2D_Prototype_v4fCrossing( *v4fOut.UB2D_VECTOR4f, *v4fInLeft.UB2D_VECTOR4f, *v4fInRight.UB2D_VECTOR4f )
Prototype.f UB2D_Prototype_v4fDistance( *v4fSource1.UB2D_VECTOR4f, *v4fSource2.UB2D_VECTOR4f )
Prototype.i UB2D_Prototype_v4fDivide( *v4fOut.UB2D_VECTOR4f, *v4fIn.UB2D_VECTOR4f )
Prototype.i UB2D_Prototype_v4fDivision( *v4fOut.UB2D_VECTOR4f, *v4fInLeft.UB2D_VECTOR4f, *v4fInRight.UB2D_VECTOR4f )
Prototype.f UB2D_Prototype_v4fDot( *v4fInLeft.UB2D_VECTOR4f, *v4fInRight.UB2D_VECTOR4f = #Null, *m4fMatrix.UB2D_MATRIX4f = #Null )
Prototype.i UB2D_Prototype_v4fEqual( *v4fInLeft.UB2D_VECTOR4f, *v4fInRight.UB2D_VECTOR4f )
Prototype.i UB2D_Prototype_v4fInverse( *v4fResultAndOperand.UB2D_VECTOR4f )
Prototype.i UB2D_Prototype_v4fInversion( *v4fResult.UB2D_VECTOR4f, *v4fOperand.UB2D_VECTOR4f )
Prototype.f UB2D_Prototype_v4fLength( *v4fIn.UB2D_VECTOR4f )
Prototype.i UB2D_Prototype_v4fMultiplikation( *v4fOut.UB2D_VECTOR4f, *v4fInLeft.UB2D_VECTOR4f, *v4fInRight.UB2D_VECTOR4f )
Prototype.i UB2D_Prototype_v4fMultiplikationByMatrix4f( *v4fOut.UB2D_VECTOR4f, *m4fInLeft.UB2D_MATRIX4f, *v4fInRight.UB2D_VECTOR4f )
Prototype.i UB2D_Prototype_v4fMultiply( *v4fOut.UB2D_VECTOR4f, *v4fIn.UB2D_VECTOR4f )
Prototype.i UB2D_Prototype_v4fMultiplyByMatrix4f( *v4fInOut.UB2D_VECTOR4f, *m4fIn.UB2D_MATRIX4f )
Prototype.i UB2D_Prototype_v4fNormalization( *v4fOut.UB2D_VECTOR4f, *v4fIn.UB2D_VECTOR4f )
Prototype.i UB2D_Prototype_v4fNormalize( *v4fInOut.UB2D_VECTOR4f )
Prototype.i UB2D_Prototype_v4fPeek( iOffset.i = 0 )
Prototype.i UB2D_Prototype_v4fPop( iCount.i = 1 )
Prototype.i UB2D_Prototype_v4fPush( X.f = 0, Y.f = 0, Z.f = 0, W.f = 1.0 )
Prototype.i UB2D_Prototype_v4fPushCopy( *v4fIn.UB2D_VECTOR4f )
Prototype.i UB2D_Prototype_v4fScale( *v4fInOut.UB2D_VECTOR4f, fValue.f )
Prototype.i UB2D_Prototype_v4fScaling( *v4fOut.UB2D_VECTOR4f, *v4fIn.UB2D_VECTOR4f, fValue.f )
Prototype.i UB2D_Prototype_v4fSet( *v4fOut.UB2D_VECTOR4f, X.f, Y.f, Z.f, W.f )
Prototype.i UB2D_Prototype_v4fStr( *v4fTarget.UB2D_VECTOR4f, sSeparator.s = ", ", iDecimalDigits.i = 3 )
Prototype.i UB2D_Prototype_v4fSubtract( *v4fInOut.UB2D_VECTOR4f, *v4fIn.UB2D_VECTOR4f )
Prototype.i UB2D_Prototype_v4fSubtraction( *v4fOut.UB2D_VECTOR4f, *v4fInLeft.UB2D_VECTOR4f, *v4fInRight.UB2D_VECTOR4f )
Prototype.i UB2D_Prototype_v4fTangential( *v4fOut.UB2D_VECTOR4f, *v4fInVector.UB2D_VECTOR4f, *v4fInNormal.UB2D_VECTOR4f )
Prototype.i UB2D_Prototype_v4fToMatrix4f( *v4fSource.UB2D_VECTOR4f, *m4fResult.UB2D_MATRIX4f, *v4fYawAxis.UB2D_VECTOR4f = #Null )
Prototype.i UB2D_Prototype_v4fToQuaternion( *v4fSource.UB2D_VECTOR4f, *qResult.UB2D_QUATERNION, *v4fYawAxis.UB2D_VECTOR4f = #Null )

;</Library Prototypes>

;</Library Procedures>

Procedure.i InitUnionBytes2DEngine( iFlags.i = #UB2D_ENGINE_RELEASE )
	
	Protected iLibrary.i
	
	If iFlags & #UB2D_ENGINE_DEBUG 
		iLibrary.i = OpenLibrary(#PB_Any, "UB2D_d.dll")
	Else
		iLibrary.i = OpenLibrary(#PB_Any, "UB2D.dll")
	EndIf
	
	If iLibrary
		
		Global UB2D_ASync.UB2D_Prototype_ASync = GetFunction(iLibrary, "UB2D_ASync")
		Global UB2D_AddArmatureAnimation.UB2D_Prototype_AddArmatureAnimation = GetFunction(iLibrary, "UB2D_AddArmatureAnimation")
		Global UB2D_AddArmatureBone.UB2D_Prototype_AddArmatureBone = GetFunction(iLibrary, "UB2D_AddArmatureBone")
		Global UB2D_AddArmatureFrame.UB2D_Prototype_AddArmatureFrame = GetFunction(iLibrary, "UB2D_AddArmatureFrame")
		Global UB2D_AddGadgetItem.UB2D_Prototype_AddGadgetItem = GetFunction(iLibrary, "UB2D_AddGadgetItem")
		Global UB2D_AddMeshCubeData.UB2D_Prototype_AddMeshCubeData = GetFunction(iLibrary, "UB2D_AddMeshCubeData")
		Global UB2D_AddMeshData.UB2D_Prototype_AddMeshData = GetFunction(iLibrary, "UB2D_AddMeshData")
		Global UB2D_AddMeshFaceData.UB2D_Prototype_AddMeshFaceData = GetFunction(iLibrary, "UB2D_AddMeshFaceData")
		Global UB2D_AddMeshInstance.UB2D_Prototype_AddMeshInstance = GetFunction(iLibrary, "UB2D_AddMeshInstance")
		Global UB2D_AddMeshVertexGroup.UB2D_Prototype_AddMeshVertexGroup = GetFunction(iLibrary, "UB2D_AddMeshVertexGroup")
		Global UB2D_AddObjectInstance.UB2D_Prototype_AddObjectInstance = GetFunction(iLibrary, "UB2D_AddObjectInstance")
		Global UB2D_AddRenderTreeMaterial.UB2D_Prototype_AddRenderTreeMaterial = GetFunction(iLibrary, "UB2D_AddRenderTreeMaterial")
		Global UB2D_AddRenderTreeMeshInstance.UB2D_Prototype_AddRenderTreeMeshInstance = GetFunction(iLibrary, "UB2D_AddRenderTreeMeshInstance")
		Global UB2D_AddRenderTreeObjectInstance.UB2D_Prototype_AddRenderTreeObjectInstance = GetFunction(iLibrary, "UB2D_AddRenderTreeObjectInstance")
		Global UB2D_AddRenderTreeShader.UB2D_Prototype_AddRenderTreeShader = GetFunction(iLibrary, "UB2D_AddRenderTreeShader")
		Global UB2D_AddSimpleMeshFaceData.UB2D_Prototype_AddSimpleMeshFaceData = GetFunction(iLibrary, "UB2D_AddSimpleMeshFaceData")
		Global UB2D_AddTextureToTextureArray.UB2D_Prototype_AddTextureToTextureArray = GetFunction(iLibrary, "UB2D_AddTextureToTextureArray")
		Global UB2D_AmbientLightColor.UB2D_Prototype_AmbientLightColor = GetFunction(iLibrary, "UB2D_AmbientLightColor")
		Global UB2D_ArcSin.UB2D_Prototype_ArcSin = GetFunction(iLibrary, "UB2D_ArcSin")
		Global UB2D_ArmatureAnimation.UB2D_Prototype_ArmatureAnimation = GetFunction(iLibrary, "UB2D_ArmatureAnimation")
		Global UB2D_ArmatureBone.UB2D_Prototype_ArmatureBone = GetFunction(iLibrary, "UB2D_ArmatureBone")
		Global UB2D_ArmatureBoneID.UB2D_Prototype_ArmatureBoneID = GetFunction(iLibrary, "UB2D_ArmatureBoneID")
		Global UB2D_ArmatureID.UB2D_Prototype_ArmatureID = GetFunction(iLibrary, "UB2D_ArmatureID")
		Global UB2D_Attach.UB2D_Prototype_Attach = GetFunction(iLibrary, "UB2D_Attach")
		Global UB2D_BindCameraProjectionMatrix.UB2D_Prototype_BindCameraProjectionMatrix = GetFunction(iLibrary, "UB2D_BindCameraProjectionMatrix")
		Global UB2D_BindCurrentCameraProjectionMatrix.UB2D_Prototype_BindCurrentCameraProjectionMatrix = GetFunction(iLibrary, "UB2D_BindCurrentCameraProjectionMatrix")
		Global UB2D_BindFrameBuffer.UB2D_Prototype_BindFrameBuffer = GetFunction(iLibrary, "UB2D_BindFrameBuffer")
		Global UB2D_BindMaterial.UB2D_Prototype_BindMaterial = GetFunction(iLibrary, "UB2D_BindMaterial")
		Global UB2D_BindShader.UB2D_Prototype_BindShader = GetFunction(iLibrary, "UB2D_BindShader")
		Global UB2D_ButtonGadget.UB2D_Prototype_ButtonGadget = GetFunction(iLibrary, "UB2D_ButtonGadget")
		Global UB2D_CalculateMeshTangents.UB2D_Prototype_CalculateMeshTangents = GetFunction(iLibrary, "UB2D_CalculateMeshTangents")
		Global UB2D_Camera.UB2D_Prototype_Camera = GetFunction(iLibrary, "UB2D_Camera")
		Global UB2D_CameraFar.UB2D_Prototype_CameraFar = GetFunction(iLibrary, "UB2D_CameraFar")
		Global UB2D_CameraID.UB2D_Prototype_CameraID = GetFunction(iLibrary, "UB2D_CameraID")
		Global UB2D_CameraInvMatrix.UB2D_Prototype_CameraInvMatrix = GetFunction(iLibrary, "UB2D_CameraInvMatrix")
		Global UB2D_CameraMatrix.UB2D_Prototype_CameraMatrix = GetFunction(iLibrary, "UB2D_CameraMatrix")
		Global UB2D_CameraNear.UB2D_Prototype_CameraNear = GetFunction(iLibrary, "UB2D_CameraNear")
		Global UB2D_CameraPositionX.UB2D_Prototype_CameraPositionX = GetFunction(iLibrary, "UB2D_CameraPositionX")
		Global UB2D_CameraPositionY.UB2D_Prototype_CameraPositionY = GetFunction(iLibrary, "UB2D_CameraPositionY")
		Global UB2D_CameraRotation.UB2D_Prototype_CameraRotation = GetFunction(iLibrary, "UB2D_CameraRotation")
		Global UB2D_CatchFont.UB2D_Prototype_CatchFont = GetFunction(iLibrary, "UB2D_CatchFont")
		Global UB2D_CatchJSON.UB2D_Prototype_CatchJSON = GetFunction(iLibrary, "UB2D_CatchJSON")
		Global UB2D_CatchShader.UB2D_Prototype_CatchShader = GetFunction(iLibrary, "UB2D_CatchShader")
		Global UB2D_CatchTexture.UB2D_Prototype_CatchTexture = GetFunction(iLibrary, "UB2D_CatchTexture")
		Global UB2D_CheckBoxGadget.UB2D_Prototype_CheckBoxGadget = GetFunction(iLibrary, "UB2D_CheckBoxGadget")
		Global UB2D_ClearGadgetItems.UB2D_Prototype_ClearGadgetItems = GetFunction(iLibrary, "UB2D_ClearGadgetItems")
		Global UB2D_ClearMouse.UB2D_Prototype_ClearMouse = GetFunction(iLibrary, "UB2D_ClearMouse")
		Global UB2D_ClipMouse.UB2D_Prototype_ClipMouse = GetFunction(iLibrary, "UB2D_ClipMouse")
		Global UB2D_ClipObject.UB2D_Prototype_ClipObject = GetFunction(iLibrary, "UB2D_ClipObject")
		Global UB2D_ClipSprite.UB2D_Prototype_ClipSprite = GetFunction(iLibrary, "UB2D_ClipSprite")
		Global UB2D_CloseEngineControl.UB2D_Prototype_CloseEngineControl = GetFunction(iLibrary, "UB2D_CloseEngineControl")
		Global UB2D_CloseGadgetList.UB2D_Prototype_CloseGadgetList = GetFunction(iLibrary, "UB2D_CloseGadgetList")
		Global UB2D_Color.UB2D_Prototype_Color = GetFunction(iLibrary, "UB2D_Color")
		Global UB2D_ContainerGadget.UB2D_Prototype_ContainerGadget = GetFunction(iLibrary, "UB2D_ContainerGadget")
		Global UB2D_ConvertTextureToImage.UB2D_Prototype_ConvertTextureToImage = GetFunction(iLibrary, "UB2D_ConvertTextureToImage")
		Global UB2D_CopyFont.UB2D_Prototype_CopyFont = GetFunction(iLibrary, "UB2D_CopyFont")
		Global UB2D_CopyMaterial.UB2D_Prototype_CopyMaterial = GetFunction(iLibrary, "UB2D_CopyMaterial")
		Global UB2D_CountGadgetItems.UB2D_Prototype_CountGadgetItems = GetFunction(iLibrary, "UB2D_CountGadgetItems")
		Global UB2D_CreateArmature.UB2D_Prototype_CreateArmature = GetFunction(iLibrary, "UB2D_CreateArmature")
		Global UB2D_CreateCamera.UB2D_Prototype_CreateCamera = GetFunction(iLibrary, "UB2D_CreateCamera")
		Global UB2D_CreateClippedObject.UB2D_Prototype_CreateClippedObject = GetFunction(iLibrary, "UB2D_CreateClippedObject")
		Global UB2D_CreateClippedSprite.UB2D_Prototype_CreateClippedSprite = GetFunction(iLibrary, "UB2D_CreateClippedSprite")
		Global UB2D_CreateCubeMesh.UB2D_Prototype_CreateCubeMesh = GetFunction(iLibrary, "UB2D_CreateCubeMesh")
		Global UB2D_CreateEmptySprite.UB2D_Prototype_CreateEmptySprite = GetFunction(iLibrary, "UB2D_CreateEmptySprite")
		Global UB2D_CreateEmptyTexture.UB2D_Prototype_CreateEmptyTexture = GetFunction(iLibrary, "UB2D_CreateEmptyTexture")
		Global UB2D_CreateInvertSphereMesh.UB2D_Prototype_CreateInvertSphereMesh = GetFunction(iLibrary, "UB2D_CreateInvertSphereMesh")
		Global UB2D_CreateLight.UB2D_Prototype_CreateLight = GetFunction(iLibrary, "UB2D_CreateLight")
		Global UB2D_CreateMaterial.UB2D_Prototype_CreateMaterial = GetFunction(iLibrary, "UB2D_CreateMaterial")
		Global UB2D_CreateMesh.UB2D_Prototype_CreateMesh = GetFunction(iLibrary, "UB2D_CreateMesh")
		Global UB2D_CreateObject.UB2D_Prototype_CreateObject = GetFunction(iLibrary, "UB2D_CreateObject")
		Global UB2D_CreatePlaneMesh.UB2D_Prototype_CreatePlaneMesh = GetFunction(iLibrary, "UB2D_CreatePlaneMesh")
		Global UB2D_CreateSphereMesh.UB2D_Prototype_CreateSphereMesh = GetFunction(iLibrary, "UB2D_CreateSphereMesh")
		Global UB2D_CreateSprite.UB2D_Prototype_CreateSprite = GetFunction(iLibrary, "UB2D_CreateSprite")
		Global UB2D_CreateSquarePlaneMesh.UB2D_Prototype_CreateSquarePlaneMesh = GetFunction(iLibrary, "UB2D_CreateSquarePlaneMesh")
		Global UB2D_CreateTexture.UB2D_Prototype_CreateTexture = GetFunction(iLibrary, "UB2D_CreateTexture")
		Global UB2D_CreateTextureArray.UB2D_Prototype_CreateTextureArray = GetFunction(iLibrary, "UB2D_CreateTextureArray")
		Global UB2D_CreateTextureArrayFromTO.UB2D_Prototype_CreateTextureArrayFromTO = GetFunction(iLibrary, "UB2D_CreateTextureArrayFromTO")
		Global UB2D_CreateTextureFromTO.UB2D_Prototype_CreateTextureFromTO = GetFunction(iLibrary, "UB2D_CreateTextureFromTO")
		Global UB2D_CreateTriangleMesh.UB2D_Prototype_CreateTriangleMesh = GetFunction(iLibrary, "UB2D_CreateTriangleMesh")
		Global UB2D_CreateWindow.UB2D_Prototype_CreateWindow = GetFunction(iLibrary, "UB2D_CreateWindow")
		Global UB2D_CurrentArmatureAnimation.UB2D_Prototype_CurrentArmatureAnimation = GetFunction(iLibrary, "UB2D_CurrentArmatureAnimation")
		Global UB2D_CurrentCamera.UB2D_Prototype_CurrentCamera = GetFunction(iLibrary, "UB2D_CurrentCamera")
		Global UB2D_CurrentCameraFar.UB2D_Prototype_CurrentCameraFar = GetFunction(iLibrary, "UB2D_CurrentCameraFar")
		Global UB2D_CurrentCameraInvMatrix.UB2D_Prototype_CurrentCameraInvMatrix = GetFunction(iLibrary, "UB2D_CurrentCameraInvMatrix")
		Global UB2D_CurrentCameraMatrix.UB2D_Prototype_CurrentCameraMatrix = GetFunction(iLibrary, "UB2D_CurrentCameraMatrix")
		Global UB2D_CurrentCameraNear.UB2D_Prototype_CurrentCameraNear = GetFunction(iLibrary, "UB2D_CurrentCameraNear")
		Global UB2D_CurrentCameraPositionX.UB2D_Prototype_CurrentCameraPositionX = GetFunction(iLibrary, "UB2D_CurrentCameraPositionX")
		Global UB2D_CurrentCameraPositionY.UB2D_Prototype_CurrentCameraPositionY = GetFunction(iLibrary, "UB2D_CurrentCameraPositionY")
		Global UB2D_CurrentCameraRotation.UB2D_Prototype_CurrentCameraRotation = GetFunction(iLibrary, "UB2D_CurrentCameraRotation")
		Global UB2D_Debug.UB2D_Prototype_Debug = GetFunction(iLibrary, "UB2D_Debug")
		Global UB2D_DebugSystemInformation.UB2D_Prototype_DebugSystemInformation = GetFunction(iLibrary, "UB2D_DebugSystemInformation")
		Global UB2D_DefaultShaderID.UB2D_Prototype_DefaultShaderID = GetFunction(iLibrary, "UB2D_DefaultShaderID")
		Global UB2D_DeleteAllMeshInstanceFromMesh.UB2D_Prototype_DeleteAllMeshInstanceFromMesh = GetFunction(iLibrary, "UB2D_DeleteAllMeshInstanceFromMesh")
		Global UB2D_DeleteMeshInstance.UB2D_Prototype_DeleteMeshInstance = GetFunction(iLibrary, "UB2D_DeleteMeshInstance")
		Global UB2D_DeleteObjectInstance.UB2D_Prototype_DeleteObjectInstance = GetFunction(iLibrary, "UB2D_DeleteObjectInstance")
		Global UB2D_DeleteRenderTreeMaterial.UB2D_Prototype_DeleteRenderTreeMaterial = GetFunction(iLibrary, "UB2D_DeleteRenderTreeMaterial")
		Global UB2D_DeleteRenderTreeMeshInstance.UB2D_Prototype_DeleteRenderTreeMeshInstance = GetFunction(iLibrary, "UB2D_DeleteRenderTreeMeshInstance")
		Global UB2D_DeleteRenderTreeObjectInstance.UB2D_Prototype_DeleteRenderTreeObjectInstance = GetFunction(iLibrary, "UB2D_DeleteRenderTreeObjectInstance")
		Global UB2D_DeleteRenderTreeShader.UB2D_Prototype_DeleteRenderTreeShader = GetFunction(iLibrary, "UB2D_DeleteRenderTreeShader")
		Global UB2D_DirectLightColor.UB2D_Prototype_DirectLightColor = GetFunction(iLibrary, "UB2D_DirectLightColor")
		Global UB2D_DirectLightIntensity.UB2D_Prototype_DirectLightIntensity = GetFunction(iLibrary, "UB2D_DirectLightIntensity")
		Global UB2D_DisableGadget.UB2D_Prototype_DisableGadget = GetFunction(iLibrary, "UB2D_DisableGadget")
		Global UB2D_DisplayArmature.UB2D_Prototype_DisplayArmature = GetFunction(iLibrary, "UB2D_DisplayArmature")
		Global UB2D_DisplayDrawingBuffer.UB2D_Prototype_DisplayDrawingBuffer = GetFunction(iLibrary, "UB2D_DisplayDrawingBuffer")
		Global UB2D_DisplayGUI.UB2D_Prototype_DisplayGUI = GetFunction(iLibrary, "UB2D_DisplayGUI")
		Global UB2D_DisplayObject.UB2D_Prototype_DisplayObject = GetFunction(iLibrary, "UB2D_DisplayObject")
		Global UB2D_DisplaySprite.UB2D_Prototype_DisplaySprite = GetFunction(iLibrary, "UB2D_DisplaySprite")
		Global UB2D_DisplaySpriteWithoutBindings.UB2D_Prototype_DisplaySpriteWithoutBindings = GetFunction(iLibrary, "UB2D_DisplaySpriteWithoutBindings")
		Global UB2D_DisplayText.UB2D_Prototype_DisplayText = GetFunction(iLibrary, "UB2D_DisplayText")
		Global UB2D_Draw2DBox.UB2D_Prototype_Draw2DBox = GetFunction(iLibrary, "UB2D_Draw2DBox")
		Global UB2D_Draw2DCircle.UB2D_Prototype_Draw2DCircle = GetFunction(iLibrary, "UB2D_Draw2DCircle")
		Global UB2D_Draw2DCross.UB2D_Prototype_Draw2DCross = GetFunction(iLibrary, "UB2D_Draw2DCross")
		Global UB2D_Draw2DLine.UB2D_Prototype_Draw2DLine = GetFunction(iLibrary, "UB2D_Draw2DLine")
		Global UB2D_Draw2DTrianle.UB2D_Prototype_Draw2DTrianle = GetFunction(iLibrary, "UB2D_Draw2DTrianle")
		Global UB2D_Draw2DVectorBox.UB2D_Prototype_Draw2DVectorBox = GetFunction(iLibrary, "UB2D_Draw2DVectorBox")
		Global UB2D_Draw2DVectorCircle.UB2D_Prototype_Draw2DVectorCircle = GetFunction(iLibrary, "UB2D_Draw2DVectorCircle")
		Global UB2D_Draw2DVectorCross.UB2D_Prototype_Draw2DVectorCross = GetFunction(iLibrary, "UB2D_Draw2DVectorCross")
		Global UB2D_Draw2DVectorLine.UB2D_Prototype_Draw2DVectorLine = GetFunction(iLibrary, "UB2D_Draw2DVectorLine")
		Global UB2D_Draw2DVectorTrianle.UB2D_Prototype_Draw2DVectorTrianle = GetFunction(iLibrary, "UB2D_Draw2DVectorTrianle")
		Global UB2D_Draw3DAxes.UB2D_Prototype_Draw3DAxes = GetFunction(iLibrary, "UB2D_Draw3DAxes")
		Global UB2D_Draw3DBox.UB2D_Prototype_Draw3DBox = GetFunction(iLibrary, "UB2D_Draw3DBox")
		Global UB2D_Draw3DCross.UB2D_Prototype_Draw3DCross = GetFunction(iLibrary, "UB2D_Draw3DCross")
		Global UB2D_Draw3DLine.UB2D_Prototype_Draw3DLine = GetFunction(iLibrary, "UB2D_Draw3DLine")
		Global UB2D_Draw3DSphere.UB2D_Prototype_Draw3DSphere = GetFunction(iLibrary, "UB2D_Draw3DSphere")
		Global UB2D_Draw3DTrianle.UB2D_Prototype_Draw3DTrianle = GetFunction(iLibrary, "UB2D_Draw3DTrianle")
		Global UB2D_Draw3DVectorBox.UB2D_Prototype_Draw3DVectorBox = GetFunction(iLibrary, "UB2D_Draw3DVectorBox")
		Global UB2D_Draw3DVectorCross.UB2D_Prototype_Draw3DVectorCross = GetFunction(iLibrary, "UB2D_Draw3DVectorCross")
		Global UB2D_Draw3DVectorLine.UB2D_Prototype_Draw3DVectorLine = GetFunction(iLibrary, "UB2D_Draw3DVectorLine")
		Global UB2D_Draw3DVectorSphere.UB2D_Prototype_Draw3DVectorSphere = GetFunction(iLibrary, "UB2D_Draw3DVectorSphere")
		Global UB2D_Draw3DVectorTrianle.UB2D_Prototype_Draw3DVectorTrianle = GetFunction(iLibrary, "UB2D_Draw3DVectorTrianle")
		Global UB2D_DrawingLineWidth.UB2D_Prototype_DrawingLineWidth = GetFunction(iLibrary, "UB2D_DrawingLineWidth")
		Global UB2D_DuplicateLight.UB2D_Prototype_DuplicateLight = GetFunction(iLibrary, "UB2D_DuplicateLight")
		Global UB2D_DuplicateMaterial.UB2D_Prototype_DuplicateMaterial = GetFunction(iLibrary, "UB2D_DuplicateMaterial")
		Global UB2D_EnableGadget.UB2D_Prototype_EnableGadget = GetFunction(iLibrary, "UB2D_EnableGadget")
		Global UB2D_EngineControlStatus.UB2D_Prototype_EngineControlStatus = GetFunction(iLibrary, "UB2D_EngineControlStatus")
		Global UB2D_Error.UB2D_Prototype_Error = GetFunction(iLibrary, "UB2D_Error")
		Global UB2D_Event.UB2D_Prototype_Event = GetFunction(iLibrary, "UB2D_Event")
		Global UB2D_EventGadget.UB2D_Prototype_EventGadget = GetFunction(iLibrary, "UB2D_EventGadget")
		Global UB2D_ExamineArmature.UB2D_Prototype_ExamineArmature = GetFunction(iLibrary, "UB2D_ExamineArmature")
		Global UB2D_ExamineGamepads.UB2D_Prototype_ExamineGamepads = GetFunction(iLibrary, "UB2D_ExamineGamepads")
		Global UB2D_ExamineKeyboard.UB2D_Prototype_ExamineKeyboard = GetFunction(iLibrary, "UB2D_ExamineKeyboard")
		Global UB2D_ExamineMouse.UB2D_Prototype_ExamineMouse = GetFunction(iLibrary, "UB2D_ExamineMouse")
		Global UB2D_FPS.UB2D_Prototype_FPS = GetFunction(iLibrary, "UB2D_FPS")
		Global UB2D_FinishMesh.UB2D_Prototype_FinishMesh = GetFunction(iLibrary, "UB2D_FinishMesh")
		Global UB2D_FlipBuffers.UB2D_Prototype_FlipBuffers = GetFunction(iLibrary, "UB2D_FlipBuffers")
		Global UB2D_FontAlignment.UB2D_Prototype_FontAlignment = GetFunction(iLibrary, "UB2D_FontAlignment")
		Global UB2D_FontBendRadius.UB2D_Prototype_FontBendRadius = GetFunction(iLibrary, "UB2D_FontBendRadius")
		Global UB2D_FontColor.UB2D_Prototype_FontColor = GetFunction(iLibrary, "UB2D_FontColor")
		Global UB2D_FontID.UB2D_Prototype_FontID = GetFunction(iLibrary, "UB2D_FontID")
		Global UB2D_FontItalic.UB2D_Prototype_FontItalic = GetFunction(iLibrary, "UB2D_FontItalic")
		Global UB2D_FontKerning.UB2D_Prototype_FontKerning = GetFunction(iLibrary, "UB2D_FontKerning")
		Global UB2D_FontOrigin.UB2D_Prototype_FontOrigin = GetFunction(iLibrary, "UB2D_FontOrigin")
		Global UB2D_FontRegion.UB2D_Prototype_FontRegion = GetFunction(iLibrary, "UB2D_FontRegion")
		Global UB2D_FontRotation.UB2D_Prototype_FontRotation = GetFunction(iLibrary, "UB2D_FontRotation")
		Global UB2D_FontSize.UB2D_Prototype_FontSize = GetFunction(iLibrary, "UB2D_FontSize")
		Global UB2D_FontSpace.UB2D_Prototype_FontSpace = GetFunction(iLibrary, "UB2D_FontSpace")
		Global UB2D_FontWordWrap.UB2D_Prototype_FontWordWrap = GetFunction(iLibrary, "UB2D_FontWordWrap")
		Global UB2D_Free.UB2D_Prototype_Free = GetFunction(iLibrary, "UB2D_Free")
		Global UB2D_FreeArmature.UB2D_Prototype_FreeArmature = GetFunction(iLibrary, "UB2D_FreeArmature")
		Global UB2D_FreeCamera.UB2D_Prototype_FreeCamera = GetFunction(iLibrary, "UB2D_FreeCamera")
		Global UB2D_FreeFont.UB2D_Prototype_FreeFont = GetFunction(iLibrary, "UB2D_FreeFont")
		Global UB2D_FreeGUI.UB2D_Prototype_FreeGUI = GetFunction(iLibrary, "UB2D_FreeGUI")
		Global UB2D_FreeLight.UB2D_Prototype_FreeLight = GetFunction(iLibrary, "UB2D_FreeLight")
		Global UB2D_FreeMaterial.UB2D_Prototype_FreeMaterial = GetFunction(iLibrary, "UB2D_FreeMaterial")
		Global UB2D_FreeMesh.UB2D_Prototype_FreeMesh = GetFunction(iLibrary, "UB2D_FreeMesh")
		Global UB2D_FreeMeshes.UB2D_Prototype_FreeMeshes = GetFunction(iLibrary, "UB2D_FreeMeshes")
		Global UB2D_FreeObject.UB2D_Prototype_FreeObject = GetFunction(iLibrary, "UB2D_FreeObject")
		Global UB2D_FreeObjects.UB2D_Prototype_FreeObjects = GetFunction(iLibrary, "UB2D_FreeObjects")
		Global UB2D_FreeSprite.UB2D_Prototype_FreeSprite = GetFunction(iLibrary, "UB2D_FreeSprite")
		Global UB2D_FreeTexture.UB2D_Prototype_FreeTexture = GetFunction(iLibrary, "UB2D_FreeTexture")
		Global UB2D_GadgetID.UB2D_Prototype_GadgetID = GetFunction(iLibrary, "UB2D_GadgetID")
		Global UB2D_GamepadAxis.UB2D_Prototype_GamepadAxis = GetFunction(iLibrary, "UB2D_GamepadAxis")
		Global UB2D_GamepadAxisDeadzone.UB2D_Prototype_GamepadAxisDeadzone = GetFunction(iLibrary, "UB2D_GamepadAxisDeadzone")
		Global UB2D_GamepadButtonEvent.UB2D_Prototype_GamepadButtonEvent = GetFunction(iLibrary, "UB2D_GamepadButtonEvent")
		Global UB2D_GamepadButtonPushed.UB2D_Prototype_GamepadButtonPushed = GetFunction(iLibrary, "UB2D_GamepadButtonPushed")
		Global UB2D_GamepadButtonReleased.UB2D_Prototype_GamepadButtonReleased = GetFunction(iLibrary, "UB2D_GamepadButtonReleased")
		Global UB2D_GamepadName_StringReturn.UB2D_Prototype_GamepadName = GetFunction(iLibrary, "UB2D_GamepadName")
		Global UB2D_GamepadPointOfView.UB2D_Prototype_GamepadPointOfView = GetFunction(iLibrary, "UB2D_GamepadPointOfView")
		Global UB2D_GetActiveGadget.UB2D_Prototype_GetActiveGadget = GetFunction(iLibrary, "UB2D_GetActiveGadget")
		Global UB2D_GetArmatureAnimationTime.UB2D_Prototype_GetArmatureAnimationTime = GetFunction(iLibrary, "UB2D_GetArmatureAnimationTime")
		Global UB2D_GetArmaturePositionX.UB2D_Prototype_GetArmaturePositionX = GetFunction(iLibrary, "UB2D_GetArmaturePositionX")
		Global UB2D_GetArmaturePositionY.UB2D_Prototype_GetArmaturePositionY = GetFunction(iLibrary, "UB2D_GetArmaturePositionY")
		Global UB2D_GetArmatureRotation.UB2D_Prototype_GetArmatureRotation = GetFunction(iLibrary, "UB2D_GetArmatureRotation")
		Global UB2D_GetGadgetItemData.UB2D_Prototype_GetGadgetItemData = GetFunction(iLibrary, "UB2D_GetGadgetItemData")
		Global UB2D_GetGadgetState.UB2D_Prototype_GetGadgetState = GetFunction(iLibrary, "UB2D_GetGadgetState")
		Global UB2D_GetGadgetText_StringReturn.UB2D_Prototype_GetGadgetText = GetFunction(iLibrary, "UB2D_GetGadgetText")
		Global UB2D_GetGadgetValue.UB2D_Prototype_GetGadgetValue = GetFunction(iLibrary, "UB2D_GetGadgetValue")
		Global UB2D_GetMeshInstanceRotationX.UB2D_Prototype_GetMeshInstanceRotationX = GetFunction(iLibrary, "UB2D_GetMeshInstanceRotationX")
		Global UB2D_GetMeshInstanceRotationY.UB2D_Prototype_GetMeshInstanceRotationY = GetFunction(iLibrary, "UB2D_GetMeshInstanceRotationY")
		Global UB2D_GetMeshInstanceRotationZ.UB2D_Prototype_GetMeshInstanceRotationZ = GetFunction(iLibrary, "UB2D_GetMeshInstanceRotationZ")
		Global UB2D_GetTextureName_StringReturn.UB2D_Prototype_GetTextureName = GetFunction(iLibrary, "UB2D_GetTextureName")
		Global UB2D_GetWindowState.UB2D_Prototype_GetWindowState = GetFunction(iLibrary, "UB2D_GetWindowState")
		Global UB2D_HideGadget.UB2D_Prototype_HideGadget = GetFunction(iLibrary, "UB2D_HideGadget")
		Global UB2D_HideMouse.UB2D_Prototype_HideMouse = GetFunction(iLibrary, "UB2D_HideMouse")
		Global UB2D_HideWindow.UB2D_Prototype_HideWindow = GetFunction(iLibrary, "UB2D_HideWindow")
		Global UB2D_ImportJSON.UB2D_Prototype_ImportJSON = GetFunction(iLibrary, "UB2D_ImportJSON")
		Global UB2D_ImportXML.UB2D_Prototype_ImportXML = GetFunction(iLibrary, "UB2D_ImportXML")
		Global UB2D_IsFont.UB2D_Prototype_IsFont = GetFunction(iLibrary, "UB2D_IsFont")
		Global UB2D_IsLight.UB2D_Prototype_IsLight = GetFunction(iLibrary, "UB2D_IsLight")
		Global UB2D_IsMaterial.UB2D_Prototype_IsMaterial = GetFunction(iLibrary, "UB2D_IsMaterial")
		Global UB2D_IsMesh.UB2D_Prototype_IsMesh = GetFunction(iLibrary, "UB2D_IsMesh")
		Global UB2D_IsMeshInstance.UB2D_Prototype_IsMeshInstance = GetFunction(iLibrary, "UB2D_IsMeshInstance")
		Global UB2D_IsMouseInArea.UB2D_Prototype_IsMouseInArea = GetFunction(iLibrary, "UB2D_IsMouseInArea")
		Global UB2D_IsMouseInRange.UB2D_Prototype_IsMouseInRange = GetFunction(iLibrary, "UB2D_IsMouseInRange")
		Global UB2D_IsObject.UB2D_Prototype_IsObject = GetFunction(iLibrary, "UB2D_IsObject")
		Global UB2D_IsObjectInstance.UB2D_Prototype_IsObjectInstance = GetFunction(iLibrary, "UB2D_IsObjectInstance")
		Global UB2D_IsShader.UB2D_Prototype_IsShader = GetFunction(iLibrary, "UB2D_IsShader")
		Global UB2D_IsSprite.UB2D_Prototype_IsSprite = GetFunction(iLibrary, "UB2D_IsSprite")
		Global UB2D_IsTexture.UB2D_Prototype_IsTexture = GetFunction(iLibrary, "UB2D_IsTexture")
		Global UB2D_IsWindowHidden.UB2D_Prototype_IsWindowHidden = GetFunction(iLibrary, "UB2D_IsWindowHidden")
		Global UB2D_KeyboardDown.UB2D_Prototype_KeyboardDown = GetFunction(iLibrary, "UB2D_KeyboardDown")
		Global UB2D_KeyboardInput_StringReturn.UB2D_Prototype_KeyboardInput = GetFunction(iLibrary, "UB2D_KeyboardInput")
		Global UB2D_KeyboardPushed.UB2D_Prototype_KeyboardPushed = GetFunction(iLibrary, "UB2D_KeyboardPushed")
		Global UB2D_KeyboardReleased.UB2D_Prototype_KeyboardReleased = GetFunction(iLibrary, "UB2D_KeyboardReleased")
		Global UB2D_LightColor.UB2D_Prototype_LightColor = GetFunction(iLibrary, "UB2D_LightColor")
		Global UB2D_LightConeAngle.UB2D_Prototype_LightConeAngle = GetFunction(iLibrary, "UB2D_LightConeAngle")
		Global UB2D_LightID.UB2D_Prototype_LightID = GetFunction(iLibrary, "UB2D_LightID")
		Global UB2D_LightIntensity.UB2D_Prototype_LightIntensity = GetFunction(iLibrary, "UB2D_LightIntensity")
		Global UB2D_LightPositionX.UB2D_Prototype_LightPositionX = GetFunction(iLibrary, "UB2D_LightPositionX")
		Global UB2D_LightPositionY.UB2D_Prototype_LightPositionY = GetFunction(iLibrary, "UB2D_LightPositionY")
		Global UB2D_LightPositionZ.UB2D_Prototype_LightPositionZ = GetFunction(iLibrary, "UB2D_LightPositionZ")
		Global UB2D_LightRange.UB2D_Prototype_LightRange = GetFunction(iLibrary, "UB2D_LightRange")
		Global UB2D_LightState.UB2D_Prototype_LightState = GetFunction(iLibrary, "UB2D_LightState")
		Global UB2D_LightType.UB2D_Prototype_LightType = GetFunction(iLibrary, "UB2D_LightType")
		Global UB2D_ListViewGadget.UB2D_Prototype_ListViewGadget = GetFunction(iLibrary, "UB2D_ListViewGadget")
		Global UB2D_LoadArmature.UB2D_Prototype_LoadArmature = GetFunction(iLibrary, "UB2D_LoadArmature")
		Global UB2D_LoadArmatureAnimation.UB2D_Prototype_LoadArmatureAnimation = GetFunction(iLibrary, "UB2D_LoadArmatureAnimation")
		Global UB2D_LoadDAEMesh.UB2D_Prototype_LoadDAEMesh = GetFunction(iLibrary, "UB2D_LoadDAEMesh")
		Global UB2D_LoadDAESkeletalMesh.UB2D_Prototype_LoadDAESkeletalMesh = GetFunction(iLibrary, "UB2D_LoadDAESkeletalMesh")
		Global UB2D_LoadEnvironmentTexture.UB2D_Prototype_LoadEnvironmentTexture = GetFunction(iLibrary, "UB2D_LoadEnvironmentTexture")
		Global UB2D_LoadFont.UB2D_Prototype_LoadFont = GetFunction(iLibrary, "UB2D_LoadFont")
		Global UB2D_LoadOBJMesh.UB2D_Prototype_LoadOBJMesh = GetFunction(iLibrary, "UB2D_LoadOBJMesh")
		Global UB2D_LoadOBJMeshSingleObject.UB2D_Prototype_LoadOBJMeshSingleObject = GetFunction(iLibrary, "UB2D_LoadOBJMeshSingleObject")
		Global UB2D_LoadShader.UB2D_Prototype_LoadShader = GetFunction(iLibrary, "UB2D_LoadShader")
		Global UB2D_LoadTexture.UB2D_Prototype_LoadTexture = GetFunction(iLibrary, "UB2D_LoadTexture")
		Global UB2D_LockMouse.UB2D_Prototype_LockMouse = GetFunction(iLibrary, "UB2D_LockMouse")
		Global UB2D_Material.UB2D_Prototype_Material = GetFunction(iLibrary, "UB2D_Material")
		Global UB2D_MaterialColor.UB2D_Prototype_MaterialColor = GetFunction(iLibrary, "UB2D_MaterialColor")
		Global UB2D_MaterialEmission.UB2D_Prototype_MaterialEmission = GetFunction(iLibrary, "UB2D_MaterialEmission")
		Global UB2D_MaterialID.UB2D_Prototype_MaterialID = GetFunction(iLibrary, "UB2D_MaterialID")
		Global UB2D_MaterialMetallic.UB2D_Prototype_MaterialMetallic = GetFunction(iLibrary, "UB2D_MaterialMetallic")
		Global UB2D_MaterialName_StringReturn.UB2D_Prototype_MaterialName = GetFunction(iLibrary, "UB2D_MaterialName")
		Global UB2D_MaterialRoughness.UB2D_Prototype_MaterialRoughness = GetFunction(iLibrary, "UB2D_MaterialRoughness")
		Global UB2D_MaterialShader.UB2D_Prototype_MaterialShader = GetFunction(iLibrary, "UB2D_MaterialShader")
		Global UB2D_MaterialSpecular.UB2D_Prototype_MaterialSpecular = GetFunction(iLibrary, "UB2D_MaterialSpecular")
		Global UB2D_MaterialTexture.UB2D_Prototype_MaterialTexture = GetFunction(iLibrary, "UB2D_MaterialTexture")
		Global UB2D_MaterialValue.UB2D_Prototype_MaterialValue = GetFunction(iLibrary, "UB2D_MaterialValue")
		Global UB2D_Mesh.UB2D_Prototype_Mesh = GetFunction(iLibrary, "UB2D_Mesh")
		Global UB2D_MeshFaceCount.UB2D_Prototype_MeshFaceCount = GetFunction(iLibrary, "UB2D_MeshFaceCount")
		Global UB2D_MeshID.UB2D_Prototype_MeshID = GetFunction(iLibrary, "UB2D_MeshID")
		Global UB2D_MeshIndicesCount.UB2D_Prototype_MeshIndicesCount = GetFunction(iLibrary, "UB2D_MeshIndicesCount")
		Global UB2D_MeshInstanceBehaviour.UB2D_Prototype_MeshInstanceBehaviour = GetFunction(iLibrary, "UB2D_MeshInstanceBehaviour")
		Global UB2D_MeshInstanceDisplay.UB2D_Prototype_MeshInstanceDisplay = GetFunction(iLibrary, "UB2D_MeshInstanceDisplay")
		Global UB2D_MeshInstanceID.UB2D_Prototype_MeshInstanceID = GetFunction(iLibrary, "UB2D_MeshInstanceID")
		Global UB2D_MeshInstanceLookAt.UB2D_Prototype_MeshInstanceLookAt = GetFunction(iLibrary, "UB2D_MeshInstanceLookAt")
		Global UB2D_MeshInstanceMatrix.UB2D_Prototype_MeshInstanceMatrix = GetFunction(iLibrary, "UB2D_MeshInstanceMatrix")
		Global UB2D_MeshInstanceName_StringReturn.UB2D_Prototype_MeshInstanceName = GetFunction(iLibrary, "UB2D_MeshInstanceName")
		Global UB2D_MeshInstancePositionX.UB2D_Prototype_MeshInstancePositionX = GetFunction(iLibrary, "UB2D_MeshInstancePositionX")
		Global UB2D_MeshInstancePositionY.UB2D_Prototype_MeshInstancePositionY = GetFunction(iLibrary, "UB2D_MeshInstancePositionY")
		Global UB2D_MeshInstancePositionZ.UB2D_Prototype_MeshInstancePositionZ = GetFunction(iLibrary, "UB2D_MeshInstancePositionZ")
		Global UB2D_MeshInstanceScaleX.UB2D_Prototype_MeshInstanceScaleX = GetFunction(iLibrary, "UB2D_MeshInstanceScaleX")
		Global UB2D_MeshInstanceScaleY.UB2D_Prototype_MeshInstanceScaleY = GetFunction(iLibrary, "UB2D_MeshInstanceScaleY")
		Global UB2D_MeshInstanceScaleZ.UB2D_Prototype_MeshInstanceScaleZ = GetFunction(iLibrary, "UB2D_MeshInstanceScaleZ")
		Global UB2D_MeshName_StringReturn.UB2D_Prototype_MeshName = GetFunction(iLibrary, "UB2D_MeshName")
		Global UB2D_MeshNormal.UB2D_Prototype_MeshNormal = GetFunction(iLibrary, "UB2D_MeshNormal")
		Global UB2D_MeshTexCoord.UB2D_Prototype_MeshTexCoord = GetFunction(iLibrary, "UB2D_MeshTexCoord")
		Global UB2D_MeshVector.UB2D_Prototype_MeshVector = GetFunction(iLibrary, "UB2D_MeshVector")
		Global UB2D_MeshVertexCount.UB2D_Prototype_MeshVertexCount = GetFunction(iLibrary, "UB2D_MeshVertexCount")
		Global UB2D_MeshVertexGroup.UB2D_Prototype_MeshVertexGroup = GetFunction(iLibrary, "UB2D_MeshVertexGroup")
		Global UB2D_MeshVertexGroupID.UB2D_Prototype_MeshVertexGroupID = GetFunction(iLibrary, "UB2D_MeshVertexGroupID")
		Global UB2D_MouseButtonDown.UB2D_Prototype_MouseButtonDown = GetFunction(iLibrary, "UB2D_MouseButtonDown")
		Global UB2D_MouseButtonPushed.UB2D_Prototype_MouseButtonPushed = GetFunction(iLibrary, "UB2D_MouseButtonPushed")
		Global UB2D_MouseButtonReleased.UB2D_Prototype_MouseButtonReleased = GetFunction(iLibrary, "UB2D_MouseButtonReleased")
		Global UB2D_MouseDeltaX.UB2D_Prototype_MouseDeltaX = GetFunction(iLibrary, "UB2D_MouseDeltaX")
		Global UB2D_MouseDeltaY.UB2D_Prototype_MouseDeltaY = GetFunction(iLibrary, "UB2D_MouseDeltaY")
		Global UB2D_MousePosition.UB2D_Prototype_MousePosition = GetFunction(iLibrary, "UB2D_MousePosition")
		Global UB2D_MouseWheel.UB2D_Prototype_MouseWheel = GetFunction(iLibrary, "UB2D_MouseWheel")
		Global UB2D_MouseX.UB2D_Prototype_MouseX = GetFunction(iLibrary, "UB2D_MouseX")
		Global UB2D_MouseY.UB2D_Prototype_MouseY = GetFunction(iLibrary, "UB2D_MouseY")
		Global UB2D_MoveArmature.UB2D_Prototype_MoveArmature = GetFunction(iLibrary, "UB2D_MoveArmature")
		Global UB2D_MoveCamera.UB2D_Prototype_MoveCamera = GetFunction(iLibrary, "UB2D_MoveCamera")
		Global UB2D_MoveCurrentCamera.UB2D_Prototype_MoveCurrentCamera = GetFunction(iLibrary, "UB2D_MoveCurrentCamera")
		Global UB2D_MoveDrawingTransformation.UB2D_Prototype_MoveDrawingTransformation = GetFunction(iLibrary, "UB2D_MoveDrawingTransformation")
		Global UB2D_MoveLight.UB2D_Prototype_MoveLight = GetFunction(iLibrary, "UB2D_MoveLight")
		Global UB2D_MoveMeshInstance.UB2D_Prototype_MoveMeshInstance = GetFunction(iLibrary, "UB2D_MoveMeshInstance")
		Global UB2D_MoveObjectInstance.UB2D_Prototype_MoveObjectInstance = GetFunction(iLibrary, "UB2D_MoveObjectInstance")
		Global UB2D_Note.UB2D_Prototype_Note = GetFunction(iLibrary, "UB2D_Note")
		Global UB2D_ObjectHeight.UB2D_Prototype_ObjectHeight = GetFunction(iLibrary, "UB2D_ObjectHeight")
		Global UB2D_ObjectID.UB2D_Prototype_ObjectID = GetFunction(iLibrary, "UB2D_ObjectID")
		Global UB2D_ObjectInstanceBehaviour.UB2D_Prototype_ObjectInstanceBehaviour = GetFunction(iLibrary, "UB2D_ObjectInstanceBehaviour")
		Global UB2D_ObjectInstanceHeight.UB2D_Prototype_ObjectInstanceHeight = GetFunction(iLibrary, "UB2D_ObjectInstanceHeight")
		Global UB2D_ObjectInstanceID.UB2D_Prototype_ObjectInstanceID = GetFunction(iLibrary, "UB2D_ObjectInstanceID")
		Global UB2D_ObjectInstanceName_StringReturn.UB2D_Prototype_ObjectInstanceName = GetFunction(iLibrary, "UB2D_ObjectInstanceName")
		Global UB2D_ObjectInstancePositionX.UB2D_Prototype_ObjectInstancePositionX = GetFunction(iLibrary, "UB2D_ObjectInstancePositionX")
		Global UB2D_ObjectInstancePositionY.UB2D_Prototype_ObjectInstancePositionY = GetFunction(iLibrary, "UB2D_ObjectInstancePositionY")
		Global UB2D_ObjectInstancePositionZ.UB2D_Prototype_ObjectInstancePositionZ = GetFunction(iLibrary, "UB2D_ObjectInstancePositionZ")
		Global UB2D_ObjectInstanceRotation.UB2D_Prototype_ObjectInstanceRotation = GetFunction(iLibrary, "UB2D_ObjectInstanceRotation")
		Global UB2D_ObjectInstanceWidth.UB2D_Prototype_ObjectInstanceWidth = GetFunction(iLibrary, "UB2D_ObjectInstanceWidth")
		Global UB2D_ObjectMaterial.UB2D_Prototype_ObjectMaterial = GetFunction(iLibrary, "UB2D_ObjectMaterial")
		Global UB2D_ObjectOriginX.UB2D_Prototype_ObjectOriginX = GetFunction(iLibrary, "UB2D_ObjectOriginX")
		Global UB2D_ObjectOriginY.UB2D_Prototype_ObjectOriginY = GetFunction(iLibrary, "UB2D_ObjectOriginY")
		Global UB2D_ObjectRotation.UB2D_Prototype_ObjectRotation = GetFunction(iLibrary, "UB2D_ObjectRotation")
		Global UB2D_ObjectWidth.UB2D_Prototype_ObjectWidth = GetFunction(iLibrary, "UB2D_ObjectWidth")
		Global UB2D_OpenEngineControl.UB2D_Prototype_OpenEngineControl = GetFunction(iLibrary, "UB2D_OpenEngineControl")
		Global UB2D_OpenGadgetList.UB2D_Prototype_OpenGadgetList = GetFunction(iLibrary, "UB2D_OpenGadgetList")
		Global UB2D_OpenScreen.UB2D_Prototype_OpenScreen = GetFunction(iLibrary, "UB2D_OpenScreen")
		Global UB2D_OpenWindowedScreen.UB2D_Prototype_OpenWindowedScreen = GetFunction(iLibrary, "UB2D_OpenWindowedScreen")
		Global UB2D_PauseArmatureAnimation.UB2D_Prototype_PauseArmatureAnimation = GetFunction(iLibrary, "UB2D_PauseArmatureAnimation")
		Global UB2D_PlayArmatureAnimation.UB2D_Prototype_PlayArmatureAnimation = GetFunction(iLibrary, "UB2D_PlayArmatureAnimation")
		Global UB2D_ProgressbarGadget.UB2D_Prototype_ProgressbarGadget = GetFunction(iLibrary, "UB2D_ProgressbarGadget")
		Global UB2D_ReadTextureFromMemory.UB2D_Prototype_ReadTextureFromMemory = GetFunction(iLibrary, "UB2D_ReadTextureFromMemory")
		Global UB2D_RemoveArmatureFrame.UB2D_Prototype_RemoveArmatureFrame = GetFunction(iLibrary, "UB2D_RemoveArmatureFrame")
		Global UB2D_RemoveArmatureFrameBoneOffset.UB2D_Prototype_RemoveArmatureFrameBoneOffset = GetFunction(iLibrary, "UB2D_RemoveArmatureFrameBoneOffset")
		Global UB2D_RemoveArmatureFrameBoneRotation.UB2D_Prototype_RemoveArmatureFrameBoneRotation = GetFunction(iLibrary, "UB2D_RemoveArmatureFrameBoneRotation")
		Global UB2D_RemoveArmatureFrameBoneScaling.UB2D_Prototype_RemoveArmatureFrameBoneScaling = GetFunction(iLibrary, "UB2D_RemoveArmatureFrameBoneScaling")
		Global UB2D_RemoveGadgetItem.UB2D_Prototype_RemoveGadgetItem = GetFunction(iLibrary, "UB2D_RemoveGadgetItem")
		Global UB2D_RemoveMaterialRenderCallback.UB2D_Prototype_RemoveMaterialRenderCallback = GetFunction(iLibrary, "UB2D_RemoveMaterialRenderCallback")
		Global UB2D_RemoveShaderRenderCallback.UB2D_Prototype_RemoveShaderRenderCallback = GetFunction(iLibrary, "UB2D_RemoveShaderRenderCallback")
		Global UB2D_RenderScene.UB2D_Prototype_RenderScene = GetFunction(iLibrary, "UB2D_RenderScene")
		Global UB2D_Report.UB2D_Prototype_Report = GetFunction(iLibrary, "UB2D_Report")
		Global UB2D_ResetDrawingTransformationMatrix.UB2D_Prototype_ResetDrawingTransformationMatrix = GetFunction(iLibrary, "UB2D_ResetDrawingTransformationMatrix")
		Global UB2D_ResizeObject.UB2D_Prototype_ResizeObject = GetFunction(iLibrary, "UB2D_ResizeObject")
		Global UB2D_ResizeObjectInstance.UB2D_Prototype_ResizeObjectInstance = GetFunction(iLibrary, "UB2D_ResizeObjectInstance")
		Global UB2D_ResizeScreen.UB2D_Prototype_ResizeScreen = GetFunction(iLibrary, "UB2D_ResizeScreen")
		Global UB2D_ResumeArmatureAnimation.UB2D_Prototype_ResumeArmatureAnimation = GetFunction(iLibrary, "UB2D_ResumeArmatureAnimation")
		Global UB2D_RotateArmature.UB2D_Prototype_RotateArmature = GetFunction(iLibrary, "UB2D_RotateArmature")
		Global UB2D_RotateCamera.UB2D_Prototype_RotateCamera = GetFunction(iLibrary, "UB2D_RotateCamera")
		Global UB2D_RotateCurrentCamera.UB2D_Prototype_RotateCurrentCamera = GetFunction(iLibrary, "UB2D_RotateCurrentCamera")
		Global UB2D_RotateDirectLight.UB2D_Prototype_RotateDirectLight = GetFunction(iLibrary, "UB2D_RotateDirectLight")
		Global UB2D_RotateDrawingTransformation.UB2D_Prototype_RotateDrawingTransformation = GetFunction(iLibrary, "UB2D_RotateDrawingTransformation")
		Global UB2D_RotateLight.UB2D_Prototype_RotateLight = GetFunction(iLibrary, "UB2D_RotateLight")
		Global UB2D_RotateMesh.UB2D_Prototype_RotateMesh = GetFunction(iLibrary, "UB2D_RotateMesh")
		Global UB2D_RotateMeshInstance.UB2D_Prototype_RotateMeshInstance = GetFunction(iLibrary, "UB2D_RotateMeshInstance")
		Global UB2D_RotateObject.UB2D_Prototype_RotateObject = GetFunction(iLibrary, "UB2D_RotateObject")
		Global UB2D_RotateObjectInstance.UB2D_Prototype_RotateObjectInstance = GetFunction(iLibrary, "UB2D_RotateObjectInstance")
		Global UB2D_RotateSprite.UB2D_Prototype_RotateSprite = GetFunction(iLibrary, "UB2D_RotateSprite")
		Global UB2D_SaveArmature.UB2D_Prototype_SaveArmature = GetFunction(iLibrary, "UB2D_SaveArmature")
		Global UB2D_SaveTexture.UB2D_Prototype_SaveTexture = GetFunction(iLibrary, "UB2D_SaveTexture")
		Global UB2D_ScaleArmature.UB2D_Prototype_ScaleArmature = GetFunction(iLibrary, "UB2D_ScaleArmature")
		Global UB2D_ScaleDrawingTransformation.UB2D_Prototype_ScaleDrawingTransformation = GetFunction(iLibrary, "UB2D_ScaleDrawingTransformation")
		Global UB2D_ScaleMesh.UB2D_Prototype_ScaleMesh = GetFunction(iLibrary, "UB2D_ScaleMesh")
		Global UB2D_ScaleMeshInstance.UB2D_Prototype_ScaleMeshInstance = GetFunction(iLibrary, "UB2D_ScaleMeshInstance")
		Global UB2D_ScaleObject.UB2D_Prototype_ScaleObject = GetFunction(iLibrary, "UB2D_ScaleObject")
		Global UB2D_ScaleObjectInstance.UB2D_Prototype_ScaleObjectInstance = GetFunction(iLibrary, "UB2D_ScaleObjectInstance")
		Global UB2D_ScaleSprite.UB2D_Prototype_ScaleSprite = GetFunction(iLibrary, "UB2D_ScaleSprite")
		Global UB2D_SceneBlur.UB2D_Prototype_SceneBlur = GetFunction(iLibrary, "UB2D_SceneBlur")
		Global UB2D_SceneContrast.UB2D_Prototype_SceneContrast = GetFunction(iLibrary, "UB2D_SceneContrast")
		Global UB2D_SceneGamma.UB2D_Prototype_SceneGamma = GetFunction(iLibrary, "UB2D_SceneGamma")
		Global UB2D_SceneSaturation.UB2D_Prototype_SceneSaturation = GetFunction(iLibrary, "UB2D_SceneSaturation")
		Global UB2D_ScreenClearColor.UB2D_Prototype_ScreenClearColor = GetFunction(iLibrary, "UB2D_ScreenClearColor")
		Global UB2D_ScreenContainerGadgetID.UB2D_Prototype_ScreenContainerGadgetID = GetFunction(iLibrary, "UB2D_ScreenContainerGadgetID")
		Global UB2D_ScreenGamma.UB2D_Prototype_ScreenGamma = GetFunction(iLibrary, "UB2D_ScreenGamma")
		Global UB2D_ScreenHeight.UB2D_Prototype_ScreenHeight = GetFunction(iLibrary, "UB2D_ScreenHeight")
		Global UB2D_ScreenShot.UB2D_Prototype_ScreenShot = GetFunction(iLibrary, "UB2D_ScreenShot")
		Global UB2D_ScreenWidth.UB2D_Prototype_ScreenWidth = GetFunction(iLibrary, "UB2D_ScreenWidth")
		Global UB2D_ScreenWindowID.UB2D_Prototype_ScreenWindowID = GetFunction(iLibrary, "UB2D_ScreenWindowID")
		Global UB2D_SetActiveGadget.UB2D_Prototype_SetActiveGadget = GetFunction(iLibrary, "UB2D_SetActiveGadget")
		Global UB2D_SetActiveWindow.UB2D_Prototype_SetActiveWindow = GetFunction(iLibrary, "UB2D_SetActiveWindow")
		Global UB2D_SetAmbientLightColor.UB2D_Prototype_SetAmbientLightColor = GetFunction(iLibrary, "UB2D_SetAmbientLightColor")
		Global UB2D_SetArmatureAnimationSpeed.UB2D_Prototype_SetArmatureAnimationSpeed = GetFunction(iLibrary, "UB2D_SetArmatureAnimationSpeed")
		Global UB2D_SetArmatureAnimationTime.UB2D_Prototype_SetArmatureAnimationTime = GetFunction(iLibrary, "UB2D_SetArmatureAnimationTime")
		Global UB2D_SetArmatureBoneOffset.UB2D_Prototype_SetArmatureBoneOffset = GetFunction(iLibrary, "UB2D_SetArmatureBoneOffset")
		Global UB2D_SetArmatureBoneRotation.UB2D_Prototype_SetArmatureBoneRotation = GetFunction(iLibrary, "UB2D_SetArmatureBoneRotation")
		Global UB2D_SetArmatureBoneScaling.UB2D_Prototype_SetArmatureBoneScaling = GetFunction(iLibrary, "UB2D_SetArmatureBoneScaling")
		Global UB2D_SetArmatureFrameBoneOffset.UB2D_Prototype_SetArmatureFrameBoneOffset = GetFunction(iLibrary, "UB2D_SetArmatureFrameBoneOffset")
		Global UB2D_SetArmatureFrameBoneRotation.UB2D_Prototype_SetArmatureFrameBoneRotation = GetFunction(iLibrary, "UB2D_SetArmatureFrameBoneRotation")
		Global UB2D_SetArmatureFrameBoneScaling.UB2D_Prototype_SetArmatureFrameBoneScaling = GetFunction(iLibrary, "UB2D_SetArmatureFrameBoneScaling")
		Global UB2D_SetArmatureFrameTimePosition.UB2D_Prototype_SetArmatureFrameTimePosition = GetFunction(iLibrary, "UB2D_SetArmatureFrameTimePosition")
		Global UB2D_SetArmaturePosition.UB2D_Prototype_SetArmaturePosition = GetFunction(iLibrary, "UB2D_SetArmaturePosition")
		Global UB2D_SetArmatureRotation.UB2D_Prototype_SetArmatureRotation = GetFunction(iLibrary, "UB2D_SetArmatureRotation")
		Global UB2D_SetArmatureScale.UB2D_Prototype_SetArmatureScale = GetFunction(iLibrary, "UB2D_SetArmatureScale")
		Global UB2D_SetCameraMatrix.UB2D_Prototype_SetCameraMatrix = GetFunction(iLibrary, "UB2D_SetCameraMatrix")
		Global UB2D_SetCameraPosition.UB2D_Prototype_SetCameraPosition = GetFunction(iLibrary, "UB2D_SetCameraPosition")
		Global UB2D_SetCameraRotation.UB2D_Prototype_SetCameraRotation = GetFunction(iLibrary, "UB2D_SetCameraRotation")
		Global UB2D_SetColor.UB2D_Prototype_SetColor = GetFunction(iLibrary, "UB2D_SetColor")
		Global UB2D_SetCurrentCamera.UB2D_Prototype_SetCurrentCamera = GetFunction(iLibrary, "UB2D_SetCurrentCamera")
		Global UB2D_SetCurrentCameraMatrix.UB2D_Prototype_SetCurrentCameraMatrix = GetFunction(iLibrary, "UB2D_SetCurrentCameraMatrix")
		Global UB2D_SetCurrentCameraPosition.UB2D_Prototype_SetCurrentCameraPosition = GetFunction(iLibrary, "UB2D_SetCurrentCameraPosition")
		Global UB2D_SetCurrentCameraRotation.UB2D_Prototype_SetCurrentCameraRotation = GetFunction(iLibrary, "UB2D_SetCurrentCameraRotation")
		Global UB2D_SetCurrentCameraToDefault.UB2D_Prototype_SetCurrentCameraToDefault = GetFunction(iLibrary, "UB2D_SetCurrentCameraToDefault")
		Global UB2D_SetDirectLightColor.UB2D_Prototype_SetDirectLightColor = GetFunction(iLibrary, "UB2D_SetDirectLightColor")
		Global UB2D_SetDirectLightDirection.UB2D_Prototype_SetDirectLightDirection = GetFunction(iLibrary, "UB2D_SetDirectLightDirection")
		Global UB2D_SetDirectLightDirectionVector.UB2D_Prototype_SetDirectLightDirectionVector = GetFunction(iLibrary, "UB2D_SetDirectLightDirectionVector")
		Global UB2D_SetDirectLightIntensity.UB2D_Prototype_SetDirectLightIntensity = GetFunction(iLibrary, "UB2D_SetDirectLightIntensity")
		Global UB2D_SetDrawingLineWidth.UB2D_Prototype_SetDrawingLineWidth = GetFunction(iLibrary, "UB2D_SetDrawingLineWidth")
		Global UB2D_SetDrawingTransformationMatrix.UB2D_Prototype_SetDrawingTransformationMatrix = GetFunction(iLibrary, "UB2D_SetDrawingTransformationMatrix")
		Global UB2D_SetDrawingTransformationPosition.UB2D_Prototype_SetDrawingTransformationPosition = GetFunction(iLibrary, "UB2D_SetDrawingTransformationPosition")
		Global UB2D_SetDrawingTransformationRotation.UB2D_Prototype_SetDrawingTransformationRotation = GetFunction(iLibrary, "UB2D_SetDrawingTransformationRotation")
		Global UB2D_SetDrawingTransformationScale.UB2D_Prototype_SetDrawingTransformationScale = GetFunction(iLibrary, "UB2D_SetDrawingTransformationScale")
		Global UB2D_SetEnvironmentMap.UB2D_Prototype_SetEnvironmentMap = GetFunction(iLibrary, "UB2D_SetEnvironmentMap")
		Global UB2D_SetGadgetItemText.UB2D_Prototype_SetGadgetItemText = GetFunction(iLibrary, "UB2D_SetGadgetItemText")
		Global UB2D_SetGadgetState.UB2D_Prototype_SetGadgetState = GetFunction(iLibrary, "UB2D_SetGadgetState")
		Global UB2D_SetGadgetText.UB2D_Prototype_SetGadgetText = GetFunction(iLibrary, "UB2D_SetGadgetText")
		Global UB2D_SetGadgetValue.UB2D_Prototype_SetGadgetValue = GetFunction(iLibrary, "UB2D_SetGadgetValue")
		Global UB2D_SetLightColor.UB2D_Prototype_SetLightColor = GetFunction(iLibrary, "UB2D_SetLightColor")
		Global UB2D_SetLightConeAngle.UB2D_Prototype_SetLightConeAngle = GetFunction(iLibrary, "UB2D_SetLightConeAngle")
		Global UB2D_SetLightDirection.UB2D_Prototype_SetLightDirection = GetFunction(iLibrary, "UB2D_SetLightDirection")
		Global UB2D_SetLightIntensity.UB2D_Prototype_SetLightIntensity = GetFunction(iLibrary, "UB2D_SetLightIntensity")
		Global UB2D_SetLightPosition.UB2D_Prototype_SetLightPosition = GetFunction(iLibrary, "UB2D_SetLightPosition")
		Global UB2D_SetLightPositionZ.UB2D_Prototype_SetLightPositionZ = GetFunction(iLibrary, "UB2D_SetLightPositionZ")
		Global UB2D_SetLightRange.UB2D_Prototype_SetLightRange = GetFunction(iLibrary, "UB2D_SetLightRange")
		Global UB2D_SetLightRotation.UB2D_Prototype_SetLightRotation = GetFunction(iLibrary, "UB2D_SetLightRotation")
		Global UB2D_SetLightState.UB2D_Prototype_SetLightState = GetFunction(iLibrary, "UB2D_SetLightState")
		Global UB2D_SetLightType.UB2D_Prototype_SetLightType = GetFunction(iLibrary, "UB2D_SetLightType")
		Global UB2D_SetMaterialBlendingMode.UB2D_Prototype_SetMaterialBlendingMode = GetFunction(iLibrary, "UB2D_SetMaterialBlendingMode")
		Global UB2D_SetMaterialColor.UB2D_Prototype_SetMaterialColor = GetFunction(iLibrary, "UB2D_SetMaterialColor")
		Global UB2D_SetMaterialDepthMask.UB2D_Prototype_SetMaterialDepthMask = GetFunction(iLibrary, "UB2D_SetMaterialDepthMask")
		Global UB2D_SetMaterialEmission.UB2D_Prototype_SetMaterialEmission = GetFunction(iLibrary, "UB2D_SetMaterialEmission")
		Global UB2D_SetMaterialMetallic.UB2D_Prototype_SetMaterialMetallic = GetFunction(iLibrary, "UB2D_SetMaterialMetallic")
		Global UB2D_SetMaterialRenderCallback.UB2D_Prototype_SetMaterialRenderCallback = GetFunction(iLibrary, "UB2D_SetMaterialRenderCallback")
		Global UB2D_SetMaterialRoughness.UB2D_Prototype_SetMaterialRoughness = GetFunction(iLibrary, "UB2D_SetMaterialRoughness")
		Global UB2D_SetMaterialShader.UB2D_Prototype_SetMaterialShader = GetFunction(iLibrary, "UB2D_SetMaterialShader")
		Global UB2D_SetMaterialSpecular.UB2D_Prototype_SetMaterialSpecular = GetFunction(iLibrary, "UB2D_SetMaterialSpecular")
		Global UB2D_SetMaterialTexture.UB2D_Prototype_SetMaterialTexture = GetFunction(iLibrary, "UB2D_SetMaterialTexture")
		Global UB2D_SetMaterialValue.UB2D_Prototype_SetMaterialValue = GetFunction(iLibrary, "UB2D_SetMaterialValue")
		Global UB2D_SetMaterialValues.UB2D_Prototype_SetMaterialValues = GetFunction(iLibrary, "UB2D_SetMaterialValues")
		Global UB2D_SetMeshFace.UB2D_Prototype_SetMeshFace = GetFunction(iLibrary, "UB2D_SetMeshFace")
		Global UB2D_SetMeshFaceCount.UB2D_Prototype_SetMeshFaceCount = GetFunction(iLibrary, "UB2D_SetMeshFaceCount")
		Global UB2D_SetMeshIndicesCount.UB2D_Prototype_SetMeshIndicesCount = GetFunction(iLibrary, "UB2D_SetMeshIndicesCount")
		Global UB2D_SetMeshInstanceBehaviour.UB2D_Prototype_SetMeshInstanceBehaviour = GetFunction(iLibrary, "UB2D_SetMeshInstanceBehaviour")
		Global UB2D_SetMeshInstanceDisplay.UB2D_Prototype_SetMeshInstanceDisplay = GetFunction(iLibrary, "UB2D_SetMeshInstanceDisplay")
		Global UB2D_SetMeshInstanceMatrix.UB2D_Prototype_SetMeshInstanceMatrix = GetFunction(iLibrary, "UB2D_SetMeshInstanceMatrix")
		Global UB2D_SetMeshInstancePosition.UB2D_Prototype_SetMeshInstancePosition = GetFunction(iLibrary, "UB2D_SetMeshInstancePosition")
		Global UB2D_SetMeshInstanceRotation.UB2D_Prototype_SetMeshInstanceRotation = GetFunction(iLibrary, "UB2D_SetMeshInstanceRotation")
		Global UB2D_SetMeshInstanceScale.UB2D_Prototype_SetMeshInstanceScale = GetFunction(iLibrary, "UB2D_SetMeshInstanceScale")
		Global UB2D_SetMeshNormal.UB2D_Prototype_SetMeshNormal = GetFunction(iLibrary, "UB2D_SetMeshNormal")
		Global UB2D_SetMeshTexCoord.UB2D_Prototype_SetMeshTexCoord = GetFunction(iLibrary, "UB2D_SetMeshTexCoord")
		Global UB2D_SetMeshVertex.UB2D_Prototype_SetMeshVertex = GetFunction(iLibrary, "UB2D_SetMeshVertex")
		Global UB2D_SetMeshVertexCount.UB2D_Prototype_SetMeshVertexCount = GetFunction(iLibrary, "UB2D_SetMeshVertexCount")
		Global UB2D_SetMeshVertexGroup.UB2D_Prototype_SetMeshVertexGroup = GetFunction(iLibrary, "UB2D_SetMeshVertexGroup")
		Global UB2D_SetObjectInstanceBehaviour.UB2D_Prototype_SetObjectInstanceBehaviour = GetFunction(iLibrary, "UB2D_SetObjectInstanceBehaviour")
		Global UB2D_SetObjectInstancePosition.UB2D_Prototype_SetObjectInstancePosition = GetFunction(iLibrary, "UB2D_SetObjectInstancePosition")
		Global UB2D_SetObjectInstanceRotation.UB2D_Prototype_SetObjectInstanceRotation = GetFunction(iLibrary, "UB2D_SetObjectInstanceRotation")
		Global UB2D_SetObjectRotation.UB2D_Prototype_SetObjectRotation = GetFunction(iLibrary, "UB2D_SetObjectRotation")
		Global UB2D_SetSceneBlur.UB2D_Prototype_SetSceneBlur = GetFunction(iLibrary, "UB2D_SetSceneBlur")
		Global UB2D_SetSceneContrast.UB2D_Prototype_SetSceneContrast = GetFunction(iLibrary, "UB2D_SetSceneContrast")
		Global UB2D_SetSceneGamma.UB2D_Prototype_SetSceneGamma = GetFunction(iLibrary, "UB2D_SetSceneGamma")
		Global UB2D_SetSceneSaturation.UB2D_Prototype_SetSceneSaturation = GetFunction(iLibrary, "UB2D_SetSceneSaturation")
		Global UB2D_SetScreenGamma.UB2D_Prototype_SetScreenGamma = GetFunction(iLibrary, "UB2D_SetScreenGamma")
		Global UB2D_SetShaderRenderCallback.UB2D_Prototype_SetShaderRenderCallback = GetFunction(iLibrary, "UB2D_SetShaderRenderCallback")
		Global UB2D_SetShaderUniform.UB2D_Prototype_SetShaderUniform = GetFunction(iLibrary, "UB2D_SetShaderUniform")
		Global UB2D_SetShaderUniformFloat.UB2D_Prototype_SetShaderUniformFloat = GetFunction(iLibrary, "UB2D_SetShaderUniformFloat")
		Global UB2D_SetShaderUniformInteger.UB2D_Prototype_SetShaderUniformInteger = GetFunction(iLibrary, "UB2D_SetShaderUniformInteger")
		Global UB2D_SetShaderUniformMatrix3f.UB2D_Prototype_SetShaderUniformMatrix3f = GetFunction(iLibrary, "UB2D_SetShaderUniformMatrix3f")
		Global UB2D_SetShaderUniformMatrix4f.UB2D_Prototype_SetShaderUniformMatrix4f = GetFunction(iLibrary, "UB2D_SetShaderUniformMatrix4f")
		Global UB2D_SetShaderUniformPointer.UB2D_Prototype_SetShaderUniformPointer = GetFunction(iLibrary, "UB2D_SetShaderUniformPointer")
		Global UB2D_SetShaderUniformSampler.UB2D_Prototype_SetShaderUniformSampler = GetFunction(iLibrary, "UB2D_SetShaderUniformSampler")
		Global UB2D_SetShaderUniformVector.UB2D_Prototype_SetShaderUniformVector = GetFunction(iLibrary, "UB2D_SetShaderUniformVector")
		Global UB2D_SetShaderUniformVector2f.UB2D_Prototype_SetShaderUniformVector2f = GetFunction(iLibrary, "UB2D_SetShaderUniformVector2f")
		Global UB2D_SetShaderUniformVector3f.UB2D_Prototype_SetShaderUniformVector3f = GetFunction(iLibrary, "UB2D_SetShaderUniformVector3f")
		Global UB2D_SetShaderUniformVector4f.UB2D_Prototype_SetShaderUniformVector4f = GetFunction(iLibrary, "UB2D_SetShaderUniformVector4f")
		Global UB2D_SetSpriteDepth.UB2D_Prototype_SetSpriteDepth = GetFunction(iLibrary, "UB2D_SetSpriteDepth")
		Global UB2D_SetSpriteMaterial.UB2D_Prototype_SetSpriteMaterial = GetFunction(iLibrary, "UB2D_SetSpriteMaterial")
		Global UB2D_SetSpriteRotation.UB2D_Prototype_SetSpriteRotation = GetFunction(iLibrary, "UB2D_SetSpriteRotation")
		Global UB2D_SetTextureFilter.UB2D_Prototype_SetTextureFilter = GetFunction(iLibrary, "UB2D_SetTextureFilter")
		Global UB2D_SetVolumetricLightDecay.UB2D_Prototype_SetVolumetricLightDecay = GetFunction(iLibrary, "UB2D_SetVolumetricLightDecay")
		Global UB2D_SetVolumetricLightDensity.UB2D_Prototype_SetVolumetricLightDensity = GetFunction(iLibrary, "UB2D_SetVolumetricLightDensity")
		Global UB2D_SetVolumetricLightMinimalExposure.UB2D_Prototype_SetVolumetricLightMinimalExposure = GetFunction(iLibrary, "UB2D_SetVolumetricLightMinimalExposure")
		Global UB2D_SetVolumetricLightSamples.UB2D_Prototype_SetVolumetricLightSamples = GetFunction(iLibrary, "UB2D_SetVolumetricLightSamples")
		Global UB2D_SetVolumetricLightState.UB2D_Prototype_SetVolumetricLightState = GetFunction(iLibrary, "UB2D_SetVolumetricLightState")
		Global UB2D_SetVolumetricLightWeight.UB2D_Prototype_SetVolumetricLightWeight = GetFunction(iLibrary, "UB2D_SetVolumetricLightWeight")
		Global UB2D_SetWindowBlur.UB2D_Prototype_SetWindowBlur = GetFunction(iLibrary, "UB2D_SetWindowBlur")
		Global UB2D_SetWindowPosition.UB2D_Prototype_SetWindowPosition = GetFunction(iLibrary, "UB2D_SetWindowPosition")
		Global UB2D_SetWindowTitle.UB2D_Prototype_SetWindowTitle = GetFunction(iLibrary, "UB2D_SetWindowTitle")
		Global UB2D_Shader.UB2D_Prototype_Shader = GetFunction(iLibrary, "UB2D_Shader")
		Global UB2D_ShaderID.UB2D_Prototype_ShaderID = GetFunction(iLibrary, "UB2D_ShaderID")
		Global UB2D_ShaderUniformIndex.UB2D_Prototype_ShaderUniformIndex = GetFunction(iLibrary, "UB2D_ShaderUniformIndex")
		Global UB2D_ShowGadget.UB2D_Prototype_ShowGadget = GetFunction(iLibrary, "UB2D_ShowGadget")
		Global UB2D_ShowMouse.UB2D_Prototype_ShowMouse = GetFunction(iLibrary, "UB2D_ShowMouse")
		Global UB2D_ShowWindow.UB2D_Prototype_ShowWindow = GetFunction(iLibrary, "UB2D_ShowWindow")
		Global UB2D_SliderGadget.UB2D_Prototype_SliderGadget = GetFunction(iLibrary, "UB2D_SliderGadget")
		Global UB2D_SpinGadget.UB2D_Prototype_SpinGadget = GetFunction(iLibrary, "UB2D_SpinGadget")
		Global UB2D_SpriteDepth.UB2D_Prototype_SpriteDepth = GetFunction(iLibrary, "UB2D_SpriteDepth")
		Global UB2D_SpriteGadget.UB2D_Prototype_SpriteGadget = GetFunction(iLibrary, "UB2D_SpriteGadget")
		Global UB2D_SpriteHeight.UB2D_Prototype_SpriteHeight = GetFunction(iLibrary, "UB2D_SpriteHeight")
		Global UB2D_SpriteID.UB2D_Prototype_SpriteID = GetFunction(iLibrary, "UB2D_SpriteID")
		Global UB2D_SpriteMaterial.UB2D_Prototype_SpriteMaterial = GetFunction(iLibrary, "UB2D_SpriteMaterial")
		Global UB2D_SpriteOriginX.UB2D_Prototype_SpriteOriginX = GetFunction(iLibrary, "UB2D_SpriteOriginX")
		Global UB2D_SpriteOriginY.UB2D_Prototype_SpriteOriginY = GetFunction(iLibrary, "UB2D_SpriteOriginY")
		Global UB2D_SpriteRotation.UB2D_Prototype_SpriteRotation = GetFunction(iLibrary, "UB2D_SpriteRotation")
		Global UB2D_SpriteWidth.UB2D_Prototype_SpriteWidth = GetFunction(iLibrary, "UB2D_SpriteWidth")
		Global UB2D_StopArmatureAnimation.UB2D_Prototype_StopArmatureAnimation = GetFunction(iLibrary, "UB2D_StopArmatureAnimation")
		Global UB2D_StringGadget.UB2D_Prototype_StringGadget = GetFunction(iLibrary, "UB2D_StringGadget")
		Global UB2D_TextGadget.UB2D_Prototype_TextGadget = GetFunction(iLibrary, "UB2D_TextGadget")
		Global UB2D_TextHeight.UB2D_Prototype_TextHeight = GetFunction(iLibrary, "UB2D_TextHeight")
		Global UB2D_TextWidth.UB2D_Prototype_TextWidth = GetFunction(iLibrary, "UB2D_TextWidth")
		Global UB2D_Texture.UB2D_Prototype_Texture = GetFunction(iLibrary, "UB2D_Texture")
		Global UB2D_TextureFilter.UB2D_Prototype_TextureFilter = GetFunction(iLibrary, "UB2D_TextureFilter")
		Global UB2D_TextureHeight.UB2D_Prototype_TextureHeight = GetFunction(iLibrary, "UB2D_TextureHeight")
		Global UB2D_TextureID.UB2D_Prototype_TextureID = GetFunction(iLibrary, "UB2D_TextureID")
		Global UB2D_TextureWidth.UB2D_Prototype_TextureWidth = GetFunction(iLibrary, "UB2D_TextureWidth")
		Global UB2D_Time.UB2D_Prototype_Time = GetFunction(iLibrary, "UB2D_Time")
		Global UB2D_TimeFactor.UB2D_Prototype_TimeFactor = GetFunction(iLibrary, "UB2D_TimeFactor")
		Global UB2D_TransformSprite.UB2D_Prototype_TransformSprite = GetFunction(iLibrary, "UB2D_TransformSprite")
		Global UB2D_UnclipMouse.UB2D_Prototype_UnclipMouse = GetFunction(iLibrary, "UB2D_UnclipMouse")
		Global UB2D_UnlockMouse.UB2D_Prototype_UnlockMouse = GetFunction(iLibrary, "UB2D_UnlockMouse")
		Global UB2D_UpdateDrawingBufferMatrix.UB2D_Prototype_UpdateDrawingBufferMatrix = GetFunction(iLibrary, "UB2D_UpdateDrawingBufferMatrix")
		Global UB2D_UpdateMesh.UB2D_Prototype_UpdateMesh = GetFunction(iLibrary, "UB2D_UpdateMesh")
		Global UB2D_UpdateMeshInstanceMatrix.UB2D_Prototype_UpdateMeshInstanceMatrix = GetFunction(iLibrary, "UB2D_UpdateMeshInstanceMatrix")
		Global UB2D_UpdateObjectInstanceMatrix.UB2D_Prototype_UpdateObjectInstanceMatrix = GetFunction(iLibrary, "UB2D_UpdateObjectInstanceMatrix")
		Global UB2D_UpdateShaderBuffer.UB2D_Prototype_UpdateShaderBuffer = GetFunction(iLibrary, "UB2D_UpdateShaderBuffer")
		Global UB2D_ViewDebugger.UB2D_Prototype_ViewDebugger = GetFunction(iLibrary, "UB2D_ViewDebugger")
		Global UB2D_VolumetricLightDecay.UB2D_Prototype_VolumetricLightDecay = GetFunction(iLibrary, "UB2D_VolumetricLightDecay")
		Global UB2D_VolumetricLightDensity.UB2D_Prototype_VolumetricLightDensity = GetFunction(iLibrary, "UB2D_VolumetricLightDensity")
		Global UB2D_VolumetricLightMinimalExposure.UB2D_Prototype_VolumetricLightMinimalExposure = GetFunction(iLibrary, "UB2D_VolumetricLightMinimalExposure")
		Global UB2D_VolumetricLightSamples.UB2D_Prototype_VolumetricLightSamples = GetFunction(iLibrary, "UB2D_VolumetricLightSamples")
		Global UB2D_VolumetricLightState.UB2D_Prototype_VolumetricLightState = GetFunction(iLibrary, "UB2D_VolumetricLightState")
		Global UB2D_VolumetricLightWeight.UB2D_Prototype_VolumetricLightWeight = GetFunction(iLibrary, "UB2D_VolumetricLightWeight")
		Global UB2D_Warning.UB2D_Prototype_Warning = GetFunction(iLibrary, "UB2D_Warning")
		Global UB2D_WindowBlur.UB2D_Prototype_WindowBlur = GetFunction(iLibrary, "UB2D_WindowBlur")
		Global UB2D_WindowEvent.UB2D_Prototype_WindowEvent = GetFunction(iLibrary, "UB2D_WindowEvent")
		Global UB2D_WindowHeight.UB2D_Prototype_WindowHeight = GetFunction(iLibrary, "UB2D_WindowHeight")
		Global UB2D_WindowID.UB2D_Prototype_WindowID = GetFunction(iLibrary, "UB2D_WindowID")
		Global UB2D_WindowTitle_StringReturn.UB2D_Prototype_WindowTitle = GetFunction(iLibrary, "UB2D_WindowTitle")
		Global UB2D_WindowWidth.UB2D_Prototype_WindowWidth = GetFunction(iLibrary, "UB2D_WindowWidth")
		Global UB2D_WorldMatrix.UB2D_Prototype_WorldMatrix = GetFunction(iLibrary, "UB2D_WorldMatrix")
		Global UB2D_WriteTextureToMemory.UB2D_Prototype_WriteTextureToMemory = GetFunction(iLibrary, "UB2D_WriteTextureToMemory")
		Global UB2D_ZoomSprite.UB2D_Prototype_ZoomSprite = GetFunction(iLibrary, "UB2D_ZoomSprite")
		Global UB2D_fClamp.UB2D_Prototype_fClamp = GetFunction(iLibrary, "UB2D_fClamp")
		Global UB2D_fFloor.UB2D_Prototype_fFloor = GetFunction(iLibrary, "UB2D_fFloor")
		Global UB2D_fMax.UB2D_Prototype_fMax = GetFunction(iLibrary, "UB2D_fMax")
		Global UB2D_fMin.UB2D_Prototype_fMin = GetFunction(iLibrary, "UB2D_fMin")
		Global UB2D_fRandom.UB2D_Prototype_fRandom = GetFunction(iLibrary, "UB2D_fRandom")
		Global UB2D_fRangeRandom.UB2D_Prototype_fRangeRandom = GetFunction(iLibrary, "UB2D_fRangeRandom")
		Global UB2D_fSignPow.UB2D_Prototype_fSignPow = GetFunction(iLibrary, "UB2D_fSignPow")
		Global UB2D_iClamp.UB2D_Prototype_iClamp = GetFunction(iLibrary, "UB2D_iClamp")
		Global UB2D_iMax.UB2D_Prototype_iMax = GetFunction(iLibrary, "UB2D_iMax")
		Global UB2D_iMin.UB2D_Prototype_iMin = GetFunction(iLibrary, "UB2D_iMin")
		Global UB2D_m4fBias.UB2D_Prototype_m4fBias = GetFunction(iLibrary, "UB2D_m4fBias")
		Global UB2D_m4fFromDirection.UB2D_Prototype_m4fFromDirection = GetFunction(iLibrary, "UB2D_m4fFromDirection")
		Global UB2D_m4fFromPosition.UB2D_Prototype_m4fFromPosition = GetFunction(iLibrary, "UB2D_m4fFromPosition")
		Global UB2D_m4fFromPositionQuaternionScaling.UB2D_Prototype_m4fFromPositionQuaternionScaling = GetFunction(iLibrary, "UB2D_m4fFromPositionQuaternionScaling")
		Global UB2D_m4fFromRandomSolidAngle.UB2D_Prototype_m4fFromRandomSolidAngle = GetFunction(iLibrary, "UB2D_m4fFromRandomSolidAngle")
		Global UB2D_m4fFromRotation.UB2D_Prototype_m4fFromRotation = GetFunction(iLibrary, "UB2D_m4fFromRotation")
		Global UB2D_m4fFromScaling.UB2D_Prototype_m4fFromScaling = GetFunction(iLibrary, "UB2D_m4fFromScaling")
		Global UB2D_m4fFromTransformation.UB2D_Prototype_m4fFromTransformation = GetFunction(iLibrary, "UB2D_m4fFromTransformation")
		Global UB2D_m4fFromTransformationAlternative.UB2D_Prototype_m4fFromTransformationAlternative = GetFunction(iLibrary, "UB2D_m4fFromTransformationAlternative")
		Global UB2D_m4fFromVector4f.UB2D_Prototype_m4fFromVector4f = GetFunction(iLibrary, "UB2D_m4fFromVector4f")
		Global UB2D_m4fFrustum.UB2D_Prototype_m4fFrustum = GetFunction(iLibrary, "UB2D_m4fFrustum")
		Global UB2D_m4fFrustumOLD.UB2D_Prototype_m4fFrustumOLD = GetFunction(iLibrary, "UB2D_m4fFrustumOLD")
		Global UB2D_m4fIdentity.UB2D_Prototype_m4fIdentity = GetFunction(iLibrary, "UB2D_m4fIdentity")
		Global UB2D_m4fInverse.UB2D_Prototype_m4fInverse = GetFunction(iLibrary, "UB2D_m4fInverse")
		Global UB2D_m4fInversion.UB2D_Prototype_m4fInversion = GetFunction(iLibrary, "UB2D_m4fInversion")
		Global UB2D_m4fLookAt.UB2D_Prototype_m4fLookAt = GetFunction(iLibrary, "UB2D_m4fLookAt")
		Global UB2D_m4fMultiplication.UB2D_Prototype_m4fMultiplication = GetFunction(iLibrary, "UB2D_m4fMultiplication")
		Global UB2D_m4fMultiply.UB2D_Prototype_m4fMultiply = GetFunction(iLibrary, "UB2D_m4fMultiply")
		Global UB2D_m4fPerspective.UB2D_Prototype_m4fPerspective = GetFunction(iLibrary, "UB2D_m4fPerspective")
		Global UB2D_m4fToMatrix3f.UB2D_Prototype_m4fToMatrix3f = GetFunction(iLibrary, "UB2D_m4fToMatrix3f")
		Global UB2D_m4fToMatrix4x3f.UB2D_Prototype_m4fToMatrix4x3f = GetFunction(iLibrary, "UB2D_m4fToMatrix4x3f")
		Global UB2D_m4fToQuaternion.UB2D_Prototype_m4fToQuaternion = GetFunction(iLibrary, "UB2D_m4fToQuaternion")
		Global UB2D_m4fToScaling.UB2D_Prototype_m4fToScaling = GetFunction(iLibrary, "UB2D_m4fToScaling")
		Global UB2D_m4fToTransposedMatrix3f.UB2D_Prototype_m4fToTransposedMatrix3f = GetFunction(iLibrary, "UB2D_m4fToTransposedMatrix3f")
		Global UB2D_m4fToVector4f.UB2D_Prototype_m4fToVector4f = GetFunction(iLibrary, "UB2D_m4fToVector4f")
		Global UB2D_m4fTranspose.UB2D_Prototype_m4fTranspose = GetFunction(iLibrary, "UB2D_m4fTranspose")
		Global UB2D_m4fTransposition.UB2D_Prototype_m4fTransposition = GetFunction(iLibrary, "UB2D_m4fTransposition")
		Global UB2D_m4fUnsign.UB2D_Prototype_m4fUnsign = GetFunction(iLibrary, "UB2D_m4fUnsign")
		Global UB2D_qDivision.UB2D_Prototype_qDivision = GetFunction(iLibrary, "UB2D_qDivision")
		Global UB2D_qFromDirection.UB2D_Prototype_qFromDirection = GetFunction(iLibrary, "UB2D_qFromDirection")
		Global UB2D_qFromEuler.UB2D_Prototype_qFromEuler = GetFunction(iLibrary, "UB2D_qFromEuler")
		Global UB2D_qIdentity.UB2D_Prototype_qIdentity = GetFunction(iLibrary, "UB2D_qIdentity")
		Global UB2D_qInverse.UB2D_Prototype_qInverse = GetFunction(iLibrary, "UB2D_qInverse")
		Global UB2D_qInversion.UB2D_Prototype_qInversion = GetFunction(iLibrary, "UB2D_qInversion")
		Global UB2D_qMultiplication.UB2D_Prototype_qMultiplication = GetFunction(iLibrary, "UB2D_qMultiplication")
		Global UB2D_qMultiply.UB2D_Prototype_qMultiply = GetFunction(iLibrary, "UB2D_qMultiply")
		Global UB2D_qNormalization.UB2D_Prototype_qNormalization = GetFunction(iLibrary, "UB2D_qNormalization")
		Global UB2D_qNormalize.UB2D_Prototype_qNormalize = GetFunction(iLibrary, "UB2D_qNormalize")
		Global UB2D_qSet.UB2D_Prototype_qSet = GetFunction(iLibrary, "UB2D_qSet")
		Global UB2D_qStr_StringReturn.UB2D_Prototype_qStr = GetFunction(iLibrary, "UB2D_qStr")
		Global UB2D_qToEuler.UB2D_Prototype_qToEuler = GetFunction(iLibrary, "UB2D_qToEuler")
		Global UB2D_qToMatrix4f.UB2D_Prototype_qToMatrix4f = GetFunction(iLibrary, "UB2D_qToMatrix4f")
		Global UB2D_v2fAdd.UB2D_Prototype_v2fAdd = GetFunction(iLibrary, "UB2D_v2fAdd")
		Global UB2D_v2fAddition.UB2D_Prototype_v2fAddition = GetFunction(iLibrary, "UB2D_v2fAddition")
		Global UB2D_v2fCrossing.UB2D_Prototype_v2fCrossing = GetFunction(iLibrary, "UB2D_v2fCrossing")
		Global UB2D_v2fDistance.UB2D_Prototype_v2fDistance = GetFunction(iLibrary, "UB2D_v2fDistance")
		Global UB2D_v2fDot.UB2D_Prototype_v2fDot = GetFunction(iLibrary, "UB2D_v2fDot")
		Global UB2D_v2fLength.UB2D_Prototype_v2fLength = GetFunction(iLibrary, "UB2D_v2fLength")
		Global UB2D_v2fNormalize.UB2D_Prototype_v2fNormalize = GetFunction(iLibrary, "UB2D_v2fNormalize")
		Global UB2D_v2fScale.UB2D_Prototype_v2fScale = GetFunction(iLibrary, "UB2D_v2fScale")
		Global UB2D_v2fSet.UB2D_Prototype_v2fSet = GetFunction(iLibrary, "UB2D_v2fSet")
		Global UB2D_v2fSubtract.UB2D_Prototype_v2fSubtract = GetFunction(iLibrary, "UB2D_v2fSubtract")
		Global UB2D_v2fSubtraction.UB2D_Prototype_v2fSubtraction = GetFunction(iLibrary, "UB2D_v2fSubtraction")
		Global UB2D_v2iAdd.UB2D_Prototype_v2iAdd = GetFunction(iLibrary, "UB2D_v2iAdd")
		Global UB2D_v2iAddition.UB2D_Prototype_v2iAddition = GetFunction(iLibrary, "UB2D_v2iAddition")
		Global UB2D_v2iCrossing.UB2D_Prototype_v2iCrossing = GetFunction(iLibrary, "UB2D_v2iCrossing")
		Global UB2D_v2iDistance.UB2D_Prototype_v2iDistance = GetFunction(iLibrary, "UB2D_v2iDistance")
		Global UB2D_v2iDot.UB2D_Prototype_v2iDot = GetFunction(iLibrary, "UB2D_v2iDot")
		Global UB2D_v2iLength.UB2D_Prototype_v2iLength = GetFunction(iLibrary, "UB2D_v2iLength")
		Global UB2D_v2iNormalize.UB2D_Prototype_v2iNormalize = GetFunction(iLibrary, "UB2D_v2iNormalize")
		Global UB2D_v2iScale.UB2D_Prototype_v2iScale = GetFunction(iLibrary, "UB2D_v2iScale")
		Global UB2D_v2iSet.UB2D_Prototype_v2iSet = GetFunction(iLibrary, "UB2D_v2iSet")
		Global UB2D_v2iSubtract.UB2D_Prototype_v2iSubtract = GetFunction(iLibrary, "UB2D_v2iSubtract")
		Global UB2D_v2iSubtraction.UB2D_Prototype_v2iSubtraction = GetFunction(iLibrary, "UB2D_v2iSubtraction")
		Global UB2D_v3fAdd.UB2D_Prototype_v3fAdd = GetFunction(iLibrary, "UB2D_v3fAdd")
		Global UB2D_v3fAddition.UB2D_Prototype_v3fAddition = GetFunction(iLibrary, "UB2D_v3fAddition")
		Global UB2D_v3fCrossing.UB2D_Prototype_v3fCrossing = GetFunction(iLibrary, "UB2D_v3fCrossing")
		Global UB2D_v3fDistance.UB2D_Prototype_v3fDistance = GetFunction(iLibrary, "UB2D_v3fDistance")
		Global UB2D_v3fDot.UB2D_Prototype_v3fDot = GetFunction(iLibrary, "UB2D_v3fDot")
		Global UB2D_v3fLength.UB2D_Prototype_v3fLength = GetFunction(iLibrary, "UB2D_v3fLength")
		Global UB2D_v3fMultiplyByMatrix4f.UB2D_Prototype_v3fMultiplyByMatrix4f = GetFunction(iLibrary, "UB2D_v3fMultiplyByMatrix4f")
		Global UB2D_v3fNormalFormVertices.UB2D_Prototype_v3fNormalFormVertices = GetFunction(iLibrary, "UB2D_v3fNormalFormVertices")
		Global UB2D_v3fNormalize.UB2D_Prototype_v3fNormalize = GetFunction(iLibrary, "UB2D_v3fNormalize")
		Global UB2D_v3fScale.UB2D_Prototype_v3fScale = GetFunction(iLibrary, "UB2D_v3fScale")
		Global UB2D_v3fSet.UB2D_Prototype_v3fSet = GetFunction(iLibrary, "UB2D_v3fSet")
		Global UB2D_v3fSqrDistance.UB2D_Prototype_v3fSqrDistance = GetFunction(iLibrary, "UB2D_v3fSqrDistance")
		Global UB2D_v3fStr_StringReturn.UB2D_Prototype_v3fStr = GetFunction(iLibrary, "UB2D_v3fStr")
		Global UB2D_v3fSubtract.UB2D_Prototype_v3fSubtract = GetFunction(iLibrary, "UB2D_v3fSubtract")
		Global UB2D_v3fSubtraction.UB2D_Prototype_v3fSubtraction = GetFunction(iLibrary, "UB2D_v3fSubtraction")
		Global UB2D_v3fTangentFormVertices.UB2D_Prototype_v3fTangentFormVertices = GetFunction(iLibrary, "UB2D_v3fTangentFormVertices")
		Global UB2D_v4fAbs.UB2D_Prototype_v4fAbs = GetFunction(iLibrary, "UB2D_v4fAbs")
		Global UB2D_v4fAdd.UB2D_Prototype_v4fAdd = GetFunction(iLibrary, "UB2D_v4fAdd")
		Global UB2D_v4fAddition.UB2D_Prototype_v4fAddition = GetFunction(iLibrary, "UB2D_v4fAddition")
		Global UB2D_v4fAngle.UB2D_Prototype_v4fAngle = GetFunction(iLibrary, "UB2D_v4fAngle")
		Global UB2D_v4fChange.UB2D_Prototype_v4fChange = GetFunction(iLibrary, "UB2D_v4fChange")
		Global UB2D_v4fCopy.UB2D_Prototype_v4fCopy = GetFunction(iLibrary, "UB2D_v4fCopy")
		Global UB2D_v4fCross.UB2D_Prototype_v4fCross = GetFunction(iLibrary, "UB2D_v4fCross")
		Global UB2D_v4fCrossing.UB2D_Prototype_v4fCrossing = GetFunction(iLibrary, "UB2D_v4fCrossing")
		Global UB2D_v4fDistance.UB2D_Prototype_v4fDistance = GetFunction(iLibrary, "UB2D_v4fDistance")
		Global UB2D_v4fDivide.UB2D_Prototype_v4fDivide = GetFunction(iLibrary, "UB2D_v4fDivide")
		Global UB2D_v4fDivision.UB2D_Prototype_v4fDivision = GetFunction(iLibrary, "UB2D_v4fDivision")
		Global UB2D_v4fDot.UB2D_Prototype_v4fDot = GetFunction(iLibrary, "UB2D_v4fDot")
		Global UB2D_v4fEqual.UB2D_Prototype_v4fEqual = GetFunction(iLibrary, "UB2D_v4fEqual")
		Global UB2D_v4fInverse.UB2D_Prototype_v4fInverse = GetFunction(iLibrary, "UB2D_v4fInverse")
		Global UB2D_v4fInversion.UB2D_Prototype_v4fInversion = GetFunction(iLibrary, "UB2D_v4fInversion")
		Global UB2D_v4fLength.UB2D_Prototype_v4fLength = GetFunction(iLibrary, "UB2D_v4fLength")
		Global UB2D_v4fMultiplikation.UB2D_Prototype_v4fMultiplikation = GetFunction(iLibrary, "UB2D_v4fMultiplikation")
		Global UB2D_v4fMultiplikationByMatrix4f.UB2D_Prototype_v4fMultiplikationByMatrix4f = GetFunction(iLibrary, "UB2D_v4fMultiplikationByMatrix4f")
		Global UB2D_v4fMultiply.UB2D_Prototype_v4fMultiply = GetFunction(iLibrary, "UB2D_v4fMultiply")
		Global UB2D_v4fMultiplyByMatrix4f.UB2D_Prototype_v4fMultiplyByMatrix4f = GetFunction(iLibrary, "UB2D_v4fMultiplyByMatrix4f")
		Global UB2D_v4fNormalization.UB2D_Prototype_v4fNormalization = GetFunction(iLibrary, "UB2D_v4fNormalization")
		Global UB2D_v4fNormalize.UB2D_Prototype_v4fNormalize = GetFunction(iLibrary, "UB2D_v4fNormalize")
		Global UB2D_v4fPeek.UB2D_Prototype_v4fPeek = GetFunction(iLibrary, "UB2D_v4fPeek")
		Global UB2D_v4fPop.UB2D_Prototype_v4fPop = GetFunction(iLibrary, "UB2D_v4fPop")
		Global UB2D_v4fPush.UB2D_Prototype_v4fPush = GetFunction(iLibrary, "UB2D_v4fPush")
		Global UB2D_v4fPushCopy.UB2D_Prototype_v4fPushCopy = GetFunction(iLibrary, "UB2D_v4fPushCopy")
		Global UB2D_v4fScale.UB2D_Prototype_v4fScale = GetFunction(iLibrary, "UB2D_v4fScale")
		Global UB2D_v4fScaling.UB2D_Prototype_v4fScaling = GetFunction(iLibrary, "UB2D_v4fScaling")
		Global UB2D_v4fSet.UB2D_Prototype_v4fSet = GetFunction(iLibrary, "UB2D_v4fSet")
		Global UB2D_v4fStr_StringReturn.UB2D_Prototype_v4fStr = GetFunction(iLibrary, "UB2D_v4fStr")
		Global UB2D_v4fSubtract.UB2D_Prototype_v4fSubtract = GetFunction(iLibrary, "UB2D_v4fSubtract")
		Global UB2D_v4fSubtraction.UB2D_Prototype_v4fSubtraction = GetFunction(iLibrary, "UB2D_v4fSubtraction")
		Global UB2D_v4fTangential.UB2D_Prototype_v4fTangential = GetFunction(iLibrary, "UB2D_v4fTangential")
		Global UB2D_v4fToMatrix4f.UB2D_Prototype_v4fToMatrix4f = GetFunction(iLibrary, "UB2D_v4fToMatrix4f")
		Global UB2D_v4fToQuaternion.UB2D_Prototype_v4fToQuaternion = GetFunction(iLibrary, "UB2D_v4fToQuaternion")
		
		ProcedureReturn #True
		
	EndIf
	
EndProcedure

Procedure.s UB2D_GamepadName(iGamepad.i)
	ProcedureReturn PeekS(UB2D_GamepadName_StringReturn(iGamepad.i))
EndProcedure
Procedure.s UB2D_GetGadgetText( iGadget.i )
	ProcedureReturn PeekS(UB2D_GetGadgetText_StringReturn( iGadget.i ))
EndProcedure
Procedure.s UB2D_GetTextureName( iTexture.i )
	ProcedureReturn PeekS(UB2D_GetTextureName_StringReturn( iTexture.i ))
EndProcedure
Procedure.s UB2D_KeyboardInput()
	ProcedureReturn PeekS(UB2D_KeyboardInput_StringReturn())
EndProcedure
Procedure.s UB2D_MaterialName( iMaterial.i )
	ProcedureReturn PeekS(UB2D_MaterialName_StringReturn( iMaterial.i ))
EndProcedure
Procedure.s UB2D_MeshInstanceName( iMeshInstance.i )
	ProcedureReturn PeekS(UB2D_MeshInstanceName_StringReturn( iMeshInstance.i ))
EndProcedure
Procedure.s UB2D_MeshName( iMesh.i )
	ProcedureReturn PeekS(UB2D_MeshName_StringReturn( iMesh.i ))
EndProcedure
Procedure.s UB2D_ObjectInstanceName( iObjectInstance.i )
	ProcedureReturn PeekS(UB2D_ObjectInstanceName_StringReturn( iObjectInstance.i ))
EndProcedure
Procedure.s UB2D_WindowTitle()
	ProcedureReturn PeekS(UB2D_WindowTitle_StringReturn())
EndProcedure
Procedure.s UB2D_qStr( *qSource.UB2D_QUATERNION, sSeparator.s=", ", iDecimalDigits.i = 3 )
	ProcedureReturn PeekS(UB2D_qStr_StringReturn( *qSource.UB2D_QUATERNION, sSeparator.s))
EndProcedure
Procedure.s UB2D_v3fStr( *v3fTarget.UB2D_VECTOR4f, sSeparator.s=", " )
	ProcedureReturn PeekS(UB2D_v3fStr_StringReturn( *v3fTarget.UB2D_VECTOR4f, sSeparator.s))
EndProcedure
Procedure.s UB2D_v4fStr( *v4fTarget.UB2D_VECTOR4f, sSeparator.s = ", ", iDecimalDigits.i = 3 )
	ProcedureReturn PeekS(UB2D_v4fStr_StringReturn( *v4fTarget.UB2D_VECTOR4f, sSeparator.s ))
EndProcedure

;</Library Procedures>

; IDE Options = PureBasic 5.62 (Windows - x64)
; CursorPosition = 4
; Folding = ---------------------------
; EnableXP
; EnableCompileCount = 0
; EnableBuildCount = 0